"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.AddressPublicServiceClient = exports.AddressPublicServiceService = exports.AddressDataResponse = exports.AddressDataByKeyRequest = exports.AddressDataRequest = exports.protobufPackage = void 0;
const long_1 = __importDefault(require("long"));
const grpc_js_1 = require("@grpc/grpc-js");
const _m0 = __importStar(require("protobufjs/minimal"));
const data_entry_1 = require("../data_entry");
const empty_1 = require("../google/protobuf/empty");
const address_1 = require("../entity/address");
const wrappers_1 = require("../google/protobuf/wrappers");
exports.protobufPackage = "wavesenterprise.grpc";
function createBaseAddressDataRequest() {
    return { address: "", limit: undefined, offset: undefined };
}
exports.AddressDataRequest = {
    encode(message, writer = _m0.Writer.create()) {
        if (message.address !== undefined && message.address !== "") {
            writer.uint32(10).string(message.address);
        }
        if (message.limit !== undefined) {
            wrappers_1.Int32Value.encode({ value: message.limit }, writer.uint32(18).fork()).ldelim();
        }
        if (message.offset !== undefined) {
            wrappers_1.Int32Value.encode({ value: message.offset }, writer.uint32(26).fork()).ldelim();
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseAddressDataRequest();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.address = reader.string();
                    break;
                case 2:
                    message.limit = wrappers_1.Int32Value.decode(reader, reader.uint32()).value;
                    break;
                case 3:
                    message.offset = wrappers_1.Int32Value.decode(reader, reader.uint32()).value;
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        return {
            address: isSet(object.address) ? String(object.address) : "",
            limit: isSet(object.limit) ? Number(object.limit) : undefined,
            offset: isSet(object.offset) ? Number(object.offset) : undefined,
        };
    },
    toJSON(message) {
        const obj = {};
        message.address !== undefined && (obj.address = message.address);
        message.limit !== undefined && (obj.limit = message.limit);
        message.offset !== undefined && (obj.offset = message.offset);
        return obj;
    },
    fromPartial(object) {
        var _a, _b, _c;
        const message = createBaseAddressDataRequest();
        message.address = (_a = object.address) !== null && _a !== void 0 ? _a : "";
        message.limit = (_b = object.limit) !== null && _b !== void 0 ? _b : undefined;
        message.offset = (_c = object.offset) !== null && _c !== void 0 ? _c : undefined;
        return message;
    },
};
function createBaseAddressDataByKeyRequest() {
    return { address: "", key: undefined };
}
exports.AddressDataByKeyRequest = {
    encode(message, writer = _m0.Writer.create()) {
        if (message.address !== undefined && message.address !== "") {
            writer.uint32(10).string(message.address);
        }
        if (message.key !== undefined) {
            wrappers_1.StringValue.encode({ value: message.key }, writer.uint32(18).fork()).ldelim();
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseAddressDataByKeyRequest();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.address = reader.string();
                    break;
                case 2:
                    message.key = wrappers_1.StringValue.decode(reader, reader.uint32()).value;
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        return {
            address: isSet(object.address) ? String(object.address) : "",
            key: isSet(object.key) ? String(object.key) : undefined,
        };
    },
    toJSON(message) {
        const obj = {};
        message.address !== undefined && (obj.address = message.address);
        message.key !== undefined && (obj.key = message.key);
        return obj;
    },
    fromPartial(object) {
        var _a, _b;
        const message = createBaseAddressDataByKeyRequest();
        message.address = (_a = object.address) !== null && _a !== void 0 ? _a : "";
        message.key = (_b = object.key) !== null && _b !== void 0 ? _b : undefined;
        return message;
    },
};
function createBaseAddressDataResponse() {
    return { entries: [] };
}
exports.AddressDataResponse = {
    encode(message, writer = _m0.Writer.create()) {
        if (message.entries !== undefined && message.entries.length !== 0) {
            for (const v of message.entries) {
                data_entry_1.DataEntry.encode(v, writer.uint32(10).fork()).ldelim();
            }
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseAddressDataResponse();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.entries.push(data_entry_1.DataEntry.decode(reader, reader.uint32()));
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        return {
            entries: Array.isArray(object === null || object === void 0 ? void 0 : object.entries)
                ? object.entries.map((e) => data_entry_1.DataEntry.fromJSON(e))
                : [],
        };
    },
    toJSON(message) {
        const obj = {};
        if (message.entries) {
            obj.entries = message.entries.map((e) => e ? data_entry_1.DataEntry.toJSON(e) : undefined);
        }
        else {
            obj.entries = [];
        }
        return obj;
    },
    fromPartial(object) {
        var _a;
        const message = createBaseAddressDataResponse();
        message.entries =
            ((_a = object.entries) === null || _a === void 0 ? void 0 : _a.map((e) => data_entry_1.DataEntry.fromPartial(e))) || [];
        return message;
    },
};
exports.AddressPublicServiceService = {
    getAddresses: {
        path: "/wavesenterprise.grpc.AddressPublicService/GetAddresses",
        requestStream: false,
        responseStream: false,
        requestSerialize: (value) => Buffer.from(empty_1.Empty.encode(value).finish()),
        requestDeserialize: (value) => empty_1.Empty.decode(value),
        responseSerialize: (value) => Buffer.from(address_1.AddressesResponse.encode(value).finish()),
        responseDeserialize: (value) => address_1.AddressesResponse.decode(value),
    },
    getAddressData: {
        path: "/wavesenterprise.grpc.AddressPublicService/GetAddressData",
        requestStream: false,
        responseStream: false,
        requestSerialize: (value) => Buffer.from(exports.AddressDataRequest.encode(value).finish()),
        requestDeserialize: (value) => exports.AddressDataRequest.decode(value),
        responseSerialize: (value) => Buffer.from(exports.AddressDataResponse.encode(value).finish()),
        responseDeserialize: (value) => exports.AddressDataResponse.decode(value),
    },
    getAddressDataByKey: {
        path: "/wavesenterprise.grpc.AddressPublicService/GetAddressDataByKey",
        requestStream: false,
        responseStream: false,
        requestSerialize: (value) => Buffer.from(exports.AddressDataByKeyRequest.encode(value).finish()),
        requestDeserialize: (value) => exports.AddressDataByKeyRequest.decode(value),
        responseSerialize: (value) => Buffer.from(exports.AddressDataResponse.encode(value).finish()),
        responseDeserialize: (value) => exports.AddressDataResponse.decode(value),
    },
};
exports.AddressPublicServiceClient = (0, grpc_js_1.makeGenericClientConstructor)(exports.AddressPublicServiceService, "wavesenterprise.grpc.AddressPublicService");
if (_m0.util.Long !== long_1.default) {
    _m0.util.Long = long_1.default;
    _m0.configure();
}
function isSet(value) {
    return value !== null && value !== undefined;
}
//# sourceMappingURL=address_public_service.js.map