"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.PermissionServiceClient = exports.PermissionServiceService = exports.RolesForAddressResponse = exports.AddressesPermissionsResponse = exports.AddressesPermissionsRequest = exports.RoleInfo = exports.PermissionsResponse = exports.PermissionsRequest = exports.protobufPackage = void 0;
const long_1 = __importDefault(require("long"));
const grpc_js_1 = require("@grpc/grpc-js");
const _m0 = __importStar(require("protobufjs/minimal"));
const wrappers_1 = require("../google/protobuf/wrappers");
exports.protobufPackage = "wavesenterprise";
function createBasePermissionsRequest() {
    return { address: "", timestamp: undefined };
}
exports.PermissionsRequest = {
    encode(message, writer = _m0.Writer.create()) {
        if (message.address !== undefined && message.address !== "") {
            writer.uint32(10).string(message.address);
        }
        if (message.timestamp !== undefined) {
            wrappers_1.Int64Value.encode({ value: message.timestamp }, writer.uint32(18).fork()).ldelim();
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBasePermissionsRequest();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.address = reader.string();
                    break;
                case 2:
                    message.timestamp = wrappers_1.Int64Value.decode(reader, reader.uint32()).value;
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        return {
            address: isSet(object.address) ? String(object.address) : "",
            timestamp: isSet(object.timestamp)
                ? long_1.default.fromValue(object.timestamp)
                : undefined,
        };
    },
    toJSON(message) {
        const obj = {};
        message.address !== undefined && (obj.address = message.address);
        message.timestamp !== undefined && (obj.timestamp = message.timestamp);
        return obj;
    },
    fromPartial(object) {
        var _a;
        const message = createBasePermissionsRequest();
        message.address = (_a = object.address) !== null && _a !== void 0 ? _a : "";
        message.timestamp =
            object.timestamp !== undefined && object.timestamp !== null
                ? long_1.default.fromValue(object.timestamp)
                : undefined;
        return message;
    },
};
function createBasePermissionsResponse() {
    return { roles: [], timestamp: long_1.default.ZERO };
}
exports.PermissionsResponse = {
    encode(message, writer = _m0.Writer.create()) {
        if (message.roles !== undefined && message.roles.length !== 0) {
            for (const v of message.roles) {
                exports.RoleInfo.encode(v, writer.uint32(10).fork()).ldelim();
            }
        }
        if (message.timestamp !== undefined && !message.timestamp.isZero()) {
            writer.uint32(16).int64(message.timestamp);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBasePermissionsResponse();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.roles.push(exports.RoleInfo.decode(reader, reader.uint32()));
                    break;
                case 2:
                    message.timestamp = reader.int64();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        return {
            roles: Array.isArray(object === null || object === void 0 ? void 0 : object.roles)
                ? object.roles.map((e) => exports.RoleInfo.fromJSON(e))
                : [],
            timestamp: isSet(object.timestamp)
                ? long_1.default.fromString(object.timestamp)
                : long_1.default.ZERO,
        };
    },
    toJSON(message) {
        const obj = {};
        if (message.roles) {
            obj.roles = message.roles.map((e) => e ? exports.RoleInfo.toJSON(e) : undefined);
        }
        else {
            obj.roles = [];
        }
        message.timestamp !== undefined &&
            (obj.timestamp = (message.timestamp || long_1.default.ZERO).toString());
        return obj;
    },
    fromPartial(object) {
        var _a;
        const message = createBasePermissionsResponse();
        message.roles = ((_a = object.roles) === null || _a === void 0 ? void 0 : _a.map((e) => exports.RoleInfo.fromPartial(e))) || [];
        message.timestamp =
            object.timestamp !== undefined && object.timestamp !== null
                ? long_1.default.fromValue(object.timestamp)
                : long_1.default.ZERO;
        return message;
    },
};
function createBaseRoleInfo() {
    return { role: "", dueTimestamp: undefined };
}
exports.RoleInfo = {
    encode(message, writer = _m0.Writer.create()) {
        if (message.role !== undefined && message.role !== "") {
            writer.uint32(10).string(message.role);
        }
        if (message.dueTimestamp !== undefined) {
            wrappers_1.Int64Value.encode({ value: message.dueTimestamp }, writer.uint32(18).fork()).ldelim();
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseRoleInfo();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.role = reader.string();
                    break;
                case 2:
                    message.dueTimestamp = wrappers_1.Int64Value.decode(reader, reader.uint32()).value;
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        return {
            role: isSet(object.role) ? String(object.role) : "",
            dueTimestamp: isSet(object.dueTimestamp)
                ? long_1.default.fromValue(object.dueTimestamp)
                : undefined,
        };
    },
    toJSON(message) {
        const obj = {};
        message.role !== undefined && (obj.role = message.role);
        message.dueTimestamp !== undefined &&
            (obj.dueTimestamp = message.dueTimestamp);
        return obj;
    },
    fromPartial(object) {
        var _a;
        const message = createBaseRoleInfo();
        message.role = (_a = object.role) !== null && _a !== void 0 ? _a : "";
        message.dueTimestamp =
            object.dueTimestamp !== undefined && object.dueTimestamp !== null
                ? long_1.default.fromValue(object.dueTimestamp)
                : undefined;
        return message;
    },
};
function createBaseAddressesPermissionsRequest() {
    return { addresses: [], timestamp: long_1.default.ZERO };
}
exports.AddressesPermissionsRequest = {
    encode(message, writer = _m0.Writer.create()) {
        if (message.addresses !== undefined && message.addresses.length !== 0) {
            for (const v of message.addresses) {
                writer.uint32(10).string(v);
            }
        }
        if (message.timestamp !== undefined && !message.timestamp.isZero()) {
            writer.uint32(16).int64(message.timestamp);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseAddressesPermissionsRequest();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.addresses.push(reader.string());
                    break;
                case 2:
                    message.timestamp = reader.int64();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        return {
            addresses: Array.isArray(object === null || object === void 0 ? void 0 : object.addresses)
                ? object.addresses.map((e) => String(e))
                : [],
            timestamp: isSet(object.timestamp)
                ? long_1.default.fromString(object.timestamp)
                : long_1.default.ZERO,
        };
    },
    toJSON(message) {
        const obj = {};
        if (message.addresses) {
            obj.addresses = message.addresses.map((e) => e);
        }
        else {
            obj.addresses = [];
        }
        message.timestamp !== undefined &&
            (obj.timestamp = (message.timestamp || long_1.default.ZERO).toString());
        return obj;
    },
    fromPartial(object) {
        var _a;
        const message = createBaseAddressesPermissionsRequest();
        message.addresses = ((_a = object.addresses) === null || _a === void 0 ? void 0 : _a.map((e) => e)) || [];
        message.timestamp =
            object.timestamp !== undefined && object.timestamp !== null
                ? long_1.default.fromValue(object.timestamp)
                : long_1.default.ZERO;
        return message;
    },
};
function createBaseAddressesPermissionsResponse() {
    return { addressToRoles: [], timestamp: long_1.default.ZERO };
}
exports.AddressesPermissionsResponse = {
    encode(message, writer = _m0.Writer.create()) {
        if (message.addressToRoles !== undefined &&
            message.addressToRoles.length !== 0) {
            for (const v of message.addressToRoles) {
                exports.RolesForAddressResponse.encode(v, writer.uint32(10).fork()).ldelim();
            }
        }
        if (message.timestamp !== undefined && !message.timestamp.isZero()) {
            writer.uint32(16).int64(message.timestamp);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseAddressesPermissionsResponse();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.addressToRoles.push(exports.RolesForAddressResponse.decode(reader, reader.uint32()));
                    break;
                case 2:
                    message.timestamp = reader.int64();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        return {
            addressToRoles: Array.isArray(object === null || object === void 0 ? void 0 : object.addressToRoles)
                ? object.addressToRoles.map((e) => exports.RolesForAddressResponse.fromJSON(e))
                : [],
            timestamp: isSet(object.timestamp)
                ? long_1.default.fromString(object.timestamp)
                : long_1.default.ZERO,
        };
    },
    toJSON(message) {
        const obj = {};
        if (message.addressToRoles) {
            obj.addressToRoles = message.addressToRoles.map((e) => e ? exports.RolesForAddressResponse.toJSON(e) : undefined);
        }
        else {
            obj.addressToRoles = [];
        }
        message.timestamp !== undefined &&
            (obj.timestamp = (message.timestamp || long_1.default.ZERO).toString());
        return obj;
    },
    fromPartial(object) {
        var _a;
        const message = createBaseAddressesPermissionsResponse();
        message.addressToRoles =
            ((_a = object.addressToRoles) === null || _a === void 0 ? void 0 : _a.map((e) => exports.RolesForAddressResponse.fromPartial(e))) || [];
        message.timestamp =
            object.timestamp !== undefined && object.timestamp !== null
                ? long_1.default.fromValue(object.timestamp)
                : long_1.default.ZERO;
        return message;
    },
};
function createBaseRolesForAddressResponse() {
    return { address: "", roles: [] };
}
exports.RolesForAddressResponse = {
    encode(message, writer = _m0.Writer.create()) {
        if (message.address !== undefined && message.address !== "") {
            writer.uint32(10).string(message.address);
        }
        if (message.roles !== undefined && message.roles.length !== 0) {
            for (const v of message.roles) {
                exports.RoleInfo.encode(v, writer.uint32(18).fork()).ldelim();
            }
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseRolesForAddressResponse();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.address = reader.string();
                    break;
                case 2:
                    message.roles.push(exports.RoleInfo.decode(reader, reader.uint32()));
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        return {
            address: isSet(object.address) ? String(object.address) : "",
            roles: Array.isArray(object === null || object === void 0 ? void 0 : object.roles)
                ? object.roles.map((e) => exports.RoleInfo.fromJSON(e))
                : [],
        };
    },
    toJSON(message) {
        const obj = {};
        message.address !== undefined && (obj.address = message.address);
        if (message.roles) {
            obj.roles = message.roles.map((e) => e ? exports.RoleInfo.toJSON(e) : undefined);
        }
        else {
            obj.roles = [];
        }
        return obj;
    },
    fromPartial(object) {
        var _a, _b;
        const message = createBaseRolesForAddressResponse();
        message.address = (_a = object.address) !== null && _a !== void 0 ? _a : "";
        message.roles = ((_b = object.roles) === null || _b === void 0 ? void 0 : _b.map((e) => exports.RoleInfo.fromPartial(e))) || [];
        return message;
    },
};
exports.PermissionServiceService = {
    getPermissions: {
        path: "/wavesenterprise.PermissionService/GetPermissions",
        requestStream: false,
        responseStream: false,
        requestSerialize: (value) => Buffer.from(exports.PermissionsRequest.encode(value).finish()),
        requestDeserialize: (value) => exports.PermissionsRequest.decode(value),
        responseSerialize: (value) => Buffer.from(exports.PermissionsResponse.encode(value).finish()),
        responseDeserialize: (value) => exports.PermissionsResponse.decode(value),
    },
    getPermissionsForAddresses: {
        path: "/wavesenterprise.PermissionService/GetPermissionsForAddresses",
        requestStream: false,
        responseStream: false,
        requestSerialize: (value) => Buffer.from(exports.AddressesPermissionsRequest.encode(value).finish()),
        requestDeserialize: (value) => exports.AddressesPermissionsRequest.decode(value),
        responseSerialize: (value) => Buffer.from(exports.AddressesPermissionsResponse.encode(value).finish()),
        responseDeserialize: (value) => exports.AddressesPermissionsResponse.decode(value),
    },
};
exports.PermissionServiceClient = (0, grpc_js_1.makeGenericClientConstructor)(exports.PermissionServiceService, "wavesenterprise.PermissionService");
if (_m0.util.Long !== long_1.default) {
    _m0.util.Long = long_1.default;
    _m0.configure();
}
function isSet(value) {
    return value !== null && value !== undefined;
}
//# sourceMappingURL=contract_permission_service.js.map