"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ContractApiVersion = exports.protobufPackage = void 0;
const long_1 = __importDefault(require("long"));
const _m0 = __importStar(require("protobufjs/minimal"));
exports.protobufPackage = "wavesenterprise";
function createBaseContractApiVersion() {
    return { majorVersion: 0, minorVersion: 0 };
}
exports.ContractApiVersion = {
    encode(message, writer = _m0.Writer.create()) {
        if (message.majorVersion !== undefined && message.majorVersion !== 0) {
            writer.uint32(8).int32(message.majorVersion);
        }
        if (message.minorVersion !== undefined && message.minorVersion !== 0) {
            writer.uint32(16).int32(message.minorVersion);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseContractApiVersion();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.majorVersion = reader.int32();
                    break;
                case 2:
                    message.minorVersion = reader.int32();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        return {
            majorVersion: isSet(object.majorVersion)
                ? Number(object.majorVersion)
                : 0,
            minorVersion: isSet(object.minorVersion)
                ? Number(object.minorVersion)
                : 0,
        };
    },
    toJSON(message) {
        const obj = {};
        message.majorVersion !== undefined &&
            (obj.majorVersion = Math.round(message.majorVersion));
        message.minorVersion !== undefined &&
            (obj.minorVersion = Math.round(message.minorVersion));
        return obj;
    },
    fromPartial(object) {
        var _a, _b;
        const message = createBaseContractApiVersion();
        message.majorVersion = (_a = object.majorVersion) !== null && _a !== void 0 ? _a : 0;
        message.minorVersion = (_b = object.minorVersion) !== null && _b !== void 0 ? _b : 0;
        return message;
    },
};
if (_m0.util.Long !== long_1.default) {
    _m0.util.Long = long_1.default;
    _m0.configure();
}
function isSet(value) {
    return value !== null && value !== undefined;
}
//# sourceMappingURL=contract_api_version.js.map