import Long from "long";
import * as _m0 from "protobufjs/minimal";
import { ContractIssue } from "./contract_asset_operation/contract_issue";
import { ContractReissue } from "./contract_asset_operation/contract_reissue";
import { ContractBurn } from "./contract_asset_operation/contract_burn";
import { ContractTransferOut } from "./contract_asset_operation/contract_transfer_out";
export declare const protobufPackage = "wavesenterprise";
export interface ContractAssetOperation {
    contractIssue?: ContractIssue | undefined;
    contractReissue?: ContractReissue | undefined;
    contractBurn?: ContractBurn | undefined;
    contractTransferOut?: ContractTransferOut | undefined;
}
export declare const ContractAssetOperation: {
    encode(message: ContractAssetOperation, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): ContractAssetOperation;
    fromJSON(object: any): ContractAssetOperation;
    toJSON(message: ContractAssetOperation): unknown;
    fromPartial(object: DeepPartial<ContractAssetOperation>): ContractAssetOperation;
};
declare type Builtin = Date | Function | Uint8Array | string | number | boolean | undefined;
export declare type DeepPartial<T> = T extends Builtin ? T : T extends Long ? string | number | Long : T extends Array<infer U> ? Array<DeepPartial<U>> : T extends ReadonlyArray<infer U> ? ReadonlyArray<DeepPartial<U>> : T extends {} ? {
    [K in keyof T]?: DeepPartial<T[K]>;
} : Partial<T>;
export {};
