"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ContractAssetOperation = exports.protobufPackage = void 0;
const long_1 = __importDefault(require("long"));
const _m0 = __importStar(require("protobufjs/minimal"));
const contract_issue_1 = require("./contract_asset_operation/contract_issue");
const contract_reissue_1 = require("./contract_asset_operation/contract_reissue");
const contract_burn_1 = require("./contract_asset_operation/contract_burn");
const contract_transfer_out_1 = require("./contract_asset_operation/contract_transfer_out");
exports.protobufPackage = "wavesenterprise";
function createBaseContractAssetOperation() {
    return {
        contractIssue: undefined,
        contractReissue: undefined,
        contractBurn: undefined,
        contractTransferOut: undefined,
    };
}
exports.ContractAssetOperation = {
    encode(message, writer = _m0.Writer.create()) {
        if (message.contractIssue !== undefined) {
            contract_issue_1.ContractIssue.encode(message.contractIssue, writer.uint32(10).fork()).ldelim();
        }
        if (message.contractReissue !== undefined) {
            contract_reissue_1.ContractReissue.encode(message.contractReissue, writer.uint32(18).fork()).ldelim();
        }
        if (message.contractBurn !== undefined) {
            contract_burn_1.ContractBurn.encode(message.contractBurn, writer.uint32(26).fork()).ldelim();
        }
        if (message.contractTransferOut !== undefined) {
            contract_transfer_out_1.ContractTransferOut.encode(message.contractTransferOut, writer.uint32(34).fork()).ldelim();
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseContractAssetOperation();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.contractIssue = contract_issue_1.ContractIssue.decode(reader, reader.uint32());
                    break;
                case 2:
                    message.contractReissue = contract_reissue_1.ContractReissue.decode(reader, reader.uint32());
                    break;
                case 3:
                    message.contractBurn = contract_burn_1.ContractBurn.decode(reader, reader.uint32());
                    break;
                case 4:
                    message.contractTransferOut = contract_transfer_out_1.ContractTransferOut.decode(reader, reader.uint32());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        return {
            contractIssue: isSet(object.contractIssue)
                ? contract_issue_1.ContractIssue.fromJSON(object.contractIssue)
                : undefined,
            contractReissue: isSet(object.contractReissue)
                ? contract_reissue_1.ContractReissue.fromJSON(object.contractReissue)
                : undefined,
            contractBurn: isSet(object.contractBurn)
                ? contract_burn_1.ContractBurn.fromJSON(object.contractBurn)
                : undefined,
            contractTransferOut: isSet(object.contractTransferOut)
                ? contract_transfer_out_1.ContractTransferOut.fromJSON(object.contractTransferOut)
                : undefined,
        };
    },
    toJSON(message) {
        const obj = {};
        message.contractIssue !== undefined &&
            (obj.contractIssue = message.contractIssue
                ? contract_issue_1.ContractIssue.toJSON(message.contractIssue)
                : undefined);
        message.contractReissue !== undefined &&
            (obj.contractReissue = message.contractReissue
                ? contract_reissue_1.ContractReissue.toJSON(message.contractReissue)
                : undefined);
        message.contractBurn !== undefined &&
            (obj.contractBurn = message.contractBurn
                ? contract_burn_1.ContractBurn.toJSON(message.contractBurn)
                : undefined);
        message.contractTransferOut !== undefined &&
            (obj.contractTransferOut = message.contractTransferOut
                ? contract_transfer_out_1.ContractTransferOut.toJSON(message.contractTransferOut)
                : undefined);
        return obj;
    },
    fromPartial(object) {
        const message = createBaseContractAssetOperation();
        message.contractIssue =
            object.contractIssue !== undefined && object.contractIssue !== null
                ? contract_issue_1.ContractIssue.fromPartial(object.contractIssue)
                : undefined;
        message.contractReissue =
            object.contractReissue !== undefined && object.contractReissue !== null
                ? contract_reissue_1.ContractReissue.fromPartial(object.contractReissue)
                : undefined;
        message.contractBurn =
            object.contractBurn !== undefined && object.contractBurn !== null
                ? contract_burn_1.ContractBurn.fromPartial(object.contractBurn)
                : undefined;
        message.contractTransferOut =
            object.contractTransferOut !== undefined &&
                object.contractTransferOut !== null
                ? contract_transfer_out_1.ContractTransferOut.fromPartial(object.contractTransferOut)
                : undefined;
        return message;
    },
};
if (_m0.util.Long !== long_1.default) {
    _m0.util.Long = long_1.default;
    _m0.configure();
}
function isSet(value) {
    return value !== null && value !== undefined;
}
//# sourceMappingURL=contract_asset_operation.js.map