import Long from "long";
import * as _m0 from "protobufjs/minimal";
export declare const protobufPackage = "wavesenterprise";
export interface ContractIssue {
    assetId?: string;
    name?: string;
    description?: string;
    quantity?: Long;
    decimals?: number;
    isReissuable?: boolean;
    nonce?: number;
}
export declare const ContractIssue: {
    encode(message: ContractIssue, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): ContractIssue;
    fromJSON(object: any): ContractIssue;
    toJSON(message: ContractIssue): unknown;
    fromPartial(object: DeepPartial<ContractIssue>): ContractIssue;
};
declare type Builtin = Date | Function | Uint8Array | string | number | boolean | undefined;
export declare type DeepPartial<T> = T extends Builtin ? T : T extends Long ? string | number | Long : T extends Array<infer U> ? Array<DeepPartial<U>> : T extends ReadonlyArray<infer U> ? ReadonlyArray<DeepPartial<U>> : T extends {} ? {
    [K in keyof T]?: DeepPartial<T[K]>;
} : Partial<T>;
export {};
