"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ContractIssue = exports.protobufPackage = void 0;
const long_1 = __importDefault(require("long"));
const _m0 = __importStar(require("protobufjs/minimal"));
exports.protobufPackage = "wavesenterprise";
function createBaseContractIssue() {
    return {
        assetId: "",
        name: "",
        description: "",
        quantity: long_1.default.ZERO,
        decimals: 0,
        isReissuable: false,
        nonce: 0,
    };
}
exports.ContractIssue = {
    encode(message, writer = _m0.Writer.create()) {
        if (message.assetId !== undefined && message.assetId !== "") {
            writer.uint32(10).string(message.assetId);
        }
        if (message.name !== undefined && message.name !== "") {
            writer.uint32(18).string(message.name);
        }
        if (message.description !== undefined && message.description !== "") {
            writer.uint32(26).string(message.description);
        }
        if (message.quantity !== undefined && !message.quantity.isZero()) {
            writer.uint32(32).int64(message.quantity);
        }
        if (message.decimals !== undefined && message.decimals !== 0) {
            writer.uint32(40).int32(message.decimals);
        }
        if (message.isReissuable === true) {
            writer.uint32(48).bool(message.isReissuable);
        }
        if (message.nonce !== undefined && message.nonce !== 0) {
            writer.uint32(56).int32(message.nonce);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseContractIssue();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.assetId = reader.string();
                    break;
                case 2:
                    message.name = reader.string();
                    break;
                case 3:
                    message.description = reader.string();
                    break;
                case 4:
                    message.quantity = reader.int64();
                    break;
                case 5:
                    message.decimals = reader.int32();
                    break;
                case 6:
                    message.isReissuable = reader.bool();
                    break;
                case 7:
                    message.nonce = reader.int32();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        return {
            assetId: isSet(object.assetId) ? String(object.assetId) : "",
            name: isSet(object.name) ? String(object.name) : "",
            description: isSet(object.description) ? String(object.description) : "",
            quantity: isSet(object.quantity)
                ? long_1.default.fromString(object.quantity)
                : long_1.default.ZERO,
            decimals: isSet(object.decimals) ? Number(object.decimals) : 0,
            isReissuable: isSet(object.isReissuable)
                ? Boolean(object.isReissuable)
                : false,
            nonce: isSet(object.nonce) ? Number(object.nonce) : 0,
        };
    },
    toJSON(message) {
        const obj = {};
        message.assetId !== undefined && (obj.assetId = message.assetId);
        message.name !== undefined && (obj.name = message.name);
        message.description !== undefined &&
            (obj.description = message.description);
        message.quantity !== undefined &&
            (obj.quantity = (message.quantity || long_1.default.ZERO).toString());
        message.decimals !== undefined &&
            (obj.decimals = Math.round(message.decimals));
        message.isReissuable !== undefined &&
            (obj.isReissuable = message.isReissuable);
        message.nonce !== undefined && (obj.nonce = Math.round(message.nonce));
        return obj;
    },
    fromPartial(object) {
        var _a, _b, _c, _d, _e, _f;
        const message = createBaseContractIssue();
        message.assetId = (_a = object.assetId) !== null && _a !== void 0 ? _a : "";
        message.name = (_b = object.name) !== null && _b !== void 0 ? _b : "";
        message.description = (_c = object.description) !== null && _c !== void 0 ? _c : "";
        message.quantity =
            object.quantity !== undefined && object.quantity !== null
                ? long_1.default.fromValue(object.quantity)
                : long_1.default.ZERO;
        message.decimals = (_d = object.decimals) !== null && _d !== void 0 ? _d : 0;
        message.isReissuable = (_e = object.isReissuable) !== null && _e !== void 0 ? _e : false;
        message.nonce = (_f = object.nonce) !== null && _f !== void 0 ? _f : 0;
        return message;
    },
};
if (_m0.util.Long !== long_1.default) {
    _m0.util.Long = long_1.default;
    _m0.configure();
}
function isSet(value) {
    return value !== null && value !== undefined;
}
//# sourceMappingURL=contract_issue.js.map