"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ContractReissue = exports.protobufPackage = void 0;
const long_1 = __importDefault(require("long"));
const _m0 = __importStar(require("protobufjs/minimal"));
exports.protobufPackage = "wavesenterprise";
function createBaseContractReissue() {
    return { assetId: "", quantity: long_1.default.ZERO, isReissuable: false };
}
exports.ContractReissue = {
    encode(message, writer = _m0.Writer.create()) {
        if (message.assetId !== undefined && message.assetId !== "") {
            writer.uint32(10).string(message.assetId);
        }
        if (message.quantity !== undefined && !message.quantity.isZero()) {
            writer.uint32(16).int64(message.quantity);
        }
        if (message.isReissuable === true) {
            writer.uint32(24).bool(message.isReissuable);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseContractReissue();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.assetId = reader.string();
                    break;
                case 2:
                    message.quantity = reader.int64();
                    break;
                case 3:
                    message.isReissuable = reader.bool();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        return {
            assetId: isSet(object.assetId) ? String(object.assetId) : "",
            quantity: isSet(object.quantity)
                ? long_1.default.fromString(object.quantity)
                : long_1.default.ZERO,
            isReissuable: isSet(object.isReissuable)
                ? Boolean(object.isReissuable)
                : false,
        };
    },
    toJSON(message) {
        const obj = {};
        message.assetId !== undefined && (obj.assetId = message.assetId);
        message.quantity !== undefined &&
            (obj.quantity = (message.quantity || long_1.default.ZERO).toString());
        message.isReissuable !== undefined &&
            (obj.isReissuable = message.isReissuable);
        return obj;
    },
    fromPartial(object) {
        var _a, _b;
        const message = createBaseContractReissue();
        message.assetId = (_a = object.assetId) !== null && _a !== void 0 ? _a : "";
        message.quantity =
            object.quantity !== undefined && object.quantity !== null
                ? long_1.default.fromValue(object.quantity)
                : long_1.default.ZERO;
        message.isReissuable = (_b = object.isReissuable) !== null && _b !== void 0 ? _b : false;
        return message;
    },
};
if (_m0.util.Long !== long_1.default) {
    _m0.util.Long = long_1.default;
    _m0.configure();
}
function isSet(value) {
    return value !== null && value !== undefined;
}
//# sourceMappingURL=contract_reissue.js.map