import Long from "long";
import * as _m0 from "protobufjs/minimal";
import { CreateContractTransaction } from "./managed/create_contract_transaction";
import { CallContractTransaction } from "./managed/call_contract_transaction";
import { UpdateContractTransaction } from "./managed/update_contract_transaction";
export declare const protobufPackage = "wavesenterprise";
export interface ExecutableTransaction {
    version?: number;
    createContractTransaction?: CreateContractTransaction | undefined;
    callContractTransaction?: CallContractTransaction | undefined;
    updateContractTransaction?: UpdateContractTransaction | undefined;
}
export declare const ExecutableTransaction: {
    encode(message: ExecutableTransaction, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): ExecutableTransaction;
    fromJSON(object: any): ExecutableTransaction;
    toJSON(message: ExecutableTransaction): unknown;
    fromPartial(object: DeepPartial<ExecutableTransaction>): ExecutableTransaction;
};
declare type Builtin = Date | Function | Uint8Array | string | number | boolean | undefined;
export declare type DeepPartial<T> = T extends Builtin ? T : T extends Long ? string | number | Long : T extends Array<infer U> ? Array<DeepPartial<U>> : T extends ReadonlyArray<infer U> ? ReadonlyArray<DeepPartial<U>> : T extends {} ? {
    [K in keyof T]?: DeepPartial<T[K]>;
} : Partial<T>;
export {};
