import Long from "long";
import * as _m0 from "protobufjs/minimal";
import { Role } from "../role";
export declare const protobufPackage = "wavesenterprise";
export interface GenesisPermitTransaction {
    id?: Uint8Array;
    target?: Uint8Array;
    role?: Role;
    fee?: Long;
    timestamp?: Long;
    signature?: Uint8Array;
}
export declare const GenesisPermitTransaction: {
    encode(message: GenesisPermitTransaction, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): GenesisPermitTransaction;
    fromJSON(object: any): GenesisPermitTransaction;
    toJSON(message: GenesisPermitTransaction): unknown;
    fromPartial(object: DeepPartial<GenesisPermitTransaction>): GenesisPermitTransaction;
};
declare type Builtin = Date | Function | Uint8Array | string | number | boolean | undefined;
export declare type DeepPartial<T> = T extends Builtin ? T : T extends Long ? string | number | Long : T extends Array<infer U> ? Array<DeepPartial<U>> : T extends ReadonlyArray<infer U> ? ReadonlyArray<DeepPartial<U>> : T extends {} ? {
    [K in keyof T]?: DeepPartial<T[K]>;
} : Partial<T>;
export {};
