import Long from "long";
import * as _m0 from "protobufjs/minimal";
import { GenesisTransaction } from "../genesis/genesis_transaction";
import { GenesisPermitTransaction } from "../genesis/genesis_permit_transaction";
import { GenesisRegisterNodeTransaction } from "../genesis/genesis_register_node_transaction";
import { RegisterNodeTransaction } from "../managed/register_node_transaction";
import { CreateAliasTransaction } from "../managed/create_alias_transaction";
import { IssueTransaction } from "../managed/issue_transaction";
import { ReissueTransaction } from "../managed/reissue_transaction";
import { BurnTransaction } from "../managed/burn_transaction";
import { LeaseTransaction } from "../managed/lease_transaction";
import { LeaseCancelTransaction } from "../managed/lease_cancel_transaction";
import { SponsorFeeTransaction } from "../managed/sponsor_fee_transaction";
import { SetAssetScriptTransaction } from "../managed/set_asset_script_transaction";
import { DataTransaction } from "../managed/data_transaction";
import { TransferTransaction } from "../managed/transfer_transaction";
import { MassTransferTransaction } from "../managed/mass_transfer_transaction";
import { PermitTransaction } from "../managed/permit_transaction";
import { CreatePolicyTransaction } from "../managed/create_policy_transaction";
import { UpdatePolicyTransaction } from "../managed/update_policy_transaction";
import { PolicyDataHashTransaction } from "../managed/policy_data_hash_transaction";
import { CreateContractTransaction } from "../managed/create_contract_transaction";
import { CallContractTransaction } from "../managed/call_contract_transaction";
import { ExecutedContractTransaction } from "../managed/executed_contract_transaction";
import { DisableContractTransaction } from "../managed/disable_contract_transaction";
import { UpdateContractTransaction } from "../managed/update_contract_transaction";
import { SetScriptTransaction } from "../managed/set_script_transaction";
export declare const protobufPackage = "wavesenterprise";
export interface AtomicInnerTransaction {
    version?: number;
    genesisTransaction?: GenesisTransaction | undefined;
    genesisPermitTransaction?: GenesisPermitTransaction | undefined;
    genesisRegisterNodeTransaction?: GenesisRegisterNodeTransaction | undefined;
    registerNodeTransaction?: RegisterNodeTransaction | undefined;
    createAliasTransaction?: CreateAliasTransaction | undefined;
    issueTransaction?: IssueTransaction | undefined;
    reissueTransaction?: ReissueTransaction | undefined;
    burnTransaction?: BurnTransaction | undefined;
    leaseTransaction?: LeaseTransaction | undefined;
    leaseCancelTransaction?: LeaseCancelTransaction | undefined;
    sponsorFeeTransaction?: SponsorFeeTransaction | undefined;
    setAssetScriptTransaction?: SetAssetScriptTransaction | undefined;
    dataTransaction?: DataTransaction | undefined;
    transferTransaction?: TransferTransaction | undefined;
    massTransferTransaction?: MassTransferTransaction | undefined;
    permitTransaction?: PermitTransaction | undefined;
    createPolicyTransaction?: CreatePolicyTransaction | undefined;
    updatePolicyTransaction?: UpdatePolicyTransaction | undefined;
    policyDataHashTransaction?: PolicyDataHashTransaction | undefined;
    createContractTransaction?: CreateContractTransaction | undefined;
    callContractTransaction?: CallContractTransaction | undefined;
    executedContractTransaction?: ExecutedContractTransaction | undefined;
    disableContractTransaction?: DisableContractTransaction | undefined;
    updateContractTransaction?: UpdateContractTransaction | undefined;
    setScriptTransaction?: SetScriptTransaction | undefined;
}
export declare const AtomicInnerTransaction: {
    encode(message: AtomicInnerTransaction, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): AtomicInnerTransaction;
    fromJSON(object: any): AtomicInnerTransaction;
    toJSON(message: AtomicInnerTransaction): unknown;
    fromPartial(object: DeepPartial<AtomicInnerTransaction>): AtomicInnerTransaction;
};
declare type Builtin = Date | Function | Uint8Array | string | number | boolean | undefined;
export declare type DeepPartial<T> = T extends Builtin ? T : T extends Long ? string | number | Long : T extends Array<infer U> ? Array<DeepPartial<U>> : T extends ReadonlyArray<infer U> ? ReadonlyArray<DeepPartial<U>> : T extends {} ? {
    [K in keyof T]?: DeepPartial<T[K]>;
} : Partial<T>;
export {};
