"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.BurnTransaction = exports.protobufPackage = void 0;
const long_1 = __importDefault(require("long"));
const _m0 = __importStar(require("protobufjs/minimal"));
exports.protobufPackage = "wavesenterprise";
function createBaseBurnTransaction() {
    return {
        id: new Uint8Array(),
        chainId: 0,
        senderPublicKey: new Uint8Array(),
        assetId: new Uint8Array(),
        amount: long_1.default.ZERO,
        fee: long_1.default.ZERO,
        timestamp: long_1.default.ZERO,
        proofs: [],
        senderAddress: new Uint8Array(),
    };
}
exports.BurnTransaction = {
    encode(message, writer = _m0.Writer.create()) {
        if (message.id !== undefined && message.id.length !== 0) {
            writer.uint32(10).bytes(message.id);
        }
        if (message.chainId !== undefined && message.chainId !== 0) {
            writer.uint32(16).int32(message.chainId);
        }
        if (message.senderPublicKey !== undefined &&
            message.senderPublicKey.length !== 0) {
            writer.uint32(26).bytes(message.senderPublicKey);
        }
        if (message.assetId !== undefined && message.assetId.length !== 0) {
            writer.uint32(34).bytes(message.assetId);
        }
        if (message.amount !== undefined && !message.amount.isZero()) {
            writer.uint32(40).int64(message.amount);
        }
        if (message.fee !== undefined && !message.fee.isZero()) {
            writer.uint32(48).int64(message.fee);
        }
        if (message.timestamp !== undefined && !message.timestamp.isZero()) {
            writer.uint32(56).int64(message.timestamp);
        }
        if (message.proofs !== undefined && message.proofs.length !== 0) {
            for (const v of message.proofs) {
                writer.uint32(66).bytes(v);
            }
        }
        if (message.senderAddress !== undefined &&
            message.senderAddress.length !== 0) {
            writer.uint32(74).bytes(message.senderAddress);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseBurnTransaction();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.id = reader.bytes();
                    break;
                case 2:
                    message.chainId = reader.int32();
                    break;
                case 3:
                    message.senderPublicKey = reader.bytes();
                    break;
                case 4:
                    message.assetId = reader.bytes();
                    break;
                case 5:
                    message.amount = reader.int64();
                    break;
                case 6:
                    message.fee = reader.int64();
                    break;
                case 7:
                    message.timestamp = reader.int64();
                    break;
                case 8:
                    message.proofs.push(reader.bytes());
                    break;
                case 9:
                    message.senderAddress = reader.bytes();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        return {
            id: isSet(object.id) ? bytesFromBase64(object.id) : new Uint8Array(),
            chainId: isSet(object.chainId) ? Number(object.chainId) : 0,
            senderPublicKey: isSet(object.senderPublicKey)
                ? bytesFromBase64(object.senderPublicKey)
                : new Uint8Array(),
            assetId: isSet(object.assetId)
                ? bytesFromBase64(object.assetId)
                : new Uint8Array(),
            amount: isSet(object.amount) ? long_1.default.fromString(object.amount) : long_1.default.ZERO,
            fee: isSet(object.fee) ? long_1.default.fromString(object.fee) : long_1.default.ZERO,
            timestamp: isSet(object.timestamp)
                ? long_1.default.fromString(object.timestamp)
                : long_1.default.ZERO,
            proofs: Array.isArray(object === null || object === void 0 ? void 0 : object.proofs)
                ? object.proofs.map((e) => bytesFromBase64(e))
                : [],
            senderAddress: isSet(object.senderAddress)
                ? bytesFromBase64(object.senderAddress)
                : new Uint8Array(),
        };
    },
    toJSON(message) {
        const obj = {};
        message.id !== undefined &&
            (obj.id = base64FromBytes(message.id !== undefined ? message.id : new Uint8Array()));
        message.chainId !== undefined &&
            (obj.chainId = Math.round(message.chainId));
        message.senderPublicKey !== undefined &&
            (obj.senderPublicKey = base64FromBytes(message.senderPublicKey !== undefined
                ? message.senderPublicKey
                : new Uint8Array()));
        message.assetId !== undefined &&
            (obj.assetId = base64FromBytes(message.assetId !== undefined ? message.assetId : new Uint8Array()));
        message.amount !== undefined &&
            (obj.amount = (message.amount || long_1.default.ZERO).toString());
        message.fee !== undefined &&
            (obj.fee = (message.fee || long_1.default.ZERO).toString());
        message.timestamp !== undefined &&
            (obj.timestamp = (message.timestamp || long_1.default.ZERO).toString());
        if (message.proofs) {
            obj.proofs = message.proofs.map((e) => base64FromBytes(e !== undefined ? e : new Uint8Array()));
        }
        else {
            obj.proofs = [];
        }
        message.senderAddress !== undefined &&
            (obj.senderAddress = base64FromBytes(message.senderAddress !== undefined
                ? message.senderAddress
                : new Uint8Array()));
        return obj;
    },
    fromPartial(object) {
        var _a, _b, _c, _d, _e, _f;
        const message = createBaseBurnTransaction();
        message.id = (_a = object.id) !== null && _a !== void 0 ? _a : new Uint8Array();
        message.chainId = (_b = object.chainId) !== null && _b !== void 0 ? _b : 0;
        message.senderPublicKey = (_c = object.senderPublicKey) !== null && _c !== void 0 ? _c : new Uint8Array();
        message.assetId = (_d = object.assetId) !== null && _d !== void 0 ? _d : new Uint8Array();
        message.amount =
            object.amount !== undefined && object.amount !== null
                ? long_1.default.fromValue(object.amount)
                : long_1.default.ZERO;
        message.fee =
            object.fee !== undefined && object.fee !== null
                ? long_1.default.fromValue(object.fee)
                : long_1.default.ZERO;
        message.timestamp =
            object.timestamp !== undefined && object.timestamp !== null
                ? long_1.default.fromValue(object.timestamp)
                : long_1.default.ZERO;
        message.proofs = ((_e = object.proofs) === null || _e === void 0 ? void 0 : _e.map((e) => e)) || [];
        message.senderAddress = (_f = object.senderAddress) !== null && _f !== void 0 ? _f : new Uint8Array();
        return message;
    },
};
var globalThis = (() => {
    if (typeof globalThis !== "undefined")
        return globalThis;
    if (typeof self !== "undefined")
        return self;
    if (typeof window !== "undefined")
        return window;
    if (typeof global !== "undefined")
        return global;
    throw "Unable to locate global object";
})();
const atob = globalThis.atob ||
    ((b64) => globalThis.Buffer.from(b64, "base64").toString("binary"));
function bytesFromBase64(b64) {
    const bin = atob(b64);
    const arr = new Uint8Array(bin.length);
    for (let i = 0; i < bin.length; ++i) {
        arr[i] = bin.charCodeAt(i);
    }
    return arr;
}
const btoa = globalThis.btoa ||
    ((bin) => globalThis.Buffer.from(bin, "binary").toString("base64"));
function base64FromBytes(arr) {
    const bin = [];
    for (const byte of arr) {
        bin.push(String.fromCharCode(byte));
    }
    return btoa(bin.join(""));
}
if (_m0.util.Long !== long_1.default) {
    _m0.util.Long = long_1.default;
    _m0.configure();
}
function isSet(value) {
    return value !== null && value !== undefined;
}
//# sourceMappingURL=burn_transaction.js.map