import Long from "long";
import * as _m0 from "protobufjs/minimal";
import { AtomicBadge } from "../atomic_badge";
import { DataEntry } from "../data_entry";
import { ContractTransferIn } from "../contract_transfer_in";
export declare const protobufPackage = "wavesenterprise";
export interface CallContractTransaction {
    id?: Uint8Array;
    senderPublicKey?: Uint8Array;
    contractId?: Uint8Array;
    params?: DataEntry[];
    fee?: Long;
    timestamp?: Long;
    contractVersion?: number;
    feeAssetId?: Uint8Array;
    atomicBadge?: AtomicBadge;
    payments?: ContractTransferIn[];
    proofs?: Uint8Array[];
    senderAddress?: Uint8Array;
}
export declare const CallContractTransaction: {
    encode(message: CallContractTransaction, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): CallContractTransaction;
    fromJSON(object: any): CallContractTransaction;
    toJSON(message: CallContractTransaction): unknown;
    fromPartial(object: DeepPartial<CallContractTransaction>): CallContractTransaction;
};
declare type Builtin = Date | Function | Uint8Array | string | number | boolean | undefined;
export declare type DeepPartial<T> = T extends Builtin ? T : T extends Long ? string | number | Long : T extends Array<infer U> ? Array<DeepPartial<U>> : T extends ReadonlyArray<infer U> ? ReadonlyArray<DeepPartial<U>> : T extends {} ? {
    [K in keyof T]?: DeepPartial<T[K]>;
} : Partial<T>;
export {};
