import Long from "long";
import * as _m0 from "protobufjs/minimal";
import { ExecutableTransaction } from "../executable_contract_transaction";
import { DataEntry } from "../data_entry";
import { ValidationProof } from "../validation_proof";
import { ContractAssetOperation } from "../contract_asset_operation";
export declare const protobufPackage = "wavesenterprise";
export interface ExecutedContractTransaction {
    id?: Uint8Array;
    senderPublicKey?: Uint8Array;
    tx?: ExecutableTransaction;
    results?: DataEntry[];
    resultsHash?: Uint8Array;
    validationProofs?: ValidationProof[];
    timestamp?: Long;
    assetOperations?: ContractAssetOperation[];
    proofs?: Uint8Array[];
    senderAddress?: Uint8Array;
}
export declare const ExecutedContractTransaction: {
    encode(message: ExecutedContractTransaction, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): ExecutedContractTransaction;
    fromJSON(object: any): ExecutedContractTransaction;
    toJSON(message: ExecutedContractTransaction): unknown;
    fromPartial(object: DeepPartial<ExecutedContractTransaction>): ExecutedContractTransaction;
};
declare type Builtin = Date | Function | Uint8Array | string | number | boolean | undefined;
export declare type DeepPartial<T> = T extends Builtin ? T : T extends Long ? string | number | Long : T extends Array<infer U> ? Array<DeepPartial<U>> : T extends ReadonlyArray<infer U> ? ReadonlyArray<DeepPartial<U>> : T extends {} ? {
    [K in keyof T]?: DeepPartial<T[K]>;
} : Partial<T>;
export {};
