import Long from "long";
import * as _m0 from "protobufjs/minimal";
export declare const protobufPackage = "wavesenterprise";
export interface IssueTransaction {
    id?: Uint8Array;
    chainId?: number;
    senderPublicKey?: Uint8Array;
    name?: Uint8Array;
    description?: Uint8Array;
    quantity?: Long;
    decimals?: number;
    reissuable?: boolean;
    fee?: Long;
    timestamp?: Long;
    script?: Uint8Array;
    proofs?: Uint8Array[];
    senderAddress?: Uint8Array;
}
export declare const IssueTransaction: {
    encode(message: IssueTransaction, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): IssueTransaction;
    fromJSON(object: any): IssueTransaction;
    toJSON(message: IssueTransaction): unknown;
    fromPartial(object: DeepPartial<IssueTransaction>): IssueTransaction;
};
declare type Builtin = Date | Function | Uint8Array | string | number | boolean | undefined;
export declare type DeepPartial<T> = T extends Builtin ? T : T extends Long ? string | number | Long : T extends Array<infer U> ? Array<DeepPartial<U>> : T extends ReadonlyArray<infer U> ? ReadonlyArray<DeepPartial<U>> : T extends {} ? {
    [K in keyof T]?: DeepPartial<T[K]>;
} : Partial<T>;
export {};
