"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.IssueTransaction = exports.protobufPackage = void 0;
const long_1 = __importDefault(require("long"));
const _m0 = __importStar(require("protobufjs/minimal"));
const wrappers_1 = require("../google/protobuf/wrappers");
exports.protobufPackage = "wavesenterprise";
function createBaseIssueTransaction() {
    return {
        id: new Uint8Array(),
        chainId: 0,
        senderPublicKey: new Uint8Array(),
        name: new Uint8Array(),
        description: new Uint8Array(),
        quantity: long_1.default.ZERO,
        decimals: 0,
        reissuable: false,
        fee: long_1.default.ZERO,
        timestamp: long_1.default.ZERO,
        script: undefined,
        proofs: [],
        senderAddress: new Uint8Array(),
    };
}
exports.IssueTransaction = {
    encode(message, writer = _m0.Writer.create()) {
        if (message.id !== undefined && message.id.length !== 0) {
            writer.uint32(10).bytes(message.id);
        }
        if (message.chainId !== undefined && message.chainId !== 0) {
            writer.uint32(16).int32(message.chainId);
        }
        if (message.senderPublicKey !== undefined &&
            message.senderPublicKey.length !== 0) {
            writer.uint32(26).bytes(message.senderPublicKey);
        }
        if (message.name !== undefined && message.name.length !== 0) {
            writer.uint32(34).bytes(message.name);
        }
        if (message.description !== undefined && message.description.length !== 0) {
            writer.uint32(42).bytes(message.description);
        }
        if (message.quantity !== undefined && !message.quantity.isZero()) {
            writer.uint32(48).int64(message.quantity);
        }
        if (message.decimals !== undefined && message.decimals !== 0) {
            writer.uint32(56).int32(message.decimals);
        }
        if (message.reissuable === true) {
            writer.uint32(64).bool(message.reissuable);
        }
        if (message.fee !== undefined && !message.fee.isZero()) {
            writer.uint32(72).int64(message.fee);
        }
        if (message.timestamp !== undefined && !message.timestamp.isZero()) {
            writer.uint32(80).int64(message.timestamp);
        }
        if (message.script !== undefined) {
            wrappers_1.BytesValue.encode({ value: message.script }, writer.uint32(90).fork()).ldelim();
        }
        if (message.proofs !== undefined && message.proofs.length !== 0) {
            for (const v of message.proofs) {
                writer.uint32(98).bytes(v);
            }
        }
        if (message.senderAddress !== undefined &&
            message.senderAddress.length !== 0) {
            writer.uint32(106).bytes(message.senderAddress);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseIssueTransaction();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.id = reader.bytes();
                    break;
                case 2:
                    message.chainId = reader.int32();
                    break;
                case 3:
                    message.senderPublicKey = reader.bytes();
                    break;
                case 4:
                    message.name = reader.bytes();
                    break;
                case 5:
                    message.description = reader.bytes();
                    break;
                case 6:
                    message.quantity = reader.int64();
                    break;
                case 7:
                    message.decimals = reader.int32();
                    break;
                case 8:
                    message.reissuable = reader.bool();
                    break;
                case 9:
                    message.fee = reader.int64();
                    break;
                case 10:
                    message.timestamp = reader.int64();
                    break;
                case 11:
                    message.script = wrappers_1.BytesValue.decode(reader, reader.uint32()).value;
                    break;
                case 12:
                    message.proofs.push(reader.bytes());
                    break;
                case 13:
                    message.senderAddress = reader.bytes();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        return {
            id: isSet(object.id) ? bytesFromBase64(object.id) : new Uint8Array(),
            chainId: isSet(object.chainId) ? Number(object.chainId) : 0,
            senderPublicKey: isSet(object.senderPublicKey)
                ? bytesFromBase64(object.senderPublicKey)
                : new Uint8Array(),
            name: isSet(object.name)
                ? bytesFromBase64(object.name)
                : new Uint8Array(),
            description: isSet(object.description)
                ? bytesFromBase64(object.description)
                : new Uint8Array(),
            quantity: isSet(object.quantity)
                ? long_1.default.fromString(object.quantity)
                : long_1.default.ZERO,
            decimals: isSet(object.decimals) ? Number(object.decimals) : 0,
            reissuable: isSet(object.reissuable) ? Boolean(object.reissuable) : false,
            fee: isSet(object.fee) ? long_1.default.fromString(object.fee) : long_1.default.ZERO,
            timestamp: isSet(object.timestamp)
                ? long_1.default.fromString(object.timestamp)
                : long_1.default.ZERO,
            script: isSet(object.script) ? new Uint8Array(object.script) : undefined,
            proofs: Array.isArray(object === null || object === void 0 ? void 0 : object.proofs)
                ? object.proofs.map((e) => bytesFromBase64(e))
                : [],
            senderAddress: isSet(object.senderAddress)
                ? bytesFromBase64(object.senderAddress)
                : new Uint8Array(),
        };
    },
    toJSON(message) {
        const obj = {};
        message.id !== undefined &&
            (obj.id = base64FromBytes(message.id !== undefined ? message.id : new Uint8Array()));
        message.chainId !== undefined &&
            (obj.chainId = Math.round(message.chainId));
        message.senderPublicKey !== undefined &&
            (obj.senderPublicKey = base64FromBytes(message.senderPublicKey !== undefined
                ? message.senderPublicKey
                : new Uint8Array()));
        message.name !== undefined &&
            (obj.name = base64FromBytes(message.name !== undefined ? message.name : new Uint8Array()));
        message.description !== undefined &&
            (obj.description = base64FromBytes(message.description !== undefined
                ? message.description
                : new Uint8Array()));
        message.quantity !== undefined &&
            (obj.quantity = (message.quantity || long_1.default.ZERO).toString());
        message.decimals !== undefined &&
            (obj.decimals = Math.round(message.decimals));
        message.reissuable !== undefined && (obj.reissuable = message.reissuable);
        message.fee !== undefined &&
            (obj.fee = (message.fee || long_1.default.ZERO).toString());
        message.timestamp !== undefined &&
            (obj.timestamp = (message.timestamp || long_1.default.ZERO).toString());
        message.script !== undefined && (obj.script = message.script);
        if (message.proofs) {
            obj.proofs = message.proofs.map((e) => base64FromBytes(e !== undefined ? e : new Uint8Array()));
        }
        else {
            obj.proofs = [];
        }
        message.senderAddress !== undefined &&
            (obj.senderAddress = base64FromBytes(message.senderAddress !== undefined
                ? message.senderAddress
                : new Uint8Array()));
        return obj;
    },
    fromPartial(object) {
        var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k;
        const message = createBaseIssueTransaction();
        message.id = (_a = object.id) !== null && _a !== void 0 ? _a : new Uint8Array();
        message.chainId = (_b = object.chainId) !== null && _b !== void 0 ? _b : 0;
        message.senderPublicKey = (_c = object.senderPublicKey) !== null && _c !== void 0 ? _c : new Uint8Array();
        message.name = (_d = object.name) !== null && _d !== void 0 ? _d : new Uint8Array();
        message.description = (_e = object.description) !== null && _e !== void 0 ? _e : new Uint8Array();
        message.quantity =
            object.quantity !== undefined && object.quantity !== null
                ? long_1.default.fromValue(object.quantity)
                : long_1.default.ZERO;
        message.decimals = (_f = object.decimals) !== null && _f !== void 0 ? _f : 0;
        message.reissuable = (_g = object.reissuable) !== null && _g !== void 0 ? _g : false;
        message.fee =
            object.fee !== undefined && object.fee !== null
                ? long_1.default.fromValue(object.fee)
                : long_1.default.ZERO;
        message.timestamp =
            object.timestamp !== undefined && object.timestamp !== null
                ? long_1.default.fromValue(object.timestamp)
                : long_1.default.ZERO;
        message.script = (_h = object.script) !== null && _h !== void 0 ? _h : undefined;
        message.proofs = ((_j = object.proofs) === null || _j === void 0 ? void 0 : _j.map((e) => e)) || [];
        message.senderAddress = (_k = object.senderAddress) !== null && _k !== void 0 ? _k : new Uint8Array();
        return message;
    },
};
var globalThis = (() => {
    if (typeof globalThis !== "undefined")
        return globalThis;
    if (typeof self !== "undefined")
        return self;
    if (typeof window !== "undefined")
        return window;
    if (typeof global !== "undefined")
        return global;
    throw "Unable to locate global object";
})();
const atob = globalThis.atob ||
    ((b64) => globalThis.Buffer.from(b64, "base64").toString("binary"));
function bytesFromBase64(b64) {
    const bin = atob(b64);
    const arr = new Uint8Array(bin.length);
    for (let i = 0; i < bin.length; ++i) {
        arr[i] = bin.charCodeAt(i);
    }
    return arr;
}
const btoa = globalThis.btoa ||
    ((bin) => globalThis.Buffer.from(bin, "binary").toString("base64"));
function base64FromBytes(arr) {
    const bin = [];
    for (const byte of arr) {
        bin.push(String.fromCharCode(byte));
    }
    return btoa(bin.join(""));
}
if (_m0.util.Long !== long_1.default) {
    _m0.util.Long = long_1.default;
    _m0.configure();
}
function isSet(value) {
    return value !== null && value !== undefined;
}
//# sourceMappingURL=issue_transaction.js.map