import Long from "long";
import * as _m0 from "protobufjs/minimal";
import { Transfer } from "../transfer";
export declare const protobufPackage = "wavesenterprise";
export interface MassTransferTransaction {
    id?: Uint8Array;
    senderPublicKey?: Uint8Array;
    assetId?: Uint8Array;
    transfers?: Transfer[];
    timestamp?: Long;
    fee?: Long;
    attachment?: Uint8Array;
    feeAssetId?: Uint8Array;
    proofs?: Uint8Array[];
    senderAddress?: Uint8Array;
}
export declare const MassTransferTransaction: {
    encode(message: MassTransferTransaction, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): MassTransferTransaction;
    fromJSON(object: any): MassTransferTransaction;
    toJSON(message: MassTransferTransaction): unknown;
    fromPartial(object: DeepPartial<MassTransferTransaction>): MassTransferTransaction;
};
declare type Builtin = Date | Function | Uint8Array | string | number | boolean | undefined;
export declare type DeepPartial<T> = T extends Builtin ? T : T extends Long ? string | number | Long : T extends Array<infer U> ? Array<DeepPartial<U>> : T extends ReadonlyArray<infer U> ? ReadonlyArray<DeepPartial<U>> : T extends {} ? {
    [K in keyof T]?: DeepPartial<T[K]>;
} : Partial<T>;
export {};
