import Long from "long";
import * as _m0 from "protobufjs/minimal";
export declare const protobufPackage = "wavesenterprise";
export interface SponsorFeeTransaction {
    id?: Uint8Array;
    senderPublicKey?: Uint8Array;
    assetId?: Uint8Array;
    isEnabled?: boolean;
    fee?: Long;
    timestamp?: Long;
    proofs?: Uint8Array[];
    senderAddress?: Uint8Array;
}
export declare const SponsorFeeTransaction: {
    encode(message: SponsorFeeTransaction, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): SponsorFeeTransaction;
    fromJSON(object: any): SponsorFeeTransaction;
    toJSON(message: SponsorFeeTransaction): unknown;
    fromPartial(object: DeepPartial<SponsorFeeTransaction>): SponsorFeeTransaction;
};
declare type Builtin = Date | Function | Uint8Array | string | number | boolean | undefined;
export declare type DeepPartial<T> = T extends Builtin ? T : T extends Long ? string | number | Long : T extends Array<infer U> ? Array<DeepPartial<U>> : T extends ReadonlyArray<infer U> ? ReadonlyArray<DeepPartial<U>> : T extends {} ? {
    [K in keyof T]?: DeepPartial<T[K]>;
} : Partial<T>;
export {};
