"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.PermissionOp = exports.protobufPackage = void 0;
const long_1 = __importDefault(require("long"));
const _m0 = __importStar(require("protobufjs/minimal"));
const op_type_1 = require("./op_type");
const role_1 = require("./role");
const wrappers_1 = require("./google/protobuf/wrappers");
exports.protobufPackage = "wavesenterprise";
function createBasePermissionOp() {
    return {
        opType: 0,
        role: undefined,
        timestamp: long_1.default.ZERO,
        dueTimestamp: undefined,
    };
}
exports.PermissionOp = {
    encode(message, writer = _m0.Writer.create()) {
        if (message.opType !== undefined && message.opType !== 0) {
            writer.uint32(8).int32(message.opType);
        }
        if (message.role !== undefined) {
            role_1.Role.encode(message.role, writer.uint32(18).fork()).ldelim();
        }
        if (message.timestamp !== undefined && !message.timestamp.isZero()) {
            writer.uint32(24).int64(message.timestamp);
        }
        if (message.dueTimestamp !== undefined) {
            wrappers_1.Int64Value.encode({ value: message.dueTimestamp }, writer.uint32(34).fork()).ldelim();
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBasePermissionOp();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.opType = reader.int32();
                    break;
                case 2:
                    message.role = role_1.Role.decode(reader, reader.uint32());
                    break;
                case 3:
                    message.timestamp = reader.int64();
                    break;
                case 4:
                    message.dueTimestamp = wrappers_1.Int64Value.decode(reader, reader.uint32()).value;
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        return {
            opType: isSet(object.opType) ? (0, op_type_1.opTypeFromJSON)(object.opType) : 0,
            role: isSet(object.role) ? role_1.Role.fromJSON(object.role) : undefined,
            timestamp: isSet(object.timestamp)
                ? long_1.default.fromString(object.timestamp)
                : long_1.default.ZERO,
            dueTimestamp: isSet(object.dueTimestamp)
                ? long_1.default.fromValue(object.dueTimestamp)
                : undefined,
        };
    },
    toJSON(message) {
        const obj = {};
        message.opType !== undefined && (obj.opType = (0, op_type_1.opTypeToJSON)(message.opType));
        message.role !== undefined &&
            (obj.role = message.role ? role_1.Role.toJSON(message.role) : undefined);
        message.timestamp !== undefined &&
            (obj.timestamp = (message.timestamp || long_1.default.ZERO).toString());
        message.dueTimestamp !== undefined &&
            (obj.dueTimestamp = message.dueTimestamp);
        return obj;
    },
    fromPartial(object) {
        var _a;
        const message = createBasePermissionOp();
        message.opType = (_a = object.opType) !== null && _a !== void 0 ? _a : 0;
        message.role =
            object.role !== undefined && object.role !== null
                ? role_1.Role.fromPartial(object.role)
                : undefined;
        message.timestamp =
            object.timestamp !== undefined && object.timestamp !== null
                ? long_1.default.fromValue(object.timestamp)
                : long_1.default.ZERO;
        message.dueTimestamp =
            object.dueTimestamp !== undefined && object.dueTimestamp !== null
                ? long_1.default.fromValue(object.dueTimestamp)
                : undefined;
        return message;
    },
};
if (_m0.util.Long !== long_1.default) {
    _m0.util.Long = long_1.default;
    _m0.configure();
}
function isSet(value) {
    return value !== null && value !== undefined;
}
//# sourceMappingURL=permission_op.js.map