import Long from "long";
import * as _m0 from "protobufjs/minimal";
export declare const protobufPackage = "wavesenterprise";
export interface SubscribeOnRequest {
    genesisBlock?: GenesisBlock | undefined;
    blockSignature?: BlockSignature | undefined;
    currentEvent?: CurrentEvent | undefined;
    eventsFilters?: EventsFilter[];
}
export interface GenesisBlock {
}
export interface BlockSignature {
    lastBlockSignature?: Uint8Array;
}
export interface CurrentEvent {
}
export interface EventsFilter {
    filterIn?: EventsFilter_FilterIn | undefined;
    filterOut?: EventsFilter_FilterOut | undefined;
    txTypeFilter?: TxTypeFilter | undefined;
    contractIdFilter?: ContractIdFilter | undefined;
}
export interface EventsFilter_FilterIn {
}
export interface EventsFilter_FilterOut {
}
export interface TxTypeFilter {
    txTypes?: number[];
}
export interface ContractIdFilter {
    contractIds?: Uint8Array[];
}
export declare const SubscribeOnRequest: {
    encode(message: SubscribeOnRequest, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): SubscribeOnRequest;
    fromJSON(object: any): SubscribeOnRequest;
    toJSON(message: SubscribeOnRequest): unknown;
    fromPartial(object: DeepPartial<SubscribeOnRequest>): SubscribeOnRequest;
};
export declare const GenesisBlock: {
    encode(_: GenesisBlock, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): GenesisBlock;
    fromJSON(_: any): GenesisBlock;
    toJSON(_: GenesisBlock): unknown;
    fromPartial(_: DeepPartial<GenesisBlock>): GenesisBlock;
};
export declare const BlockSignature: {
    encode(message: BlockSignature, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): BlockSignature;
    fromJSON(object: any): BlockSignature;
    toJSON(message: BlockSignature): unknown;
    fromPartial(object: DeepPartial<BlockSignature>): BlockSignature;
};
export declare const CurrentEvent: {
    encode(_: CurrentEvent, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): CurrentEvent;
    fromJSON(_: any): CurrentEvent;
    toJSON(_: CurrentEvent): unknown;
    fromPartial(_: DeepPartial<CurrentEvent>): CurrentEvent;
};
export declare const EventsFilter: {
    encode(message: EventsFilter, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): EventsFilter;
    fromJSON(object: any): EventsFilter;
    toJSON(message: EventsFilter): unknown;
    fromPartial(object: DeepPartial<EventsFilter>): EventsFilter;
};
export declare const EventsFilter_FilterIn: {
    encode(_: EventsFilter_FilterIn, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): EventsFilter_FilterIn;
    fromJSON(_: any): EventsFilter_FilterIn;
    toJSON(_: EventsFilter_FilterIn): unknown;
    fromPartial(_: DeepPartial<EventsFilter_FilterIn>): EventsFilter_FilterIn;
};
export declare const EventsFilter_FilterOut: {
    encode(_: EventsFilter_FilterOut, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): EventsFilter_FilterOut;
    fromJSON(_: any): EventsFilter_FilterOut;
    toJSON(_: EventsFilter_FilterOut): unknown;
    fromPartial(_: DeepPartial<EventsFilter_FilterOut>): EventsFilter_FilterOut;
};
export declare const TxTypeFilter: {
    encode(message: TxTypeFilter, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): TxTypeFilter;
    fromJSON(object: any): TxTypeFilter;
    toJSON(message: TxTypeFilter): unknown;
    fromPartial(object: DeepPartial<TxTypeFilter>): TxTypeFilter;
};
export declare const ContractIdFilter: {
    encode(message: ContractIdFilter, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): ContractIdFilter;
    fromJSON(object: any): ContractIdFilter;
    toJSON(message: ContractIdFilter): unknown;
    fromPartial(object: DeepPartial<ContractIdFilter>): ContractIdFilter;
};
declare type Builtin = Date | Function | Uint8Array | string | number | boolean | undefined;
export declare type DeepPartial<T> = T extends Builtin ? T : T extends Long ? string | number | Long : T extends Array<infer U> ? Array<DeepPartial<U>> : T extends ReadonlyArray<infer U> ? ReadonlyArray<DeepPartial<U>> : T extends {} ? {
    [K in keyof T]?: DeepPartial<T[K]>;
} : Partial<T>;
export {};
