"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ContractIdFilter = exports.TxTypeFilter = exports.EventsFilter_FilterOut = exports.EventsFilter_FilterIn = exports.EventsFilter = exports.CurrentEvent = exports.BlockSignature = exports.GenesisBlock = exports.SubscribeOnRequest = exports.protobufPackage = void 0;
const long_1 = __importDefault(require("long"));
const _m0 = __importStar(require("protobufjs/minimal"));
const wrappers_1 = require("../../google/protobuf/wrappers");
exports.protobufPackage = "wavesenterprise";
function createBaseSubscribeOnRequest() {
    return {
        genesisBlock: undefined,
        blockSignature: undefined,
        currentEvent: undefined,
        eventsFilters: [],
    };
}
exports.SubscribeOnRequest = {
    encode(message, writer = _m0.Writer.create()) {
        if (message.genesisBlock !== undefined) {
            exports.GenesisBlock.encode(message.genesisBlock, writer.uint32(810).fork()).ldelim();
        }
        if (message.blockSignature !== undefined) {
            exports.BlockSignature.encode(message.blockSignature, writer.uint32(818).fork()).ldelim();
        }
        if (message.currentEvent !== undefined) {
            exports.CurrentEvent.encode(message.currentEvent, writer.uint32(826).fork()).ldelim();
        }
        if (message.eventsFilters !== undefined &&
            message.eventsFilters.length !== 0) {
            for (const v of message.eventsFilters) {
                exports.EventsFilter.encode(v, writer.uint32(10).fork()).ldelim();
            }
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseSubscribeOnRequest();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 101:
                    message.genesisBlock = exports.GenesisBlock.decode(reader, reader.uint32());
                    break;
                case 102:
                    message.blockSignature = exports.BlockSignature.decode(reader, reader.uint32());
                    break;
                case 103:
                    message.currentEvent = exports.CurrentEvent.decode(reader, reader.uint32());
                    break;
                case 1:
                    message.eventsFilters.push(exports.EventsFilter.decode(reader, reader.uint32()));
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        return {
            genesisBlock: isSet(object.genesisBlock)
                ? exports.GenesisBlock.fromJSON(object.genesisBlock)
                : undefined,
            blockSignature: isSet(object.blockSignature)
                ? exports.BlockSignature.fromJSON(object.blockSignature)
                : undefined,
            currentEvent: isSet(object.currentEvent)
                ? exports.CurrentEvent.fromJSON(object.currentEvent)
                : undefined,
            eventsFilters: Array.isArray(object === null || object === void 0 ? void 0 : object.eventsFilters)
                ? object.eventsFilters.map((e) => exports.EventsFilter.fromJSON(e))
                : [],
        };
    },
    toJSON(message) {
        const obj = {};
        message.genesisBlock !== undefined &&
            (obj.genesisBlock = message.genesisBlock
                ? exports.GenesisBlock.toJSON(message.genesisBlock)
                : undefined);
        message.blockSignature !== undefined &&
            (obj.blockSignature = message.blockSignature
                ? exports.BlockSignature.toJSON(message.blockSignature)
                : undefined);
        message.currentEvent !== undefined &&
            (obj.currentEvent = message.currentEvent
                ? exports.CurrentEvent.toJSON(message.currentEvent)
                : undefined);
        if (message.eventsFilters) {
            obj.eventsFilters = message.eventsFilters.map((e) => e ? exports.EventsFilter.toJSON(e) : undefined);
        }
        else {
            obj.eventsFilters = [];
        }
        return obj;
    },
    fromPartial(object) {
        var _a;
        const message = createBaseSubscribeOnRequest();
        message.genesisBlock =
            object.genesisBlock !== undefined && object.genesisBlock !== null
                ? exports.GenesisBlock.fromPartial(object.genesisBlock)
                : undefined;
        message.blockSignature =
            object.blockSignature !== undefined && object.blockSignature !== null
                ? exports.BlockSignature.fromPartial(object.blockSignature)
                : undefined;
        message.currentEvent =
            object.currentEvent !== undefined && object.currentEvent !== null
                ? exports.CurrentEvent.fromPartial(object.currentEvent)
                : undefined;
        message.eventsFilters =
            ((_a = object.eventsFilters) === null || _a === void 0 ? void 0 : _a.map((e) => exports.EventsFilter.fromPartial(e))) || [];
        return message;
    },
};
function createBaseGenesisBlock() {
    return {};
}
exports.GenesisBlock = {
    encode(_, writer = _m0.Writer.create()) {
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseGenesisBlock();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(_) {
        return {};
    },
    toJSON(_) {
        const obj = {};
        return obj;
    },
    fromPartial(_) {
        const message = createBaseGenesisBlock();
        return message;
    },
};
function createBaseBlockSignature() {
    return { lastBlockSignature: undefined };
}
exports.BlockSignature = {
    encode(message, writer = _m0.Writer.create()) {
        if (message.lastBlockSignature !== undefined) {
            wrappers_1.BytesValue.encode({ value: message.lastBlockSignature }, writer.uint32(10).fork()).ldelim();
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseBlockSignature();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.lastBlockSignature = wrappers_1.BytesValue.decode(reader, reader.uint32()).value;
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        return {
            lastBlockSignature: isSet(object.lastBlockSignature)
                ? new Uint8Array(object.lastBlockSignature)
                : undefined,
        };
    },
    toJSON(message) {
        const obj = {};
        message.lastBlockSignature !== undefined &&
            (obj.lastBlockSignature = message.lastBlockSignature);
        return obj;
    },
    fromPartial(object) {
        var _a;
        const message = createBaseBlockSignature();
        message.lastBlockSignature = (_a = object.lastBlockSignature) !== null && _a !== void 0 ? _a : undefined;
        return message;
    },
};
function createBaseCurrentEvent() {
    return {};
}
exports.CurrentEvent = {
    encode(_, writer = _m0.Writer.create()) {
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseCurrentEvent();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(_) {
        return {};
    },
    toJSON(_) {
        const obj = {};
        return obj;
    },
    fromPartial(_) {
        const message = createBaseCurrentEvent();
        return message;
    },
};
function createBaseEventsFilter() {
    return {
        filterIn: undefined,
        filterOut: undefined,
        txTypeFilter: undefined,
        contractIdFilter: undefined,
    };
}
exports.EventsFilter = {
    encode(message, writer = _m0.Writer.create()) {
        if (message.filterIn !== undefined) {
            exports.EventsFilter_FilterIn.encode(message.filterIn, writer.uint32(10).fork()).ldelim();
        }
        if (message.filterOut !== undefined) {
            exports.EventsFilter_FilterOut.encode(message.filterOut, writer.uint32(18).fork()).ldelim();
        }
        if (message.txTypeFilter !== undefined) {
            exports.TxTypeFilter.encode(message.txTypeFilter, writer.uint32(810).fork()).ldelim();
        }
        if (message.contractIdFilter !== undefined) {
            exports.ContractIdFilter.encode(message.contractIdFilter, writer.uint32(818).fork()).ldelim();
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseEventsFilter();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.filterIn = exports.EventsFilter_FilterIn.decode(reader, reader.uint32());
                    break;
                case 2:
                    message.filterOut = exports.EventsFilter_FilterOut.decode(reader, reader.uint32());
                    break;
                case 101:
                    message.txTypeFilter = exports.TxTypeFilter.decode(reader, reader.uint32());
                    break;
                case 102:
                    message.contractIdFilter = exports.ContractIdFilter.decode(reader, reader.uint32());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        return {
            filterIn: isSet(object.filterIn)
                ? exports.EventsFilter_FilterIn.fromJSON(object.filterIn)
                : undefined,
            filterOut: isSet(object.filterOut)
                ? exports.EventsFilter_FilterOut.fromJSON(object.filterOut)
                : undefined,
            txTypeFilter: isSet(object.txTypeFilter)
                ? exports.TxTypeFilter.fromJSON(object.txTypeFilter)
                : undefined,
            contractIdFilter: isSet(object.contractIdFilter)
                ? exports.ContractIdFilter.fromJSON(object.contractIdFilter)
                : undefined,
        };
    },
    toJSON(message) {
        const obj = {};
        message.filterIn !== undefined &&
            (obj.filterIn = message.filterIn
                ? exports.EventsFilter_FilterIn.toJSON(message.filterIn)
                : undefined);
        message.filterOut !== undefined &&
            (obj.filterOut = message.filterOut
                ? exports.EventsFilter_FilterOut.toJSON(message.filterOut)
                : undefined);
        message.txTypeFilter !== undefined &&
            (obj.txTypeFilter = message.txTypeFilter
                ? exports.TxTypeFilter.toJSON(message.txTypeFilter)
                : undefined);
        message.contractIdFilter !== undefined &&
            (obj.contractIdFilter = message.contractIdFilter
                ? exports.ContractIdFilter.toJSON(message.contractIdFilter)
                : undefined);
        return obj;
    },
    fromPartial(object) {
        const message = createBaseEventsFilter();
        message.filterIn =
            object.filterIn !== undefined && object.filterIn !== null
                ? exports.EventsFilter_FilterIn.fromPartial(object.filterIn)
                : undefined;
        message.filterOut =
            object.filterOut !== undefined && object.filterOut !== null
                ? exports.EventsFilter_FilterOut.fromPartial(object.filterOut)
                : undefined;
        message.txTypeFilter =
            object.txTypeFilter !== undefined && object.txTypeFilter !== null
                ? exports.TxTypeFilter.fromPartial(object.txTypeFilter)
                : undefined;
        message.contractIdFilter =
            object.contractIdFilter !== undefined && object.contractIdFilter !== null
                ? exports.ContractIdFilter.fromPartial(object.contractIdFilter)
                : undefined;
        return message;
    },
};
function createBaseEventsFilter_FilterIn() {
    return {};
}
exports.EventsFilter_FilterIn = {
    encode(_, writer = _m0.Writer.create()) {
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseEventsFilter_FilterIn();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(_) {
        return {};
    },
    toJSON(_) {
        const obj = {};
        return obj;
    },
    fromPartial(_) {
        const message = createBaseEventsFilter_FilterIn();
        return message;
    },
};
function createBaseEventsFilter_FilterOut() {
    return {};
}
exports.EventsFilter_FilterOut = {
    encode(_, writer = _m0.Writer.create()) {
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseEventsFilter_FilterOut();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(_) {
        return {};
    },
    toJSON(_) {
        const obj = {};
        return obj;
    },
    fromPartial(_) {
        const message = createBaseEventsFilter_FilterOut();
        return message;
    },
};
function createBaseTxTypeFilter() {
    return { txTypes: [] };
}
exports.TxTypeFilter = {
    encode(message, writer = _m0.Writer.create()) {
        if (message.txTypes !== undefined && message.txTypes.length !== 0) {
            writer.uint32(10).fork();
            for (const v of message.txTypes) {
                writer.int32(v);
            }
            writer.ldelim();
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseTxTypeFilter();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    if ((tag & 7) === 2) {
                        const end2 = reader.uint32() + reader.pos;
                        while (reader.pos < end2) {
                            message.txTypes.push(reader.int32());
                        }
                    }
                    else {
                        message.txTypes.push(reader.int32());
                    }
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        return {
            txTypes: Array.isArray(object === null || object === void 0 ? void 0 : object.txTypes)
                ? object.txTypes.map((e) => Number(e))
                : [],
        };
    },
    toJSON(message) {
        const obj = {};
        if (message.txTypes) {
            obj.txTypes = message.txTypes.map((e) => Math.round(e));
        }
        else {
            obj.txTypes = [];
        }
        return obj;
    },
    fromPartial(object) {
        var _a;
        const message = createBaseTxTypeFilter();
        message.txTypes = ((_a = object.txTypes) === null || _a === void 0 ? void 0 : _a.map((e) => e)) || [];
        return message;
    },
};
function createBaseContractIdFilter() {
    return { contractIds: [] };
}
exports.ContractIdFilter = {
    encode(message, writer = _m0.Writer.create()) {
        if (message.contractIds !== undefined && message.contractIds.length !== 0) {
            for (const v of message.contractIds) {
                writer.uint32(10).bytes(v);
            }
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseContractIdFilter();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.contractIds.push(reader.bytes());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        return {
            contractIds: Array.isArray(object === null || object === void 0 ? void 0 : object.contractIds)
                ? object.contractIds.map((e) => bytesFromBase64(e))
                : [],
        };
    },
    toJSON(message) {
        const obj = {};
        if (message.contractIds) {
            obj.contractIds = message.contractIds.map((e) => base64FromBytes(e !== undefined ? e : new Uint8Array()));
        }
        else {
            obj.contractIds = [];
        }
        return obj;
    },
    fromPartial(object) {
        var _a;
        const message = createBaseContractIdFilter();
        message.contractIds = ((_a = object.contractIds) === null || _a === void 0 ? void 0 : _a.map((e) => e)) || [];
        return message;
    },
};
var globalThis = (() => {
    if (typeof globalThis !== "undefined")
        return globalThis;
    if (typeof self !== "undefined")
        return self;
    if (typeof window !== "undefined")
        return window;
    if (typeof global !== "undefined")
        return global;
    throw "Unable to locate global object";
})();
const atob = globalThis.atob ||
    ((b64) => globalThis.Buffer.from(b64, "base64").toString("binary"));
function bytesFromBase64(b64) {
    const bin = atob(b64);
    const arr = new Uint8Array(bin.length);
    for (let i = 0; i < bin.length; ++i) {
        arr[i] = bin.charCodeAt(i);
    }
    return arr;
}
const btoa = globalThis.btoa ||
    ((bin) => globalThis.Buffer.from(bin, "binary").toString("base64"));
function base64FromBytes(arr) {
    const bin = [];
    for (const byte of arr) {
        bin.push(String.fromCharCode(byte));
    }
    return btoa(bin.join(""));
}
if (_m0.util.Long !== long_1.default) {
    _m0.util.Long = long_1.default;
    _m0.configure();
}
function isSet(value) {
    return value !== null && value !== undefined;
}
//# sourceMappingURL=util_events_subscribe_on_request.js.map