"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ContractStatusServiceClient = exports.ContractStatusServiceService = exports.ContractExecutionResponse = exports.ContractExecutionRequest = exports.contractExecutionResponse_StatusToJSON = exports.contractExecutionResponse_StatusFromJSON = exports.ContractExecutionResponse_Status = exports.protobufPackage = void 0;
const long_1 = __importDefault(require("long"));
const grpc_js_1 = require("@grpc/grpc-js");
const _m0 = __importStar(require("protobufjs/minimal"));
const empty_1 = require("../google/protobuf/empty");
const wrappers_1 = require("../google/protobuf/wrappers");
exports.protobufPackage = "wavesenterprise";
var ContractExecutionResponse_Status;
(function (ContractExecutionResponse_Status) {
    ContractExecutionResponse_Status[ContractExecutionResponse_Status["SUCCESS"] = 0] = "SUCCESS";
    ContractExecutionResponse_Status[ContractExecutionResponse_Status["ERROR"] = 1] = "ERROR";
    ContractExecutionResponse_Status[ContractExecutionResponse_Status["FAILURE"] = 2] = "FAILURE";
    ContractExecutionResponse_Status[ContractExecutionResponse_Status["UNRECOGNIZED"] = -1] = "UNRECOGNIZED";
})(ContractExecutionResponse_Status = exports.ContractExecutionResponse_Status || (exports.ContractExecutionResponse_Status = {}));
function contractExecutionResponse_StatusFromJSON(object) {
    switch (object) {
        case 0:
        case "SUCCESS":
            return ContractExecutionResponse_Status.SUCCESS;
        case 1:
        case "ERROR":
            return ContractExecutionResponse_Status.ERROR;
        case 2:
        case "FAILURE":
            return ContractExecutionResponse_Status.FAILURE;
        case -1:
        case "UNRECOGNIZED":
        default:
            return ContractExecutionResponse_Status.UNRECOGNIZED;
    }
}
exports.contractExecutionResponse_StatusFromJSON = contractExecutionResponse_StatusFromJSON;
function contractExecutionResponse_StatusToJSON(object) {
    switch (object) {
        case ContractExecutionResponse_Status.SUCCESS:
            return "SUCCESS";
        case ContractExecutionResponse_Status.ERROR:
            return "ERROR";
        case ContractExecutionResponse_Status.FAILURE:
            return "FAILURE";
        default:
            return "UNKNOWN";
    }
}
exports.contractExecutionResponse_StatusToJSON = contractExecutionResponse_StatusToJSON;
function createBaseContractExecutionRequest() {
    return { txId: "" };
}
exports.ContractExecutionRequest = {
    encode(message, writer = _m0.Writer.create()) {
        if (message.txId !== undefined && message.txId !== "") {
            writer.uint32(10).string(message.txId);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseContractExecutionRequest();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.txId = reader.string();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        return {
            txId: isSet(object.txId) ? String(object.txId) : "",
        };
    },
    toJSON(message) {
        const obj = {};
        message.txId !== undefined && (obj.txId = message.txId);
        return obj;
    },
    fromPartial(object) {
        var _a;
        const message = createBaseContractExecutionRequest();
        message.txId = (_a = object.txId) !== null && _a !== void 0 ? _a : "";
        return message;
    },
};
function createBaseContractExecutionResponse() {
    return {
        sender: "",
        txId: "",
        status: 0,
        code: undefined,
        message: "",
        timestamp: long_1.default.ZERO,
        signature: "",
        senderAddress: "",
        senderPublicKey: "",
    };
}
exports.ContractExecutionResponse = {
    encode(message, writer = _m0.Writer.create()) {
        if (message.sender !== undefined && message.sender !== "") {
            writer.uint32(10).string(message.sender);
        }
        if (message.txId !== undefined && message.txId !== "") {
            writer.uint32(18).string(message.txId);
        }
        if (message.status !== undefined && message.status !== 0) {
            writer.uint32(24).int32(message.status);
        }
        if (message.code !== undefined) {
            wrappers_1.Int32Value.encode({ value: message.code }, writer.uint32(34).fork()).ldelim();
        }
        if (message.message !== undefined && message.message !== "") {
            writer.uint32(42).string(message.message);
        }
        if (message.timestamp !== undefined && !message.timestamp.isZero()) {
            writer.uint32(48).int64(message.timestamp);
        }
        if (message.signature !== undefined && message.signature !== "") {
            writer.uint32(58).string(message.signature);
        }
        if (message.senderAddress !== undefined && message.senderAddress !== "") {
            writer.uint32(66).string(message.senderAddress);
        }
        if (message.senderPublicKey !== undefined &&
            message.senderPublicKey !== "") {
            writer.uint32(74).string(message.senderPublicKey);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseContractExecutionResponse();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.sender = reader.string();
                    break;
                case 2:
                    message.txId = reader.string();
                    break;
                case 3:
                    message.status = reader.int32();
                    break;
                case 4:
                    message.code = wrappers_1.Int32Value.decode(reader, reader.uint32()).value;
                    break;
                case 5:
                    message.message = reader.string();
                    break;
                case 6:
                    message.timestamp = reader.int64();
                    break;
                case 7:
                    message.signature = reader.string();
                    break;
                case 8:
                    message.senderAddress = reader.string();
                    break;
                case 9:
                    message.senderPublicKey = reader.string();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        return {
            sender: isSet(object.sender) ? String(object.sender) : "",
            txId: isSet(object.txId) ? String(object.txId) : "",
            status: isSet(object.status)
                ? contractExecutionResponse_StatusFromJSON(object.status)
                : 0,
            code: isSet(object.code) ? Number(object.code) : undefined,
            message: isSet(object.message) ? String(object.message) : "",
            timestamp: isSet(object.timestamp)
                ? long_1.default.fromString(object.timestamp)
                : long_1.default.ZERO,
            signature: isSet(object.signature) ? String(object.signature) : "",
            senderAddress: isSet(object.senderAddress)
                ? String(object.senderAddress)
                : "",
            senderPublicKey: isSet(object.senderPublicKey)
                ? String(object.senderPublicKey)
                : "",
        };
    },
    toJSON(message) {
        const obj = {};
        message.sender !== undefined && (obj.sender = message.sender);
        message.txId !== undefined && (obj.txId = message.txId);
        message.status !== undefined &&
            (obj.status = contractExecutionResponse_StatusToJSON(message.status));
        message.code !== undefined && (obj.code = message.code);
        message.message !== undefined && (obj.message = message.message);
        message.timestamp !== undefined &&
            (obj.timestamp = (message.timestamp || long_1.default.ZERO).toString());
        message.signature !== undefined && (obj.signature = message.signature);
        message.senderAddress !== undefined &&
            (obj.senderAddress = message.senderAddress);
        message.senderPublicKey !== undefined &&
            (obj.senderPublicKey = message.senderPublicKey);
        return obj;
    },
    fromPartial(object) {
        var _a, _b, _c, _d, _e, _f, _g, _h;
        const message = createBaseContractExecutionResponse();
        message.sender = (_a = object.sender) !== null && _a !== void 0 ? _a : "";
        message.txId = (_b = object.txId) !== null && _b !== void 0 ? _b : "";
        message.status = (_c = object.status) !== null && _c !== void 0 ? _c : 0;
        message.code = (_d = object.code) !== null && _d !== void 0 ? _d : undefined;
        message.message = (_e = object.message) !== null && _e !== void 0 ? _e : "";
        message.timestamp =
            object.timestamp !== undefined && object.timestamp !== null
                ? long_1.default.fromValue(object.timestamp)
                : long_1.default.ZERO;
        message.signature = (_f = object.signature) !== null && _f !== void 0 ? _f : "";
        message.senderAddress = (_g = object.senderAddress) !== null && _g !== void 0 ? _g : "";
        message.senderPublicKey = (_h = object.senderPublicKey) !== null && _h !== void 0 ? _h : "";
        return message;
    },
};
exports.ContractStatusServiceService = {
    contractExecutionStatuses: {
        path: "/wavesenterprise.ContractStatusService/ContractExecutionStatuses",
        requestStream: false,
        responseStream: true,
        requestSerialize: (value) => Buffer.from(exports.ContractExecutionRequest.encode(value).finish()),
        requestDeserialize: (value) => exports.ContractExecutionRequest.decode(value),
        responseSerialize: (value) => Buffer.from(exports.ContractExecutionResponse.encode(value).finish()),
        responseDeserialize: (value) => exports.ContractExecutionResponse.decode(value),
    },
    contractsExecutionEvents: {
        path: "/wavesenterprise.ContractStatusService/ContractsExecutionEvents",
        requestStream: false,
        responseStream: true,
        requestSerialize: (value) => Buffer.from(empty_1.Empty.encode(value).finish()),
        requestDeserialize: (value) => empty_1.Empty.decode(value),
        responseSerialize: (value) => Buffer.from(exports.ContractExecutionResponse.encode(value).finish()),
        responseDeserialize: (value) => exports.ContractExecutionResponse.decode(value),
    },
};
exports.ContractStatusServiceClient = (0, grpc_js_1.makeGenericClientConstructor)(exports.ContractStatusServiceService, "wavesenterprise.ContractStatusService");
if (_m0.util.Long !== long_1.default) {
    _m0.util.Long = long_1.default;
    _m0.configure();
}
function isSet(value) {
    return value !== null && value !== undefined;
}
//# sourceMappingURL=util_contract_status_service.js.map