"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.UtilPublicServiceClient = exports.UtilPublicServiceService = exports.NodeTimeResponse = exports.protobufPackage = void 0;
const long_1 = __importDefault(require("long"));
const grpc_js_1 = require("@grpc/grpc-js");
const _m0 = __importStar(require("protobufjs/minimal"));
const empty_1 = require("../google/protobuf/empty");
exports.protobufPackage = "wavesenterprise.grpc";
function createBaseNodeTimeResponse() {
    return { system: long_1.default.ZERO, ntp: long_1.default.ZERO };
}
exports.NodeTimeResponse = {
    encode(message, writer = _m0.Writer.create()) {
        if (message.system !== undefined && !message.system.isZero()) {
            writer.uint32(8).int64(message.system);
        }
        if (message.ntp !== undefined && !message.ntp.isZero()) {
            writer.uint32(16).int64(message.ntp);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseNodeTimeResponse();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.system = reader.int64();
                    break;
                case 2:
                    message.ntp = reader.int64();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        return {
            system: isSet(object.system) ? long_1.default.fromString(object.system) : long_1.default.ZERO,
            ntp: isSet(object.ntp) ? long_1.default.fromString(object.ntp) : long_1.default.ZERO,
        };
    },
    toJSON(message) {
        const obj = {};
        message.system !== undefined &&
            (obj.system = (message.system || long_1.default.ZERO).toString());
        message.ntp !== undefined &&
            (obj.ntp = (message.ntp || long_1.default.ZERO).toString());
        return obj;
    },
    fromPartial(object) {
        const message = createBaseNodeTimeResponse();
        message.system =
            object.system !== undefined && object.system !== null
                ? long_1.default.fromValue(object.system)
                : long_1.default.ZERO;
        message.ntp =
            object.ntp !== undefined && object.ntp !== null
                ? long_1.default.fromValue(object.ntp)
                : long_1.default.ZERO;
        return message;
    },
};
exports.UtilPublicServiceService = {
    getNodeTime: {
        path: "/wavesenterprise.grpc.UtilPublicService/GetNodeTime",
        requestStream: false,
        responseStream: false,
        requestSerialize: (value) => Buffer.from(empty_1.Empty.encode(value).finish()),
        requestDeserialize: (value) => empty_1.Empty.decode(value),
        responseSerialize: (value) => Buffer.from(exports.NodeTimeResponse.encode(value).finish()),
        responseDeserialize: (value) => exports.NodeTimeResponse.decode(value),
    },
};
exports.UtilPublicServiceClient = (0, grpc_js_1.makeGenericClientConstructor)(exports.UtilPublicServiceService, "wavesenterprise.grpc.UtilPublicService");
if (_m0.util.Long !== long_1.default) {
    _m0.util.Long = long_1.default;
    _m0.configure();
}
function isSet(value) {
    return value !== null && value !== undefined;
}
//# sourceMappingURL=util_public_service.js.map