"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.TransactionWithCertChain = exports.TransactionInfoResponse = exports.TransactionInfoRequest = exports.protobufPackage = void 0;
const long_1 = __importDefault(require("long"));
const _m0 = __importStar(require("protobufjs/minimal"));
const transaction_1 = require("../managed/transaction");
exports.protobufPackage = "wavesenterprise";
function createBaseTransactionInfoRequest() {
    return { txId: "" };
}
exports.TransactionInfoRequest = {
    encode(message, writer = _m0.Writer.create()) {
        if (message.txId !== undefined && message.txId !== "") {
            writer.uint32(10).string(message.txId);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseTransactionInfoRequest();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.txId = reader.string();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        return {
            txId: isSet(object.txId) ? String(object.txId) : "",
        };
    },
    toJSON(message) {
        const obj = {};
        message.txId !== undefined && (obj.txId = message.txId);
        return obj;
    },
    fromPartial(object) {
        var _a;
        const message = createBaseTransactionInfoRequest();
        message.txId = (_a = object.txId) !== null && _a !== void 0 ? _a : "";
        return message;
    },
};
function createBaseTransactionInfoResponse() {
    return { height: 0, transaction: undefined };
}
exports.TransactionInfoResponse = {
    encode(message, writer = _m0.Writer.create()) {
        if (message.height !== undefined && message.height !== 0) {
            writer.uint32(8).int32(message.height);
        }
        if (message.transaction !== undefined) {
            transaction_1.Transaction.encode(message.transaction, writer.uint32(18).fork()).ldelim();
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseTransactionInfoResponse();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.height = reader.int32();
                    break;
                case 2:
                    message.transaction = transaction_1.Transaction.decode(reader, reader.uint32());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        return {
            height: isSet(object.height) ? Number(object.height) : 0,
            transaction: isSet(object.transaction)
                ? transaction_1.Transaction.fromJSON(object.transaction)
                : undefined,
        };
    },
    toJSON(message) {
        const obj = {};
        message.height !== undefined && (obj.height = Math.round(message.height));
        message.transaction !== undefined &&
            (obj.transaction = message.transaction
                ? transaction_1.Transaction.toJSON(message.transaction)
                : undefined);
        return obj;
    },
    fromPartial(object) {
        var _a;
        const message = createBaseTransactionInfoResponse();
        message.height = (_a = object.height) !== null && _a !== void 0 ? _a : 0;
        message.transaction =
            object.transaction !== undefined && object.transaction !== null
                ? transaction_1.Transaction.fromPartial(object.transaction)
                : undefined;
        return message;
    },
};
function createBaseTransactionWithCertChain() {
    return { transaction: undefined, certificates: [] };
}
exports.TransactionWithCertChain = {
    encode(message, writer = _m0.Writer.create()) {
        if (message.transaction !== undefined) {
            transaction_1.Transaction.encode(message.transaction, writer.uint32(10).fork()).ldelim();
        }
        if (message.certificates !== undefined &&
            message.certificates.length !== 0) {
            for (const v of message.certificates) {
                writer.uint32(18).bytes(v);
            }
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseTransactionWithCertChain();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.transaction = transaction_1.Transaction.decode(reader, reader.uint32());
                    break;
                case 2:
                    message.certificates.push(reader.bytes());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        return {
            transaction: isSet(object.transaction)
                ? transaction_1.Transaction.fromJSON(object.transaction)
                : undefined,
            certificates: Array.isArray(object === null || object === void 0 ? void 0 : object.certificates)
                ? object.certificates.map((e) => bytesFromBase64(e))
                : [],
        };
    },
    toJSON(message) {
        const obj = {};
        message.transaction !== undefined &&
            (obj.transaction = message.transaction
                ? transaction_1.Transaction.toJSON(message.transaction)
                : undefined);
        if (message.certificates) {
            obj.certificates = message.certificates.map((e) => base64FromBytes(e !== undefined ? e : new Uint8Array()));
        }
        else {
            obj.certificates = [];
        }
        return obj;
    },
    fromPartial(object) {
        var _a;
        const message = createBaseTransactionWithCertChain();
        message.transaction =
            object.transaction !== undefined && object.transaction !== null
                ? transaction_1.Transaction.fromPartial(object.transaction)
                : undefined;
        message.certificates = ((_a = object.certificates) === null || _a === void 0 ? void 0 : _a.map((e) => e)) || [];
        return message;
    },
};
var globalThis = (() => {
    if (typeof globalThis !== "undefined")
        return globalThis;
    if (typeof self !== "undefined")
        return self;
    if (typeof window !== "undefined")
        return window;
    if (typeof global !== "undefined")
        return global;
    throw "Unable to locate global object";
})();
const atob = globalThis.atob ||
    ((b64) => globalThis.Buffer.from(b64, "base64").toString("binary"));
function bytesFromBase64(b64) {
    const bin = atob(b64);
    const arr = new Uint8Array(bin.length);
    for (let i = 0; i < bin.length; ++i) {
        arr[i] = bin.charCodeAt(i);
    }
    return arr;
}
const btoa = globalThis.btoa ||
    ((bin) => globalThis.Buffer.from(bin, "binary").toString("base64"));
function base64FromBytes(arr) {
    const bin = [];
    for (const byte of arr) {
        bin.push(String.fromCharCode(byte));
    }
    return btoa(bin.join(""));
}
if (_m0.util.Long !== long_1.default) {
    _m0.util.Long = long_1.default;
    _m0.configure();
}
function isSet(value) {
    return value !== null && value !== undefined;
}
//# sourceMappingURL=util_transaction_service.js.map