"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ValidationPolicy_MajorityWithOneOf = exports.ValidationPolicy_Majority = exports.ValidationPolicy_Any = exports.ValidationPolicy = exports.protobufPackage = void 0;
const long_1 = __importDefault(require("long"));
const _m0 = __importStar(require("protobufjs/minimal"));
exports.protobufPackage = "wavesenterprise";
function createBaseValidationPolicy() {
    return { any: undefined, majority: undefined, majorityWithOneOf: undefined };
}
exports.ValidationPolicy = {
    encode(message, writer = _m0.Writer.create()) {
        if (message.any !== undefined) {
            exports.ValidationPolicy_Any.encode(message.any, writer.uint32(82).fork()).ldelim();
        }
        if (message.majority !== undefined) {
            exports.ValidationPolicy_Majority.encode(message.majority, writer.uint32(90).fork()).ldelim();
        }
        if (message.majorityWithOneOf !== undefined) {
            exports.ValidationPolicy_MajorityWithOneOf.encode(message.majorityWithOneOf, writer.uint32(98).fork()).ldelim();
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseValidationPolicy();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 10:
                    message.any = exports.ValidationPolicy_Any.decode(reader, reader.uint32());
                    break;
                case 11:
                    message.majority = exports.ValidationPolicy_Majority.decode(reader, reader.uint32());
                    break;
                case 12:
                    message.majorityWithOneOf = exports.ValidationPolicy_MajorityWithOneOf.decode(reader, reader.uint32());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        return {
            any: isSet(object.any)
                ? exports.ValidationPolicy_Any.fromJSON(object.any)
                : undefined,
            majority: isSet(object.majority)
                ? exports.ValidationPolicy_Majority.fromJSON(object.majority)
                : undefined,
            majorityWithOneOf: isSet(object.majorityWithOneOf)
                ? exports.ValidationPolicy_MajorityWithOneOf.fromJSON(object.majorityWithOneOf)
                : undefined,
        };
    },
    toJSON(message) {
        const obj = {};
        message.any !== undefined &&
            (obj.any = message.any
                ? exports.ValidationPolicy_Any.toJSON(message.any)
                : undefined);
        message.majority !== undefined &&
            (obj.majority = message.majority
                ? exports.ValidationPolicy_Majority.toJSON(message.majority)
                : undefined);
        message.majorityWithOneOf !== undefined &&
            (obj.majorityWithOneOf = message.majorityWithOneOf
                ? exports.ValidationPolicy_MajorityWithOneOf.toJSON(message.majorityWithOneOf)
                : undefined);
        return obj;
    },
    fromPartial(object) {
        const message = createBaseValidationPolicy();
        message.any =
            object.any !== undefined && object.any !== null
                ? exports.ValidationPolicy_Any.fromPartial(object.any)
                : undefined;
        message.majority =
            object.majority !== undefined && object.majority !== null
                ? exports.ValidationPolicy_Majority.fromPartial(object.majority)
                : undefined;
        message.majorityWithOneOf =
            object.majorityWithOneOf !== undefined &&
                object.majorityWithOneOf !== null
                ? exports.ValidationPolicy_MajorityWithOneOf.fromPartial(object.majorityWithOneOf)
                : undefined;
        return message;
    },
};
function createBaseValidationPolicy_Any() {
    return {};
}
exports.ValidationPolicy_Any = {
    encode(_, writer = _m0.Writer.create()) {
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseValidationPolicy_Any();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(_) {
        return {};
    },
    toJSON(_) {
        const obj = {};
        return obj;
    },
    fromPartial(_) {
        const message = createBaseValidationPolicy_Any();
        return message;
    },
};
function createBaseValidationPolicy_Majority() {
    return {};
}
exports.ValidationPolicy_Majority = {
    encode(_, writer = _m0.Writer.create()) {
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseValidationPolicy_Majority();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(_) {
        return {};
    },
    toJSON(_) {
        const obj = {};
        return obj;
    },
    fromPartial(_) {
        const message = createBaseValidationPolicy_Majority();
        return message;
    },
};
function createBaseValidationPolicy_MajorityWithOneOf() {
    return { addresses: [] };
}
exports.ValidationPolicy_MajorityWithOneOf = {
    encode(message, writer = _m0.Writer.create()) {
        if (message.addresses !== undefined && message.addresses.length !== 0) {
            for (const v of message.addresses) {
                writer.uint32(10).bytes(v);
            }
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseValidationPolicy_MajorityWithOneOf();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.addresses.push(reader.bytes());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        return {
            addresses: Array.isArray(object === null || object === void 0 ? void 0 : object.addresses)
                ? object.addresses.map((e) => bytesFromBase64(e))
                : [],
        };
    },
    toJSON(message) {
        const obj = {};
        if (message.addresses) {
            obj.addresses = message.addresses.map((e) => base64FromBytes(e !== undefined ? e : new Uint8Array()));
        }
        else {
            obj.addresses = [];
        }
        return obj;
    },
    fromPartial(object) {
        var _a;
        const message = createBaseValidationPolicy_MajorityWithOneOf();
        message.addresses = ((_a = object.addresses) === null || _a === void 0 ? void 0 : _a.map((e) => e)) || [];
        return message;
    },
};
var globalThis = (() => {
    if (typeof globalThis !== "undefined")
        return globalThis;
    if (typeof self !== "undefined")
        return self;
    if (typeof window !== "undefined")
        return window;
    if (typeof global !== "undefined")
        return global;
    throw "Unable to locate global object";
})();
const atob = globalThis.atob ||
    ((b64) => globalThis.Buffer.from(b64, "base64").toString("binary"));
function bytesFromBase64(b64) {
    const bin = atob(b64);
    const arr = new Uint8Array(bin.length);
    for (let i = 0; i < bin.length; ++i) {
        arr[i] = bin.charCodeAt(i);
    }
    return arr;
}
const btoa = globalThis.btoa ||
    ((bin) => globalThis.Buffer.from(bin, "binary").toString("base64"));
function base64FromBytes(arr) {
    const bin = [];
    for (const byte of arr) {
        bin.push(String.fromCharCode(byte));
    }
    return btoa(bin.join(""));
}
if (_m0.util.Long !== long_1.default) {
    _m0.util.Long = long_1.default;
    _m0.configure();
}
function isSet(value) {
    return value !== null && value !== undefined;
}
//# sourceMappingURL=validation_policy.js.map