"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.AliasPublicServiceClient = exports.AliasPublicServiceService = exports.AliasesResponse = exports.AliasRequest = exports.protobufPackage = void 0;
const long_1 = __importDefault(require("long"));
const grpc_js_1 = require("@grpc/grpc-js");
const _m0 = __importStar(require("protobufjs/minimal"));
const address_1 = require("../entity/address");
exports.protobufPackage = "wavesenterprise.grpc";
function createBaseAliasRequest() {
    return { alias: "" };
}
exports.AliasRequest = {
    encode(message, writer = _m0.Writer.create()) {
        if (message.alias !== undefined && message.alias !== "") {
            writer.uint32(10).string(message.alias);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseAliasRequest();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.alias = reader.string();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        return {
            alias: isSet(object.alias) ? String(object.alias) : "",
        };
    },
    toJSON(message) {
        const obj = {};
        message.alias !== undefined && (obj.alias = message.alias);
        return obj;
    },
    fromPartial(object) {
        var _a;
        const message = createBaseAliasRequest();
        message.alias = (_a = object.alias) !== null && _a !== void 0 ? _a : "";
        return message;
    },
};
function createBaseAliasesResponse() {
    return { aliases: [] };
}
exports.AliasesResponse = {
    encode(message, writer = _m0.Writer.create()) {
        if (message.aliases !== undefined && message.aliases.length !== 0) {
            for (const v of message.aliases) {
                writer.uint32(10).string(v);
            }
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseAliasesResponse();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.aliases.push(reader.string());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        return {
            aliases: Array.isArray(object === null || object === void 0 ? void 0 : object.aliases)
                ? object.aliases.map((e) => String(e))
                : [],
        };
    },
    toJSON(message) {
        const obj = {};
        if (message.aliases) {
            obj.aliases = message.aliases.map((e) => e);
        }
        else {
            obj.aliases = [];
        }
        return obj;
    },
    fromPartial(object) {
        var _a;
        const message = createBaseAliasesResponse();
        message.aliases = ((_a = object.aliases) === null || _a === void 0 ? void 0 : _a.map((e) => e)) || [];
        return message;
    },
};
exports.AliasPublicServiceService = {
    addressByAlias: {
        path: "/wavesenterprise.grpc.AliasPublicService/AddressByAlias",
        requestStream: false,
        responseStream: false,
        requestSerialize: (value) => Buffer.from(exports.AliasRequest.encode(value).finish()),
        requestDeserialize: (value) => exports.AliasRequest.decode(value),
        responseSerialize: (value) => Buffer.from(address_1.AddressResponse.encode(value).finish()),
        responseDeserialize: (value) => address_1.AddressResponse.decode(value),
    },
    aliasesByAddress: {
        path: "/wavesenterprise.grpc.AliasPublicService/AliasesByAddress",
        requestStream: false,
        responseStream: false,
        requestSerialize: (value) => Buffer.from(address_1.AddressRequest.encode(value).finish()),
        requestDeserialize: (value) => address_1.AddressRequest.decode(value),
        responseSerialize: (value) => Buffer.from(exports.AliasesResponse.encode(value).finish()),
        responseDeserialize: (value) => exports.AliasesResponse.decode(value),
    },
};
exports.AliasPublicServiceClient = (0, grpc_js_1.makeGenericClientConstructor)(exports.AliasPublicServiceService, "wavesenterprise.grpc.AliasPublicService");
if (_m0.util.Long !== long_1.default) {
    _m0.util.Long = long_1.default;
    _m0.configure();
}
function isSet(value) {
    return value !== null && value !== undefined;
}
//# sourceMappingURL=alias_public_service.js.map