export declare const protobufPackage = "wavesenterprise";
export declare enum CryptoAlgo {
    UNKNOWN_CRYPTO_ALGO = 0,
    GOST_3412_2015_K = 2,
    AES = 3,
    UNRECOGNIZED = -1
}
export declare function cryptoAlgoFromJSON(object: any): CryptoAlgo;
export declare function cryptoAlgoToJSON(object: CryptoAlgo): string;
export declare enum CryptoType {
    UNKNOWN_CRYPTO_TYPE = 0,
    GOST = 1,
    CURVE_25519 = 2,
    UNRECOGNIZED = -1
}
export declare function cryptoTypeFromJSON(object: any): CryptoType;
export declare function cryptoTypeToJSON(object: CryptoType): string;
export declare enum ConsensusType {
    UNKNOWN_CONSENSUS_TYPE = 0,
    POA = 1,
    POS = 2,
    CFT = 3,
    UNRECOGNIZED = -1
}
export declare function consensusTypeFromJSON(object: any): ConsensusType;
export declare function consensusTypeToJSON(object: ConsensusType): string;
export declare enum PkiMode {
    UNKNOWN_PKI_MODE = 0,
    ON = 1,
    OFF = 2,
    TEST = 3,
    UNRECOGNIZED = -1
}
export declare function pkiModeFromJSON(object: any): PkiMode;
export declare function pkiModeToJSON(object: PkiMode): string;
