"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.PrivacyServiceClient = exports.PrivacyServiceService = exports.PolicyItemFileInfo = exports.PolicyItemInfoResponse = exports.PolicyItemInfoRequest = exports.PolicyItemDataResponse = exports.PolicyItemDataRequest = exports.PolicyHashesResponse = exports.PolicyHashesRequest = exports.PolicyOwnersResponse = exports.PolicyOwnersRequest = exports.PolicyRecipientsResponse = exports.PolicyRecipientsRequest = exports.protobufPackage = void 0;
const long_1 = __importDefault(require("long"));
const grpc_js_1 = require("@grpc/grpc-js");
const _m0 = __importStar(require("protobufjs/minimal"));
exports.protobufPackage = "wavesenterprise";
function createBasePolicyRecipientsRequest() {
    return { policyId: "" };
}
exports.PolicyRecipientsRequest = {
    encode(message, writer = _m0.Writer.create()) {
        if (message.policyId !== undefined && message.policyId !== "") {
            writer.uint32(10).string(message.policyId);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBasePolicyRecipientsRequest();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.policyId = reader.string();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        return {
            policyId: isSet(object.policyId) ? String(object.policyId) : "",
        };
    },
    toJSON(message) {
        const obj = {};
        message.policyId !== undefined && (obj.policyId = message.policyId);
        return obj;
    },
    fromPartial(object) {
        var _a;
        const message = createBasePolicyRecipientsRequest();
        message.policyId = (_a = object.policyId) !== null && _a !== void 0 ? _a : "";
        return message;
    },
};
function createBasePolicyRecipientsResponse() {
    return { recipients: [] };
}
exports.PolicyRecipientsResponse = {
    encode(message, writer = _m0.Writer.create()) {
        if (message.recipients !== undefined && message.recipients.length !== 0) {
            for (const v of message.recipients) {
                writer.uint32(10).string(v);
            }
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBasePolicyRecipientsResponse();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.recipients.push(reader.string());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        return {
            recipients: Array.isArray(object === null || object === void 0 ? void 0 : object.recipients)
                ? object.recipients.map((e) => String(e))
                : [],
        };
    },
    toJSON(message) {
        const obj = {};
        if (message.recipients) {
            obj.recipients = message.recipients.map((e) => e);
        }
        else {
            obj.recipients = [];
        }
        return obj;
    },
    fromPartial(object) {
        var _a;
        const message = createBasePolicyRecipientsResponse();
        message.recipients = ((_a = object.recipients) === null || _a === void 0 ? void 0 : _a.map((e) => e)) || [];
        return message;
    },
};
function createBasePolicyOwnersRequest() {
    return { policyId: "" };
}
exports.PolicyOwnersRequest = {
    encode(message, writer = _m0.Writer.create()) {
        if (message.policyId !== undefined && message.policyId !== "") {
            writer.uint32(10).string(message.policyId);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBasePolicyOwnersRequest();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.policyId = reader.string();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        return {
            policyId: isSet(object.policyId) ? String(object.policyId) : "",
        };
    },
    toJSON(message) {
        const obj = {};
        message.policyId !== undefined && (obj.policyId = message.policyId);
        return obj;
    },
    fromPartial(object) {
        var _a;
        const message = createBasePolicyOwnersRequest();
        message.policyId = (_a = object.policyId) !== null && _a !== void 0 ? _a : "";
        return message;
    },
};
function createBasePolicyOwnersResponse() {
    return { owners: [] };
}
exports.PolicyOwnersResponse = {
    encode(message, writer = _m0.Writer.create()) {
        if (message.owners !== undefined && message.owners.length !== 0) {
            for (const v of message.owners) {
                writer.uint32(10).string(v);
            }
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBasePolicyOwnersResponse();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.owners.push(reader.string());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        return {
            owners: Array.isArray(object === null || object === void 0 ? void 0 : object.owners)
                ? object.owners.map((e) => String(e))
                : [],
        };
    },
    toJSON(message) {
        const obj = {};
        if (message.owners) {
            obj.owners = message.owners.map((e) => e);
        }
        else {
            obj.owners = [];
        }
        return obj;
    },
    fromPartial(object) {
        var _a;
        const message = createBasePolicyOwnersResponse();
        message.owners = ((_a = object.owners) === null || _a === void 0 ? void 0 : _a.map((e) => e)) || [];
        return message;
    },
};
function createBasePolicyHashesRequest() {
    return { policyId: "" };
}
exports.PolicyHashesRequest = {
    encode(message, writer = _m0.Writer.create()) {
        if (message.policyId !== undefined && message.policyId !== "") {
            writer.uint32(10).string(message.policyId);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBasePolicyHashesRequest();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.policyId = reader.string();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        return {
            policyId: isSet(object.policyId) ? String(object.policyId) : "",
        };
    },
    toJSON(message) {
        const obj = {};
        message.policyId !== undefined && (obj.policyId = message.policyId);
        return obj;
    },
    fromPartial(object) {
        var _a;
        const message = createBasePolicyHashesRequest();
        message.policyId = (_a = object.policyId) !== null && _a !== void 0 ? _a : "";
        return message;
    },
};
function createBasePolicyHashesResponse() {
    return { hashes: [] };
}
exports.PolicyHashesResponse = {
    encode(message, writer = _m0.Writer.create()) {
        if (message.hashes !== undefined && message.hashes.length !== 0) {
            for (const v of message.hashes) {
                writer.uint32(10).string(v);
            }
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBasePolicyHashesResponse();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.hashes.push(reader.string());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        return {
            hashes: Array.isArray(object === null || object === void 0 ? void 0 : object.hashes)
                ? object.hashes.map((e) => String(e))
                : [],
        };
    },
    toJSON(message) {
        const obj = {};
        if (message.hashes) {
            obj.hashes = message.hashes.map((e) => e);
        }
        else {
            obj.hashes = [];
        }
        return obj;
    },
    fromPartial(object) {
        var _a;
        const message = createBasePolicyHashesResponse();
        message.hashes = ((_a = object.hashes) === null || _a === void 0 ? void 0 : _a.map((e) => e)) || [];
        return message;
    },
};
function createBasePolicyItemDataRequest() {
    return { policyId: "", itemHash: "" };
}
exports.PolicyItemDataRequest = {
    encode(message, writer = _m0.Writer.create()) {
        if (message.policyId !== undefined && message.policyId !== "") {
            writer.uint32(10).string(message.policyId);
        }
        if (message.itemHash !== undefined && message.itemHash !== "") {
            writer.uint32(18).string(message.itemHash);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBasePolicyItemDataRequest();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.policyId = reader.string();
                    break;
                case 2:
                    message.itemHash = reader.string();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        return {
            policyId: isSet(object.policyId) ? String(object.policyId) : "",
            itemHash: isSet(object.itemHash) ? String(object.itemHash) : "",
        };
    },
    toJSON(message) {
        const obj = {};
        message.policyId !== undefined && (obj.policyId = message.policyId);
        message.itemHash !== undefined && (obj.itemHash = message.itemHash);
        return obj;
    },
    fromPartial(object) {
        var _a, _b;
        const message = createBasePolicyItemDataRequest();
        message.policyId = (_a = object.policyId) !== null && _a !== void 0 ? _a : "";
        message.itemHash = (_b = object.itemHash) !== null && _b !== void 0 ? _b : "";
        return message;
    },
};
function createBasePolicyItemDataResponse() {
    return { data: "" };
}
exports.PolicyItemDataResponse = {
    encode(message, writer = _m0.Writer.create()) {
        if (message.data !== undefined && message.data !== "") {
            writer.uint32(10).string(message.data);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBasePolicyItemDataResponse();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.data = reader.string();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        return {
            data: isSet(object.data) ? String(object.data) : "",
        };
    },
    toJSON(message) {
        const obj = {};
        message.data !== undefined && (obj.data = message.data);
        return obj;
    },
    fromPartial(object) {
        var _a;
        const message = createBasePolicyItemDataResponse();
        message.data = (_a = object.data) !== null && _a !== void 0 ? _a : "";
        return message;
    },
};
function createBasePolicyItemInfoRequest() {
    return { policyId: "", itemHash: "" };
}
exports.PolicyItemInfoRequest = {
    encode(message, writer = _m0.Writer.create()) {
        if (message.policyId !== undefined && message.policyId !== "") {
            writer.uint32(10).string(message.policyId);
        }
        if (message.itemHash !== undefined && message.itemHash !== "") {
            writer.uint32(18).string(message.itemHash);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBasePolicyItemInfoRequest();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.policyId = reader.string();
                    break;
                case 2:
                    message.itemHash = reader.string();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        return {
            policyId: isSet(object.policyId) ? String(object.policyId) : "",
            itemHash: isSet(object.itemHash) ? String(object.itemHash) : "",
        };
    },
    toJSON(message) {
        const obj = {};
        message.policyId !== undefined && (obj.policyId = message.policyId);
        message.itemHash !== undefined && (obj.itemHash = message.itemHash);
        return obj;
    },
    fromPartial(object) {
        var _a, _b;
        const message = createBasePolicyItemInfoRequest();
        message.policyId = (_a = object.policyId) !== null && _a !== void 0 ? _a : "";
        message.itemHash = (_b = object.itemHash) !== null && _b !== void 0 ? _b : "";
        return message;
    },
};
function createBasePolicyItemInfoResponse() {
    return { sender: "", policyId: "", type: "", info: undefined, hash: "" };
}
exports.PolicyItemInfoResponse = {
    encode(message, writer = _m0.Writer.create()) {
        if (message.sender !== undefined && message.sender !== "") {
            writer.uint32(10).string(message.sender);
        }
        if (message.policyId !== undefined && message.policyId !== "") {
            writer.uint32(18).string(message.policyId);
        }
        if (message.type !== undefined && message.type !== "") {
            writer.uint32(26).string(message.type);
        }
        if (message.info !== undefined) {
            exports.PolicyItemFileInfo.encode(message.info, writer.uint32(34).fork()).ldelim();
        }
        if (message.hash !== undefined && message.hash !== "") {
            writer.uint32(42).string(message.hash);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBasePolicyItemInfoResponse();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.sender = reader.string();
                    break;
                case 2:
                    message.policyId = reader.string();
                    break;
                case 3:
                    message.type = reader.string();
                    break;
                case 4:
                    message.info = exports.PolicyItemFileInfo.decode(reader, reader.uint32());
                    break;
                case 5:
                    message.hash = reader.string();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        return {
            sender: isSet(object.sender) ? String(object.sender) : "",
            policyId: isSet(object.policyId) ? String(object.policyId) : "",
            type: isSet(object.type) ? String(object.type) : "",
            info: isSet(object.info)
                ? exports.PolicyItemFileInfo.fromJSON(object.info)
                : undefined,
            hash: isSet(object.hash) ? String(object.hash) : "",
        };
    },
    toJSON(message) {
        const obj = {};
        message.sender !== undefined && (obj.sender = message.sender);
        message.policyId !== undefined && (obj.policyId = message.policyId);
        message.type !== undefined && (obj.type = message.type);
        message.info !== undefined &&
            (obj.info = message.info
                ? exports.PolicyItemFileInfo.toJSON(message.info)
                : undefined);
        message.hash !== undefined && (obj.hash = message.hash);
        return obj;
    },
    fromPartial(object) {
        var _a, _b, _c, _d;
        const message = createBasePolicyItemInfoResponse();
        message.sender = (_a = object.sender) !== null && _a !== void 0 ? _a : "";
        message.policyId = (_b = object.policyId) !== null && _b !== void 0 ? _b : "";
        message.type = (_c = object.type) !== null && _c !== void 0 ? _c : "";
        message.info =
            object.info !== undefined && object.info !== null
                ? exports.PolicyItemFileInfo.fromPartial(object.info)
                : undefined;
        message.hash = (_d = object.hash) !== null && _d !== void 0 ? _d : "";
        return message;
    },
};
function createBasePolicyItemFileInfo() {
    return {
        filename: "",
        size: 0,
        timestamp: long_1.default.ZERO,
        author: "",
        comment: "",
    };
}
exports.PolicyItemFileInfo = {
    encode(message, writer = _m0.Writer.create()) {
        if (message.filename !== undefined && message.filename !== "") {
            writer.uint32(10).string(message.filename);
        }
        if (message.size !== undefined && message.size !== 0) {
            writer.uint32(16).int32(message.size);
        }
        if (message.timestamp !== undefined && !message.timestamp.isZero()) {
            writer.uint32(24).int64(message.timestamp);
        }
        if (message.author !== undefined && message.author !== "") {
            writer.uint32(34).string(message.author);
        }
        if (message.comment !== undefined && message.comment !== "") {
            writer.uint32(42).string(message.comment);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBasePolicyItemFileInfo();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.filename = reader.string();
                    break;
                case 2:
                    message.size = reader.int32();
                    break;
                case 3:
                    message.timestamp = reader.int64();
                    break;
                case 4:
                    message.author = reader.string();
                    break;
                case 5:
                    message.comment = reader.string();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        return {
            filename: isSet(object.filename) ? String(object.filename) : "",
            size: isSet(object.size) ? Number(object.size) : 0,
            timestamp: isSet(object.timestamp)
                ? long_1.default.fromString(object.timestamp)
                : long_1.default.ZERO,
            author: isSet(object.author) ? String(object.author) : "",
            comment: isSet(object.comment) ? String(object.comment) : "",
        };
    },
    toJSON(message) {
        const obj = {};
        message.filename !== undefined && (obj.filename = message.filename);
        message.size !== undefined && (obj.size = Math.round(message.size));
        message.timestamp !== undefined &&
            (obj.timestamp = (message.timestamp || long_1.default.ZERO).toString());
        message.author !== undefined && (obj.author = message.author);
        message.comment !== undefined && (obj.comment = message.comment);
        return obj;
    },
    fromPartial(object) {
        var _a, _b, _c, _d;
        const message = createBasePolicyItemFileInfo();
        message.filename = (_a = object.filename) !== null && _a !== void 0 ? _a : "";
        message.size = (_b = object.size) !== null && _b !== void 0 ? _b : 0;
        message.timestamp =
            object.timestamp !== undefined && object.timestamp !== null
                ? long_1.default.fromValue(object.timestamp)
                : long_1.default.ZERO;
        message.author = (_c = object.author) !== null && _c !== void 0 ? _c : "";
        message.comment = (_d = object.comment) !== null && _d !== void 0 ? _d : "";
        return message;
    },
};
exports.PrivacyServiceService = {
    getPolicyRecipients: {
        path: "/wavesenterprise.PrivacyService/GetPolicyRecipients",
        requestStream: false,
        responseStream: false,
        requestSerialize: (value) => Buffer.from(exports.PolicyRecipientsRequest.encode(value).finish()),
        requestDeserialize: (value) => exports.PolicyRecipientsRequest.decode(value),
        responseSerialize: (value) => Buffer.from(exports.PolicyRecipientsResponse.encode(value).finish()),
        responseDeserialize: (value) => exports.PolicyRecipientsResponse.decode(value),
    },
    getPolicyOwners: {
        path: "/wavesenterprise.PrivacyService/GetPolicyOwners",
        requestStream: false,
        responseStream: false,
        requestSerialize: (value) => Buffer.from(exports.PolicyOwnersRequest.encode(value).finish()),
        requestDeserialize: (value) => exports.PolicyOwnersRequest.decode(value),
        responseSerialize: (value) => Buffer.from(exports.PolicyOwnersResponse.encode(value).finish()),
        responseDeserialize: (value) => exports.PolicyOwnersResponse.decode(value),
    },
    getPolicyHashes: {
        path: "/wavesenterprise.PrivacyService/GetPolicyHashes",
        requestStream: false,
        responseStream: false,
        requestSerialize: (value) => Buffer.from(exports.PolicyHashesRequest.encode(value).finish()),
        requestDeserialize: (value) => exports.PolicyHashesRequest.decode(value),
        responseSerialize: (value) => Buffer.from(exports.PolicyHashesResponse.encode(value).finish()),
        responseDeserialize: (value) => exports.PolicyHashesResponse.decode(value),
    },
    getPolicyItemData: {
        path: "/wavesenterprise.PrivacyService/GetPolicyItemData",
        requestStream: false,
        responseStream: false,
        requestSerialize: (value) => Buffer.from(exports.PolicyItemDataRequest.encode(value).finish()),
        requestDeserialize: (value) => exports.PolicyItemDataRequest.decode(value),
        responseSerialize: (value) => Buffer.from(exports.PolicyItemDataResponse.encode(value).finish()),
        responseDeserialize: (value) => exports.PolicyItemDataResponse.decode(value),
    },
    getPolicyItemInfo: {
        path: "/wavesenterprise.PrivacyService/GetPolicyItemInfo",
        requestStream: false,
        responseStream: false,
        requestSerialize: (value) => Buffer.from(exports.PolicyItemInfoRequest.encode(value).finish()),
        requestDeserialize: (value) => exports.PolicyItemInfoRequest.decode(value),
        responseSerialize: (value) => Buffer.from(exports.PolicyItemInfoResponse.encode(value).finish()),
        responseDeserialize: (value) => exports.PolicyItemInfoResponse.decode(value),
    },
};
exports.PrivacyServiceClient = (0, grpc_js_1.makeGenericClientConstructor)(exports.PrivacyServiceService, "wavesenterprise.PrivacyService");
if (_m0.util.Long !== long_1.default) {
    _m0.util.Long = long_1.default;
    _m0.configure();
}
function isSet(value) {
    return value !== null && value !== undefined;
}
//# sourceMappingURL=contract_privacy_service.js.map