"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.TransactionServiceClient = exports.TransactionServiceService = exports.TransactionExistsResponse = exports.TransactionExistsRequest = exports.protobufPackage = void 0;
const long_1 = __importDefault(require("long"));
const grpc_js_1 = require("@grpc/grpc-js");
const _m0 = __importStar(require("protobufjs/minimal"));
const util_transaction_service_1 = require("../util/util_transaction_service");
exports.protobufPackage = "wavesenterprise";
function createBaseTransactionExistsRequest() {
    return { txId: "" };
}
exports.TransactionExistsRequest = {
    encode(message, writer = _m0.Writer.create()) {
        if (message.txId !== undefined && message.txId !== "") {
            writer.uint32(10).string(message.txId);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseTransactionExistsRequest();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.txId = reader.string();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        return {
            txId: isSet(object.txId) ? String(object.txId) : "",
        };
    },
    toJSON(message) {
        const obj = {};
        message.txId !== undefined && (obj.txId = message.txId);
        return obj;
    },
    fromPartial(object) {
        var _a;
        const message = createBaseTransactionExistsRequest();
        message.txId = (_a = object.txId) !== null && _a !== void 0 ? _a : "";
        return message;
    },
};
function createBaseTransactionExistsResponse() {
    return { exists: false };
}
exports.TransactionExistsResponse = {
    encode(message, writer = _m0.Writer.create()) {
        if (message.exists === true) {
            writer.uint32(8).bool(message.exists);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseTransactionExistsResponse();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.exists = reader.bool();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        return {
            exists: isSet(object.exists) ? Boolean(object.exists) : false,
        };
    },
    toJSON(message) {
        const obj = {};
        message.exists !== undefined && (obj.exists = message.exists);
        return obj;
    },
    fromPartial(object) {
        var _a;
        const message = createBaseTransactionExistsResponse();
        message.exists = (_a = object.exists) !== null && _a !== void 0 ? _a : false;
        return message;
    },
};
exports.TransactionServiceService = {
    transactionExists: {
        path: "/wavesenterprise.TransactionService/TransactionExists",
        requestStream: false,
        responseStream: false,
        requestSerialize: (value) => Buffer.from(exports.TransactionExistsRequest.encode(value).finish()),
        requestDeserialize: (value) => exports.TransactionExistsRequest.decode(value),
        responseSerialize: (value) => Buffer.from(exports.TransactionExistsResponse.encode(value).finish()),
        responseDeserialize: (value) => exports.TransactionExistsResponse.decode(value),
    },
    transactionInfo: {
        path: "/wavesenterprise.TransactionService/TransactionInfo",
        requestStream: false,
        responseStream: false,
        requestSerialize: (value) => Buffer.from(util_transaction_service_1.TransactionInfoRequest.encode(value).finish()),
        requestDeserialize: (value) => util_transaction_service_1.TransactionInfoRequest.decode(value),
        responseSerialize: (value) => Buffer.from(util_transaction_service_1.TransactionInfoResponse.encode(value).finish()),
        responseDeserialize: (value) => util_transaction_service_1.TransactionInfoResponse.decode(value),
    },
};
exports.TransactionServiceClient = (0, grpc_js_1.makeGenericClientConstructor)(exports.TransactionServiceService, "wavesenterprise.TransactionService");
if (_m0.util.Long !== long_1.default) {
    _m0.util.Long = long_1.default;
    _m0.configure();
}
function isSet(value) {
    return value !== null && value !== undefined;
}
//# sourceMappingURL=contract_transaction_service.js.map