"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.DataEntry = exports.protobufPackage = void 0;
const long_1 = __importDefault(require("long"));
const _m0 = __importStar(require("protobufjs/minimal"));
exports.protobufPackage = "wavesenterprise";
function createBaseDataEntry() {
    return {
        key: "",
        intValue: undefined,
        boolValue: undefined,
        binaryValue: undefined,
        stringValue: undefined,
    };
}
exports.DataEntry = {
    encode(message, writer = _m0.Writer.create()) {
        if (message.key !== undefined && message.key !== "") {
            writer.uint32(10).string(message.key);
        }
        if (message.intValue !== undefined) {
            writer.uint32(80).int64(message.intValue);
        }
        if (message.boolValue !== undefined) {
            writer.uint32(88).bool(message.boolValue);
        }
        if (message.binaryValue !== undefined) {
            writer.uint32(98).bytes(message.binaryValue);
        }
        if (message.stringValue !== undefined) {
            writer.uint32(106).string(message.stringValue);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseDataEntry();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.key = reader.string();
                    break;
                case 10:
                    message.intValue = reader.int64();
                    break;
                case 11:
                    message.boolValue = reader.bool();
                    break;
                case 12:
                    message.binaryValue = reader.bytes();
                    break;
                case 13:
                    message.stringValue = reader.string();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        return {
            key: isSet(object.key) ? String(object.key) : "",
            intValue: isSet(object.intValue)
                ? long_1.default.fromString(object.intValue)
                : undefined,
            boolValue: isSet(object.boolValue)
                ? Boolean(object.boolValue)
                : undefined,
            binaryValue: isSet(object.binaryValue)
                ? bytesFromBase64(object.binaryValue)
                : undefined,
            stringValue: isSet(object.stringValue)
                ? String(object.stringValue)
                : undefined,
        };
    },
    toJSON(message) {
        const obj = {};
        message.key !== undefined && (obj.key = message.key);
        message.intValue !== undefined &&
            (obj.intValue = (message.intValue || undefined).toString());
        message.boolValue !== undefined && (obj.boolValue = message.boolValue);
        message.binaryValue !== undefined &&
            (obj.binaryValue =
                message.binaryValue !== undefined
                    ? base64FromBytes(message.binaryValue)
                    : undefined);
        message.stringValue !== undefined &&
            (obj.stringValue = message.stringValue);
        return obj;
    },
    fromPartial(object) {
        var _a, _b, _c, _d;
        const message = createBaseDataEntry();
        message.key = (_a = object.key) !== null && _a !== void 0 ? _a : "";
        message.intValue =
            object.intValue !== undefined && object.intValue !== null
                ? long_1.default.fromValue(object.intValue)
                : undefined;
        message.boolValue = (_b = object.boolValue) !== null && _b !== void 0 ? _b : undefined;
        message.binaryValue = (_c = object.binaryValue) !== null && _c !== void 0 ? _c : undefined;
        message.stringValue = (_d = object.stringValue) !== null && _d !== void 0 ? _d : undefined;
        return message;
    },
};
var globalThis = (() => {
    if (typeof globalThis !== "undefined")
        return globalThis;
    if (typeof self !== "undefined")
        return self;
    if (typeof window !== "undefined")
        return window;
    if (typeof global !== "undefined")
        return global;
    throw "Unable to locate global object";
})();
const atob = globalThis.atob ||
    ((b64) => globalThis.Buffer.from(b64, "base64").toString("binary"));
function bytesFromBase64(b64) {
    const bin = atob(b64);
    const arr = new Uint8Array(bin.length);
    for (let i = 0; i < bin.length; ++i) {
        arr[i] = bin.charCodeAt(i);
    }
    return arr;
}
const btoa = globalThis.btoa ||
    ((bin) => globalThis.Buffer.from(bin, "binary").toString("base64"));
function base64FromBytes(arr) {
    const bin = [];
    for (const byte of arr) {
        bin.push(String.fromCharCode(byte));
    }
    return btoa(bin.join(""));
}
if (_m0.util.Long !== long_1.default) {
    _m0.util.Long = long_1.default;
    _m0.configure();
}
function isSet(value) {
    return value !== null && value !== undefined;
}
//# sourceMappingURL=data_entry.js.map