"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ExecutableTransaction = exports.protobufPackage = void 0;
const long_1 = __importDefault(require("long"));
const _m0 = __importStar(require("protobufjs/minimal"));
const create_contract_transaction_1 = require("./managed/create_contract_transaction");
const call_contract_transaction_1 = require("./managed/call_contract_transaction");
const update_contract_transaction_1 = require("./managed/update_contract_transaction");
exports.protobufPackage = "wavesenterprise";
function createBaseExecutableTransaction() {
    return {
        version: 0,
        createContractTransaction: undefined,
        callContractTransaction: undefined,
        updateContractTransaction: undefined,
    };
}
exports.ExecutableTransaction = {
    encode(message, writer = _m0.Writer.create()) {
        if (message.version !== undefined && message.version !== 0) {
            writer.uint32(8).int32(message.version);
        }
        if (message.createContractTransaction !== undefined) {
            create_contract_transaction_1.CreateContractTransaction.encode(message.createContractTransaction, writer.uint32(8002).fork()).ldelim();
        }
        if (message.callContractTransaction !== undefined) {
            call_contract_transaction_1.CallContractTransaction.encode(message.callContractTransaction, writer.uint32(8010).fork()).ldelim();
        }
        if (message.updateContractTransaction !== undefined) {
            update_contract_transaction_1.UpdateContractTransaction.encode(message.updateContractTransaction, writer.uint32(8018).fork()).ldelim();
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseExecutableTransaction();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.version = reader.int32();
                    break;
                case 1000:
                    message.createContractTransaction = create_contract_transaction_1.CreateContractTransaction.decode(reader, reader.uint32());
                    break;
                case 1001:
                    message.callContractTransaction = call_contract_transaction_1.CallContractTransaction.decode(reader, reader.uint32());
                    break;
                case 1002:
                    message.updateContractTransaction = update_contract_transaction_1.UpdateContractTransaction.decode(reader, reader.uint32());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        return {
            version: isSet(object.version) ? Number(object.version) : 0,
            createContractTransaction: isSet(object.createContractTransaction)
                ? create_contract_transaction_1.CreateContractTransaction.fromJSON(object.createContractTransaction)
                : undefined,
            callContractTransaction: isSet(object.callContractTransaction)
                ? call_contract_transaction_1.CallContractTransaction.fromJSON(object.callContractTransaction)
                : undefined,
            updateContractTransaction: isSet(object.updateContractTransaction)
                ? update_contract_transaction_1.UpdateContractTransaction.fromJSON(object.updateContractTransaction)
                : undefined,
        };
    },
    toJSON(message) {
        const obj = {};
        message.version !== undefined &&
            (obj.version = Math.round(message.version));
        message.createContractTransaction !== undefined &&
            (obj.createContractTransaction = message.createContractTransaction
                ? create_contract_transaction_1.CreateContractTransaction.toJSON(message.createContractTransaction)
                : undefined);
        message.callContractTransaction !== undefined &&
            (obj.callContractTransaction = message.callContractTransaction
                ? call_contract_transaction_1.CallContractTransaction.toJSON(message.callContractTransaction)
                : undefined);
        message.updateContractTransaction !== undefined &&
            (obj.updateContractTransaction = message.updateContractTransaction
                ? update_contract_transaction_1.UpdateContractTransaction.toJSON(message.updateContractTransaction)
                : undefined);
        return obj;
    },
    fromPartial(object) {
        var _a;
        const message = createBaseExecutableTransaction();
        message.version = (_a = object.version) !== null && _a !== void 0 ? _a : 0;
        message.createContractTransaction =
            object.createContractTransaction !== undefined &&
                object.createContractTransaction !== null
                ? create_contract_transaction_1.CreateContractTransaction.fromPartial(object.createContractTransaction)
                : undefined;
        message.callContractTransaction =
            object.callContractTransaction !== undefined &&
                object.callContractTransaction !== null
                ? call_contract_transaction_1.CallContractTransaction.fromPartial(object.callContractTransaction)
                : undefined;
        message.updateContractTransaction =
            object.updateContractTransaction !== undefined &&
                object.updateContractTransaction !== null
                ? update_contract_transaction_1.UpdateContractTransaction.fromPartial(object.updateContractTransaction)
                : undefined;
        return message;
    },
};
if (_m0.util.Long !== long_1.default) {
    _m0.util.Long = long_1.default;
    _m0.configure();
}
function isSet(value) {
    return value !== null && value !== undefined;
}
//# sourceMappingURL=executable_contract_transaction.js.map