import Long from "long";
import * as _m0 from "protobufjs/minimal";
export declare const protobufPackage = "wavesenterprise";
export interface GenesisTransaction {
    id?: Uint8Array;
    recipient?: Uint8Array;
    amount?: Long;
    fee?: Long;
    timestamp?: Long;
    signature?: Uint8Array;
}
export declare const GenesisTransaction: {
    encode(message: GenesisTransaction, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): GenesisTransaction;
    fromJSON(object: any): GenesisTransaction;
    toJSON(message: GenesisTransaction): unknown;
    fromPartial(object: DeepPartial<GenesisTransaction>): GenesisTransaction;
};
declare type Builtin = Date | Function | Uint8Array | string | number | boolean | undefined;
export declare type DeepPartial<T> = T extends Builtin ? T : T extends Long ? string | number | Long : T extends Array<infer U> ? Array<DeepPartial<U>> : T extends ReadonlyArray<infer U> ? ReadonlyArray<DeepPartial<U>> : T extends {} ? {
    [K in keyof T]?: DeepPartial<T[K]>;
} : Partial<T>;
export {};
