import Long from "long";
import * as _m0 from "protobufjs/minimal";
import { AtomicInnerTransaction } from "../managed/atomic_inner_transaction";
export declare const protobufPackage = "wavesenterprise";
export interface AtomicTransaction {
    id?: Uint8Array;
    senderPublicKey?: Uint8Array;
    miner?: Uint8Array;
    transactions?: AtomicInnerTransaction[];
    timestamp?: Long;
    proofs?: Uint8Array[];
    senderAddress?: Uint8Array;
}
export declare const AtomicTransaction: {
    encode(message: AtomicTransaction, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): AtomicTransaction;
    fromJSON(object: any): AtomicTransaction;
    toJSON(message: AtomicTransaction): unknown;
    fromPartial(object: DeepPartial<AtomicTransaction>): AtomicTransaction;
};
declare type Builtin = Date | Function | Uint8Array | string | number | boolean | undefined;
export declare type DeepPartial<T> = T extends Builtin ? T : T extends Long ? string | number | Long : T extends Array<infer U> ? Array<DeepPartial<U>> : T extends ReadonlyArray<infer U> ? ReadonlyArray<DeepPartial<U>> : T extends {} ? {
    [K in keyof T]?: DeepPartial<T[K]>;
} : Partial<T>;
export {};
