import Long from "long";
import * as _m0 from "protobufjs/minimal";
import { PermissionOp } from "../permission_op";
import { AtomicBadge } from "../atomic_badge";
export declare const protobufPackage = "wavesenterprise";
export interface PermitTransaction {
    id?: Uint8Array;
    senderPublicKey?: Uint8Array;
    target?: Uint8Array;
    timestamp?: Long;
    fee?: Long;
    permissionOp?: PermissionOp;
    atomicBadge?: AtomicBadge;
    proofs?: Uint8Array[];
    senderAddress?: Uint8Array;
}
export declare const PermitTransaction: {
    encode(message: PermitTransaction, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): PermitTransaction;
    fromJSON(object: any): PermitTransaction;
    toJSON(message: PermitTransaction): unknown;
    fromPartial(object: DeepPartial<PermitTransaction>): PermitTransaction;
};
declare type Builtin = Date | Function | Uint8Array | string | number | boolean | undefined;
export declare type DeepPartial<T> = T extends Builtin ? T : T extends Long ? string | number | Long : T extends Array<infer U> ? Array<DeepPartial<U>> : T extends ReadonlyArray<infer U> ? ReadonlyArray<DeepPartial<U>> : T extends {} ? {
    [K in keyof T]?: DeepPartial<T[K]>;
} : Partial<T>;
export {};
