import Long from "long";
import * as _m0 from "protobufjs/minimal";
import { OpType } from "../op_type";
export declare const protobufPackage = "wavesenterprise";
export interface RegisterNodeTransaction {
    id?: Uint8Array;
    senderPublicKey?: Uint8Array;
    target?: Uint8Array;
    nodeName?: string;
    opType?: OpType;
    timestamp?: Long;
    fee?: Long;
    proofs?: Uint8Array[];
    senderAddress?: Uint8Array;
}
export declare const RegisterNodeTransaction: {
    encode(message: RegisterNodeTransaction, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): RegisterNodeTransaction;
    fromJSON(object: any): RegisterNodeTransaction;
    toJSON(message: RegisterNodeTransaction): unknown;
    fromPartial(object: DeepPartial<RegisterNodeTransaction>): RegisterNodeTransaction;
};
declare type Builtin = Date | Function | Uint8Array | string | number | boolean | undefined;
export declare type DeepPartial<T> = T extends Builtin ? T : T extends Long ? string | number | Long : T extends Array<infer U> ? Array<DeepPartial<U>> : T extends ReadonlyArray<infer U> ? ReadonlyArray<DeepPartial<U>> : T extends {} ? {
    [K in keyof T]?: DeepPartial<T[K]>;
} : Partial<T>;
export {};
