import Long from "long";
import * as _m0 from "protobufjs/minimal";
export declare const protobufPackage = "wavesenterprise";
export interface ReissueTransaction {
    id?: Uint8Array;
    chainId?: number;
    senderPublicKey?: Uint8Array;
    assetId?: Uint8Array;
    quantity?: Long;
    reissuable?: boolean;
    fee?: Long;
    timestamp?: Long;
    proofs?: Uint8Array[];
    senderAddress?: Uint8Array;
}
export declare const ReissueTransaction: {
    encode(message: ReissueTransaction, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): ReissueTransaction;
    fromJSON(object: any): ReissueTransaction;
    toJSON(message: ReissueTransaction): unknown;
    fromPartial(object: DeepPartial<ReissueTransaction>): ReissueTransaction;
};
declare type Builtin = Date | Function | Uint8Array | string | number | boolean | undefined;
export declare type DeepPartial<T> = T extends Builtin ? T : T extends Long ? string | number | Long : T extends Array<infer U> ? Array<DeepPartial<U>> : T extends ReadonlyArray<infer U> ? ReadonlyArray<DeepPartial<U>> : T extends {} ? {
    [K in keyof T]?: DeepPartial<T[K]>;
} : Partial<T>;
export {};
