"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Transaction = exports.protobufPackage = void 0;
const long_1 = __importDefault(require("long"));
const _m0 = __importStar(require("protobufjs/minimal"));
const genesis_transaction_1 = require("../genesis/genesis_transaction");
const genesis_permit_transaction_1 = require("../genesis/genesis_permit_transaction");
const genesis_register_node_transaction_1 = require("../genesis/genesis_register_node_transaction");
const register_node_transaction_1 = require("../managed/register_node_transaction");
const create_alias_transaction_1 = require("../managed/create_alias_transaction");
const issue_transaction_1 = require("../managed/issue_transaction");
const reissue_transaction_1 = require("../managed/reissue_transaction");
const burn_transaction_1 = require("../managed/burn_transaction");
const lease_transaction_1 = require("../managed/lease_transaction");
const lease_cancel_transaction_1 = require("../managed/lease_cancel_transaction");
const sponsor_fee_transaction_1 = require("../managed/sponsor_fee_transaction");
const set_asset_script_transaction_1 = require("../managed/set_asset_script_transaction");
const data_transaction_1 = require("../managed/data_transaction");
const transfer_transaction_1 = require("../managed/transfer_transaction");
const mass_transfer_transaction_1 = require("../managed/mass_transfer_transaction");
const permit_transaction_1 = require("../managed/permit_transaction");
const create_policy_transaction_1 = require("../managed/create_policy_transaction");
const update_policy_transaction_1 = require("../managed/update_policy_transaction");
const policy_data_hash_transaction_1 = require("../managed/policy_data_hash_transaction");
const create_contract_transaction_1 = require("../managed/create_contract_transaction");
const call_contract_transaction_1 = require("../managed/call_contract_transaction");
const executed_contract_transaction_1 = require("../managed/executed_contract_transaction");
const disable_contract_transaction_1 = require("../managed/disable_contract_transaction");
const update_contract_transaction_1 = require("../managed/update_contract_transaction");
const set_script_transaction_1 = require("../managed/set_script_transaction");
const atomic_transaction_1 = require("../managed/atomic_transaction");
exports.protobufPackage = "wavesenterprise";
function createBaseTransaction() {
    return {
        version: 0,
        genesisTransaction: undefined,
        genesisPermitTransaction: undefined,
        genesisRegisterNodeTransaction: undefined,
        registerNodeTransaction: undefined,
        createAliasTransaction: undefined,
        issueTransaction: undefined,
        reissueTransaction: undefined,
        burnTransaction: undefined,
        leaseTransaction: undefined,
        leaseCancelTransaction: undefined,
        sponsorFeeTransaction: undefined,
        setAssetScriptTransaction: undefined,
        dataTransaction: undefined,
        transferTransaction: undefined,
        massTransferTransaction: undefined,
        permitTransaction: undefined,
        createPolicyTransaction: undefined,
        updatePolicyTransaction: undefined,
        policyDataHashTransaction: undefined,
        createContractTransaction: undefined,
        callContractTransaction: undefined,
        executedContractTransaction: undefined,
        disableContractTransaction: undefined,
        updateContractTransaction: undefined,
        setScriptTransaction: undefined,
        atomicTransaction: undefined,
    };
}
exports.Transaction = {
    encode(message, writer = _m0.Writer.create()) {
        if (message.version !== undefined && message.version !== 0) {
            writer.uint32(8).int32(message.version);
        }
        if (message.genesisTransaction !== undefined) {
            genesis_transaction_1.GenesisTransaction.encode(message.genesisTransaction, writer.uint32(8002).fork()).ldelim();
        }
        if (message.genesisPermitTransaction !== undefined) {
            genesis_permit_transaction_1.GenesisPermitTransaction.encode(message.genesisPermitTransaction, writer.uint32(8010).fork()).ldelim();
        }
        if (message.genesisRegisterNodeTransaction !== undefined) {
            genesis_register_node_transaction_1.GenesisRegisterNodeTransaction.encode(message.genesisRegisterNodeTransaction, writer.uint32(8018).fork()).ldelim();
        }
        if (message.registerNodeTransaction !== undefined) {
            register_node_transaction_1.RegisterNodeTransaction.encode(message.registerNodeTransaction, writer.uint32(8026).fork()).ldelim();
        }
        if (message.createAliasTransaction !== undefined) {
            create_alias_transaction_1.CreateAliasTransaction.encode(message.createAliasTransaction, writer.uint32(8034).fork()).ldelim();
        }
        if (message.issueTransaction !== undefined) {
            issue_transaction_1.IssueTransaction.encode(message.issueTransaction, writer.uint32(8042).fork()).ldelim();
        }
        if (message.reissueTransaction !== undefined) {
            reissue_transaction_1.ReissueTransaction.encode(message.reissueTransaction, writer.uint32(8050).fork()).ldelim();
        }
        if (message.burnTransaction !== undefined) {
            burn_transaction_1.BurnTransaction.encode(message.burnTransaction, writer.uint32(8058).fork()).ldelim();
        }
        if (message.leaseTransaction !== undefined) {
            lease_transaction_1.LeaseTransaction.encode(message.leaseTransaction, writer.uint32(8066).fork()).ldelim();
        }
        if (message.leaseCancelTransaction !== undefined) {
            lease_cancel_transaction_1.LeaseCancelTransaction.encode(message.leaseCancelTransaction, writer.uint32(8074).fork()).ldelim();
        }
        if (message.sponsorFeeTransaction !== undefined) {
            sponsor_fee_transaction_1.SponsorFeeTransaction.encode(message.sponsorFeeTransaction, writer.uint32(8082).fork()).ldelim();
        }
        if (message.setAssetScriptTransaction !== undefined) {
            set_asset_script_transaction_1.SetAssetScriptTransaction.encode(message.setAssetScriptTransaction, writer.uint32(8090).fork()).ldelim();
        }
        if (message.dataTransaction !== undefined) {
            data_transaction_1.DataTransaction.encode(message.dataTransaction, writer.uint32(8098).fork()).ldelim();
        }
        if (message.transferTransaction !== undefined) {
            transfer_transaction_1.TransferTransaction.encode(message.transferTransaction, writer.uint32(8106).fork()).ldelim();
        }
        if (message.massTransferTransaction !== undefined) {
            mass_transfer_transaction_1.MassTransferTransaction.encode(message.massTransferTransaction, writer.uint32(8114).fork()).ldelim();
        }
        if (message.permitTransaction !== undefined) {
            permit_transaction_1.PermitTransaction.encode(message.permitTransaction, writer.uint32(8122).fork()).ldelim();
        }
        if (message.createPolicyTransaction !== undefined) {
            create_policy_transaction_1.CreatePolicyTransaction.encode(message.createPolicyTransaction, writer.uint32(8130).fork()).ldelim();
        }
        if (message.updatePolicyTransaction !== undefined) {
            update_policy_transaction_1.UpdatePolicyTransaction.encode(message.updatePolicyTransaction, writer.uint32(8138).fork()).ldelim();
        }
        if (message.policyDataHashTransaction !== undefined) {
            policy_data_hash_transaction_1.PolicyDataHashTransaction.encode(message.policyDataHashTransaction, writer.uint32(8146).fork()).ldelim();
        }
        if (message.createContractTransaction !== undefined) {
            create_contract_transaction_1.CreateContractTransaction.encode(message.createContractTransaction, writer.uint32(8154).fork()).ldelim();
        }
        if (message.callContractTransaction !== undefined) {
            call_contract_transaction_1.CallContractTransaction.encode(message.callContractTransaction, writer.uint32(8162).fork()).ldelim();
        }
        if (message.executedContractTransaction !== undefined) {
            executed_contract_transaction_1.ExecutedContractTransaction.encode(message.executedContractTransaction, writer.uint32(8170).fork()).ldelim();
        }
        if (message.disableContractTransaction !== undefined) {
            disable_contract_transaction_1.DisableContractTransaction.encode(message.disableContractTransaction, writer.uint32(8178).fork()).ldelim();
        }
        if (message.updateContractTransaction !== undefined) {
            update_contract_transaction_1.UpdateContractTransaction.encode(message.updateContractTransaction, writer.uint32(8186).fork()).ldelim();
        }
        if (message.setScriptTransaction !== undefined) {
            set_script_transaction_1.SetScriptTransaction.encode(message.setScriptTransaction, writer.uint32(8194).fork()).ldelim();
        }
        if (message.atomicTransaction !== undefined) {
            atomic_transaction_1.AtomicTransaction.encode(message.atomicTransaction, writer.uint32(8202).fork()).ldelim();
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseTransaction();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.version = reader.int32();
                    break;
                case 1000:
                    message.genesisTransaction = genesis_transaction_1.GenesisTransaction.decode(reader, reader.uint32());
                    break;
                case 1001:
                    message.genesisPermitTransaction = genesis_permit_transaction_1.GenesisPermitTransaction.decode(reader, reader.uint32());
                    break;
                case 1002:
                    message.genesisRegisterNodeTransaction =
                        genesis_register_node_transaction_1.GenesisRegisterNodeTransaction.decode(reader, reader.uint32());
                    break;
                case 1003:
                    message.registerNodeTransaction = register_node_transaction_1.RegisterNodeTransaction.decode(reader, reader.uint32());
                    break;
                case 1004:
                    message.createAliasTransaction = create_alias_transaction_1.CreateAliasTransaction.decode(reader, reader.uint32());
                    break;
                case 1005:
                    message.issueTransaction = issue_transaction_1.IssueTransaction.decode(reader, reader.uint32());
                    break;
                case 1006:
                    message.reissueTransaction = reissue_transaction_1.ReissueTransaction.decode(reader, reader.uint32());
                    break;
                case 1007:
                    message.burnTransaction = burn_transaction_1.BurnTransaction.decode(reader, reader.uint32());
                    break;
                case 1008:
                    message.leaseTransaction = lease_transaction_1.LeaseTransaction.decode(reader, reader.uint32());
                    break;
                case 1009:
                    message.leaseCancelTransaction = lease_cancel_transaction_1.LeaseCancelTransaction.decode(reader, reader.uint32());
                    break;
                case 1010:
                    message.sponsorFeeTransaction = sponsor_fee_transaction_1.SponsorFeeTransaction.decode(reader, reader.uint32());
                    break;
                case 1011:
                    message.setAssetScriptTransaction = set_asset_script_transaction_1.SetAssetScriptTransaction.decode(reader, reader.uint32());
                    break;
                case 1012:
                    message.dataTransaction = data_transaction_1.DataTransaction.decode(reader, reader.uint32());
                    break;
                case 1013:
                    message.transferTransaction = transfer_transaction_1.TransferTransaction.decode(reader, reader.uint32());
                    break;
                case 1014:
                    message.massTransferTransaction = mass_transfer_transaction_1.MassTransferTransaction.decode(reader, reader.uint32());
                    break;
                case 1015:
                    message.permitTransaction = permit_transaction_1.PermitTransaction.decode(reader, reader.uint32());
                    break;
                case 1016:
                    message.createPolicyTransaction = create_policy_transaction_1.CreatePolicyTransaction.decode(reader, reader.uint32());
                    break;
                case 1017:
                    message.updatePolicyTransaction = update_policy_transaction_1.UpdatePolicyTransaction.decode(reader, reader.uint32());
                    break;
                case 1018:
                    message.policyDataHashTransaction = policy_data_hash_transaction_1.PolicyDataHashTransaction.decode(reader, reader.uint32());
                    break;
                case 1019:
                    message.createContractTransaction = create_contract_transaction_1.CreateContractTransaction.decode(reader, reader.uint32());
                    break;
                case 1020:
                    message.callContractTransaction = call_contract_transaction_1.CallContractTransaction.decode(reader, reader.uint32());
                    break;
                case 1021:
                    message.executedContractTransaction =
                        executed_contract_transaction_1.ExecutedContractTransaction.decode(reader, reader.uint32());
                    break;
                case 1022:
                    message.disableContractTransaction =
                        disable_contract_transaction_1.DisableContractTransaction.decode(reader, reader.uint32());
                    break;
                case 1023:
                    message.updateContractTransaction = update_contract_transaction_1.UpdateContractTransaction.decode(reader, reader.uint32());
                    break;
                case 1024:
                    message.setScriptTransaction = set_script_transaction_1.SetScriptTransaction.decode(reader, reader.uint32());
                    break;
                case 1025:
                    message.atomicTransaction = atomic_transaction_1.AtomicTransaction.decode(reader, reader.uint32());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        return {
            version: isSet(object.version) ? Number(object.version) : 0,
            genesisTransaction: isSet(object.genesisTransaction)
                ? genesis_transaction_1.GenesisTransaction.fromJSON(object.genesisTransaction)
                : undefined,
            genesisPermitTransaction: isSet(object.genesisPermitTransaction)
                ? genesis_permit_transaction_1.GenesisPermitTransaction.fromJSON(object.genesisPermitTransaction)
                : undefined,
            genesisRegisterNodeTransaction: isSet(object.genesisRegisterNodeTransaction)
                ? genesis_register_node_transaction_1.GenesisRegisterNodeTransaction.fromJSON(object.genesisRegisterNodeTransaction)
                : undefined,
            registerNodeTransaction: isSet(object.registerNodeTransaction)
                ? register_node_transaction_1.RegisterNodeTransaction.fromJSON(object.registerNodeTransaction)
                : undefined,
            createAliasTransaction: isSet(object.createAliasTransaction)
                ? create_alias_transaction_1.CreateAliasTransaction.fromJSON(object.createAliasTransaction)
                : undefined,
            issueTransaction: isSet(object.issueTransaction)
                ? issue_transaction_1.IssueTransaction.fromJSON(object.issueTransaction)
                : undefined,
            reissueTransaction: isSet(object.reissueTransaction)
                ? reissue_transaction_1.ReissueTransaction.fromJSON(object.reissueTransaction)
                : undefined,
            burnTransaction: isSet(object.burnTransaction)
                ? burn_transaction_1.BurnTransaction.fromJSON(object.burnTransaction)
                : undefined,
            leaseTransaction: isSet(object.leaseTransaction)
                ? lease_transaction_1.LeaseTransaction.fromJSON(object.leaseTransaction)
                : undefined,
            leaseCancelTransaction: isSet(object.leaseCancelTransaction)
                ? lease_cancel_transaction_1.LeaseCancelTransaction.fromJSON(object.leaseCancelTransaction)
                : undefined,
            sponsorFeeTransaction: isSet(object.sponsorFeeTransaction)
                ? sponsor_fee_transaction_1.SponsorFeeTransaction.fromJSON(object.sponsorFeeTransaction)
                : undefined,
            setAssetScriptTransaction: isSet(object.setAssetScriptTransaction)
                ? set_asset_script_transaction_1.SetAssetScriptTransaction.fromJSON(object.setAssetScriptTransaction)
                : undefined,
            dataTransaction: isSet(object.dataTransaction)
                ? data_transaction_1.DataTransaction.fromJSON(object.dataTransaction)
                : undefined,
            transferTransaction: isSet(object.transferTransaction)
                ? transfer_transaction_1.TransferTransaction.fromJSON(object.transferTransaction)
                : undefined,
            massTransferTransaction: isSet(object.massTransferTransaction)
                ? mass_transfer_transaction_1.MassTransferTransaction.fromJSON(object.massTransferTransaction)
                : undefined,
            permitTransaction: isSet(object.permitTransaction)
                ? permit_transaction_1.PermitTransaction.fromJSON(object.permitTransaction)
                : undefined,
            createPolicyTransaction: isSet(object.createPolicyTransaction)
                ? create_policy_transaction_1.CreatePolicyTransaction.fromJSON(object.createPolicyTransaction)
                : undefined,
            updatePolicyTransaction: isSet(object.updatePolicyTransaction)
                ? update_policy_transaction_1.UpdatePolicyTransaction.fromJSON(object.updatePolicyTransaction)
                : undefined,
            policyDataHashTransaction: isSet(object.policyDataHashTransaction)
                ? policy_data_hash_transaction_1.PolicyDataHashTransaction.fromJSON(object.policyDataHashTransaction)
                : undefined,
            createContractTransaction: isSet(object.createContractTransaction)
                ? create_contract_transaction_1.CreateContractTransaction.fromJSON(object.createContractTransaction)
                : undefined,
            callContractTransaction: isSet(object.callContractTransaction)
                ? call_contract_transaction_1.CallContractTransaction.fromJSON(object.callContractTransaction)
                : undefined,
            executedContractTransaction: isSet(object.executedContractTransaction)
                ? executed_contract_transaction_1.ExecutedContractTransaction.fromJSON(object.executedContractTransaction)
                : undefined,
            disableContractTransaction: isSet(object.disableContractTransaction)
                ? disable_contract_transaction_1.DisableContractTransaction.fromJSON(object.disableContractTransaction)
                : undefined,
            updateContractTransaction: isSet(object.updateContractTransaction)
                ? update_contract_transaction_1.UpdateContractTransaction.fromJSON(object.updateContractTransaction)
                : undefined,
            setScriptTransaction: isSet(object.setScriptTransaction)
                ? set_script_transaction_1.SetScriptTransaction.fromJSON(object.setScriptTransaction)
                : undefined,
            atomicTransaction: isSet(object.atomicTransaction)
                ? atomic_transaction_1.AtomicTransaction.fromJSON(object.atomicTransaction)
                : undefined,
        };
    },
    toJSON(message) {
        const obj = {};
        message.version !== undefined &&
            (obj.version = Math.round(message.version));
        message.genesisTransaction !== undefined &&
            (obj.genesisTransaction = message.genesisTransaction
                ? genesis_transaction_1.GenesisTransaction.toJSON(message.genesisTransaction)
                : undefined);
        message.genesisPermitTransaction !== undefined &&
            (obj.genesisPermitTransaction = message.genesisPermitTransaction
                ? genesis_permit_transaction_1.GenesisPermitTransaction.toJSON(message.genesisPermitTransaction)
                : undefined);
        message.genesisRegisterNodeTransaction !== undefined &&
            (obj.genesisRegisterNodeTransaction =
                message.genesisRegisterNodeTransaction
                    ? genesis_register_node_transaction_1.GenesisRegisterNodeTransaction.toJSON(message.genesisRegisterNodeTransaction)
                    : undefined);
        message.registerNodeTransaction !== undefined &&
            (obj.registerNodeTransaction = message.registerNodeTransaction
                ? register_node_transaction_1.RegisterNodeTransaction.toJSON(message.registerNodeTransaction)
                : undefined);
        message.createAliasTransaction !== undefined &&
            (obj.createAliasTransaction = message.createAliasTransaction
                ? create_alias_transaction_1.CreateAliasTransaction.toJSON(message.createAliasTransaction)
                : undefined);
        message.issueTransaction !== undefined &&
            (obj.issueTransaction = message.issueTransaction
                ? issue_transaction_1.IssueTransaction.toJSON(message.issueTransaction)
                : undefined);
        message.reissueTransaction !== undefined &&
            (obj.reissueTransaction = message.reissueTransaction
                ? reissue_transaction_1.ReissueTransaction.toJSON(message.reissueTransaction)
                : undefined);
        message.burnTransaction !== undefined &&
            (obj.burnTransaction = message.burnTransaction
                ? burn_transaction_1.BurnTransaction.toJSON(message.burnTransaction)
                : undefined);
        message.leaseTransaction !== undefined &&
            (obj.leaseTransaction = message.leaseTransaction
                ? lease_transaction_1.LeaseTransaction.toJSON(message.leaseTransaction)
                : undefined);
        message.leaseCancelTransaction !== undefined &&
            (obj.leaseCancelTransaction = message.leaseCancelTransaction
                ? lease_cancel_transaction_1.LeaseCancelTransaction.toJSON(message.leaseCancelTransaction)
                : undefined);
        message.sponsorFeeTransaction !== undefined &&
            (obj.sponsorFeeTransaction = message.sponsorFeeTransaction
                ? sponsor_fee_transaction_1.SponsorFeeTransaction.toJSON(message.sponsorFeeTransaction)
                : undefined);
        message.setAssetScriptTransaction !== undefined &&
            (obj.setAssetScriptTransaction = message.setAssetScriptTransaction
                ? set_asset_script_transaction_1.SetAssetScriptTransaction.toJSON(message.setAssetScriptTransaction)
                : undefined);
        message.dataTransaction !== undefined &&
            (obj.dataTransaction = message.dataTransaction
                ? data_transaction_1.DataTransaction.toJSON(message.dataTransaction)
                : undefined);
        message.transferTransaction !== undefined &&
            (obj.transferTransaction = message.transferTransaction
                ? transfer_transaction_1.TransferTransaction.toJSON(message.transferTransaction)
                : undefined);
        message.massTransferTransaction !== undefined &&
            (obj.massTransferTransaction = message.massTransferTransaction
                ? mass_transfer_transaction_1.MassTransferTransaction.toJSON(message.massTransferTransaction)
                : undefined);
        message.permitTransaction !== undefined &&
            (obj.permitTransaction = message.permitTransaction
                ? permit_transaction_1.PermitTransaction.toJSON(message.permitTransaction)
                : undefined);
        message.createPolicyTransaction !== undefined &&
            (obj.createPolicyTransaction = message.createPolicyTransaction
                ? create_policy_transaction_1.CreatePolicyTransaction.toJSON(message.createPolicyTransaction)
                : undefined);
        message.updatePolicyTransaction !== undefined &&
            (obj.updatePolicyTransaction = message.updatePolicyTransaction
                ? update_policy_transaction_1.UpdatePolicyTransaction.toJSON(message.updatePolicyTransaction)
                : undefined);
        message.policyDataHashTransaction !== undefined &&
            (obj.policyDataHashTransaction = message.policyDataHashTransaction
                ? policy_data_hash_transaction_1.PolicyDataHashTransaction.toJSON(message.policyDataHashTransaction)
                : undefined);
        message.createContractTransaction !== undefined &&
            (obj.createContractTransaction = message.createContractTransaction
                ? create_contract_transaction_1.CreateContractTransaction.toJSON(message.createContractTransaction)
                : undefined);
        message.callContractTransaction !== undefined &&
            (obj.callContractTransaction = message.callContractTransaction
                ? call_contract_transaction_1.CallContractTransaction.toJSON(message.callContractTransaction)
                : undefined);
        message.executedContractTransaction !== undefined &&
            (obj.executedContractTransaction = message.executedContractTransaction
                ? executed_contract_transaction_1.ExecutedContractTransaction.toJSON(message.executedContractTransaction)
                : undefined);
        message.disableContractTransaction !== undefined &&
            (obj.disableContractTransaction = message.disableContractTransaction
                ? disable_contract_transaction_1.DisableContractTransaction.toJSON(message.disableContractTransaction)
                : undefined);
        message.updateContractTransaction !== undefined &&
            (obj.updateContractTransaction = message.updateContractTransaction
                ? update_contract_transaction_1.UpdateContractTransaction.toJSON(message.updateContractTransaction)
                : undefined);
        message.setScriptTransaction !== undefined &&
            (obj.setScriptTransaction = message.setScriptTransaction
                ? set_script_transaction_1.SetScriptTransaction.toJSON(message.setScriptTransaction)
                : undefined);
        message.atomicTransaction !== undefined &&
            (obj.atomicTransaction = message.atomicTransaction
                ? atomic_transaction_1.AtomicTransaction.toJSON(message.atomicTransaction)
                : undefined);
        return obj;
    },
    fromPartial(object) {
        var _a;
        const message = createBaseTransaction();
        message.version = (_a = object.version) !== null && _a !== void 0 ? _a : 0;
        message.genesisTransaction =
            object.genesisTransaction !== undefined &&
                object.genesisTransaction !== null
                ? genesis_transaction_1.GenesisTransaction.fromPartial(object.genesisTransaction)
                : undefined;
        message.genesisPermitTransaction =
            object.genesisPermitTransaction !== undefined &&
                object.genesisPermitTransaction !== null
                ? genesis_permit_transaction_1.GenesisPermitTransaction.fromPartial(object.genesisPermitTransaction)
                : undefined;
        message.genesisRegisterNodeTransaction =
            object.genesisRegisterNodeTransaction !== undefined &&
                object.genesisRegisterNodeTransaction !== null
                ? genesis_register_node_transaction_1.GenesisRegisterNodeTransaction.fromPartial(object.genesisRegisterNodeTransaction)
                : undefined;
        message.registerNodeTransaction =
            object.registerNodeTransaction !== undefined &&
                object.registerNodeTransaction !== null
                ? register_node_transaction_1.RegisterNodeTransaction.fromPartial(object.registerNodeTransaction)
                : undefined;
        message.createAliasTransaction =
            object.createAliasTransaction !== undefined &&
                object.createAliasTransaction !== null
                ? create_alias_transaction_1.CreateAliasTransaction.fromPartial(object.createAliasTransaction)
                : undefined;
        message.issueTransaction =
            object.issueTransaction !== undefined && object.issueTransaction !== null
                ? issue_transaction_1.IssueTransaction.fromPartial(object.issueTransaction)
                : undefined;
        message.reissueTransaction =
            object.reissueTransaction !== undefined &&
                object.reissueTransaction !== null
                ? reissue_transaction_1.ReissueTransaction.fromPartial(object.reissueTransaction)
                : undefined;
        message.burnTransaction =
            object.burnTransaction !== undefined && object.burnTransaction !== null
                ? burn_transaction_1.BurnTransaction.fromPartial(object.burnTransaction)
                : undefined;
        message.leaseTransaction =
            object.leaseTransaction !== undefined && object.leaseTransaction !== null
                ? lease_transaction_1.LeaseTransaction.fromPartial(object.leaseTransaction)
                : undefined;
        message.leaseCancelTransaction =
            object.leaseCancelTransaction !== undefined &&
                object.leaseCancelTransaction !== null
                ? lease_cancel_transaction_1.LeaseCancelTransaction.fromPartial(object.leaseCancelTransaction)
                : undefined;
        message.sponsorFeeTransaction =
            object.sponsorFeeTransaction !== undefined &&
                object.sponsorFeeTransaction !== null
                ? sponsor_fee_transaction_1.SponsorFeeTransaction.fromPartial(object.sponsorFeeTransaction)
                : undefined;
        message.setAssetScriptTransaction =
            object.setAssetScriptTransaction !== undefined &&
                object.setAssetScriptTransaction !== null
                ? set_asset_script_transaction_1.SetAssetScriptTransaction.fromPartial(object.setAssetScriptTransaction)
                : undefined;
        message.dataTransaction =
            object.dataTransaction !== undefined && object.dataTransaction !== null
                ? data_transaction_1.DataTransaction.fromPartial(object.dataTransaction)
                : undefined;
        message.transferTransaction =
            object.transferTransaction !== undefined &&
                object.transferTransaction !== null
                ? transfer_transaction_1.TransferTransaction.fromPartial(object.transferTransaction)
                : undefined;
        message.massTransferTransaction =
            object.massTransferTransaction !== undefined &&
                object.massTransferTransaction !== null
                ? mass_transfer_transaction_1.MassTransferTransaction.fromPartial(object.massTransferTransaction)
                : undefined;
        message.permitTransaction =
            object.permitTransaction !== undefined &&
                object.permitTransaction !== null
                ? permit_transaction_1.PermitTransaction.fromPartial(object.permitTransaction)
                : undefined;
        message.createPolicyTransaction =
            object.createPolicyTransaction !== undefined &&
                object.createPolicyTransaction !== null
                ? create_policy_transaction_1.CreatePolicyTransaction.fromPartial(object.createPolicyTransaction)
                : undefined;
        message.updatePolicyTransaction =
            object.updatePolicyTransaction !== undefined &&
                object.updatePolicyTransaction !== null
                ? update_policy_transaction_1.UpdatePolicyTransaction.fromPartial(object.updatePolicyTransaction)
                : undefined;
        message.policyDataHashTransaction =
            object.policyDataHashTransaction !== undefined &&
                object.policyDataHashTransaction !== null
                ? policy_data_hash_transaction_1.PolicyDataHashTransaction.fromPartial(object.policyDataHashTransaction)
                : undefined;
        message.createContractTransaction =
            object.createContractTransaction !== undefined &&
                object.createContractTransaction !== null
                ? create_contract_transaction_1.CreateContractTransaction.fromPartial(object.createContractTransaction)
                : undefined;
        message.callContractTransaction =
            object.callContractTransaction !== undefined &&
                object.callContractTransaction !== null
                ? call_contract_transaction_1.CallContractTransaction.fromPartial(object.callContractTransaction)
                : undefined;
        message.executedContractTransaction =
            object.executedContractTransaction !== undefined &&
                object.executedContractTransaction !== null
                ? executed_contract_transaction_1.ExecutedContractTransaction.fromPartial(object.executedContractTransaction)
                : undefined;
        message.disableContractTransaction =
            object.disableContractTransaction !== undefined &&
                object.disableContractTransaction !== null
                ? disable_contract_transaction_1.DisableContractTransaction.fromPartial(object.disableContractTransaction)
                : undefined;
        message.updateContractTransaction =
            object.updateContractTransaction !== undefined &&
                object.updateContractTransaction !== null
                ? update_contract_transaction_1.UpdateContractTransaction.fromPartial(object.updateContractTransaction)
                : undefined;
        message.setScriptTransaction =
            object.setScriptTransaction !== undefined &&
                object.setScriptTransaction !== null
                ? set_script_transaction_1.SetScriptTransaction.fromPartial(object.setScriptTransaction)
                : undefined;
        message.atomicTransaction =
            object.atomicTransaction !== undefined &&
                object.atomicTransaction !== null
                ? atomic_transaction_1.AtomicTransaction.fromPartial(object.atomicTransaction)
                : undefined;
        return message;
    },
};
if (_m0.util.Long !== long_1.default) {
    _m0.util.Long = long_1.default;
    _m0.configure();
}
function isSet(value) {
    return value !== null && value !== undefined;
}
//# sourceMappingURL=transaction.js.map