import Long from "long";
import * as _m0 from "protobufjs/minimal";
import { AtomicBadge } from "../atomic_badge";
export declare const protobufPackage = "wavesenterprise";
export interface TransferTransaction {
    id?: Uint8Array;
    senderPublicKey?: Uint8Array;
    assetId?: Uint8Array;
    feeAssetId?: Uint8Array;
    timestamp?: Long;
    amount?: Long;
    fee?: Long;
    recipient?: Uint8Array;
    attachment?: Uint8Array;
    atomicBadge?: AtomicBadge;
    proofs?: Uint8Array[];
    senderAddress?: Uint8Array;
}
export declare const TransferTransaction: {
    encode(message: TransferTransaction, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): TransferTransaction;
    fromJSON(object: any): TransferTransaction;
    toJSON(message: TransferTransaction): unknown;
    fromPartial(object: DeepPartial<TransferTransaction>): TransferTransaction;
};
declare type Builtin = Date | Function | Uint8Array | string | number | boolean | undefined;
export declare type DeepPartial<T> = T extends Builtin ? T : T extends Long ? string | number | Long : T extends Array<infer U> ? Array<DeepPartial<U>> : T extends ReadonlyArray<infer U> ? ReadonlyArray<DeepPartial<U>> : T extends {} ? {
    [K in keyof T]?: DeepPartial<T[K]>;
} : Partial<T>;
export {};
