import Long from "long";
import * as _m0 from "protobufjs/minimal";
import { AtomicBadge } from "../atomic_badge";
import { ValidationPolicy } from "../validation_policy";
import { ContractApiVersion } from "../contract_api_version";
export declare const protobufPackage = "wavesenterprise";
export interface UpdateContractTransaction {
    id?: Uint8Array;
    senderPublicKey?: Uint8Array;
    contractId?: Uint8Array;
    image?: string;
    imageHash?: string;
    fee?: Long;
    timestamp?: Long;
    feeAssetId?: Uint8Array;
    atomicBadge?: AtomicBadge;
    validationPolicy?: ValidationPolicy;
    apiVersion?: ContractApiVersion;
    proofs?: Uint8Array[];
    senderAddress?: Uint8Array;
}
export declare const UpdateContractTransaction: {
    encode(message: UpdateContractTransaction, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): UpdateContractTransaction;
    fromJSON(object: any): UpdateContractTransaction;
    toJSON(message: UpdateContractTransaction): unknown;
    fromPartial(object: DeepPartial<UpdateContractTransaction>): UpdateContractTransaction;
};
declare type Builtin = Date | Function | Uint8Array | string | number | boolean | undefined;
export declare type DeepPartial<T> = T extends Builtin ? T : T extends Long ? string | number | Long : T extends Array<infer U> ? Array<DeepPartial<U>> : T extends ReadonlyArray<infer U> ? ReadonlyArray<DeepPartial<U>> : T extends {} ? {
    [K in keyof T]?: DeepPartial<T[K]>;
} : Partial<T>;
export {};
