import Long from "long";
import * as _m0 from "protobufjs/minimal";
import { OpType } from "../op_type";
import { AtomicBadge } from "../atomic_badge";
export declare const protobufPackage = "wavesenterprise";
export interface UpdatePolicyTransaction {
    id?: Uint8Array;
    senderPublicKey?: Uint8Array;
    policyId?: Uint8Array;
    recipients?: Uint8Array[];
    owners?: Uint8Array[];
    opType?: OpType;
    timestamp?: Long;
    fee?: Long;
    feeAssetId?: Uint8Array;
    atomicBadge?: AtomicBadge;
    proofs?: Uint8Array[];
    senderAddress?: Uint8Array;
}
export declare const UpdatePolicyTransaction: {
    encode(message: UpdatePolicyTransaction, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): UpdatePolicyTransaction;
    fromJSON(object: any): UpdatePolicyTransaction;
    toJSON(message: UpdatePolicyTransaction): unknown;
    fromPartial(object: DeepPartial<UpdatePolicyTransaction>): UpdatePolicyTransaction;
};
declare type Builtin = Date | Function | Uint8Array | string | number | boolean | undefined;
export declare type DeepPartial<T> = T extends Builtin ? T : T extends Long ? string | number | Long : T extends Array<infer U> ? Array<DeepPartial<U>> : T extends ReadonlyArray<infer U> ? ReadonlyArray<DeepPartial<U>> : T extends {} ? {
    [K in keyof T]?: DeepPartial<T[K]>;
} : Partial<T>;
export {};
