"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.AppendedBlockHistory = exports.RollbackCompleted = exports.BlockAppended = exports.MicroBlockAppended = exports.InvalidToken = exports.InvalidApiKey = exports.MissingAuthorizationMetadata = exports.MissingRequiredRequestField = exports.BlockSignatureNotFoundError = exports.GenericError = exports.BlockchainEvent = exports.protobufPackage = void 0;
const long_1 = __importDefault(require("long"));
const _m0 = __importStar(require("protobufjs/minimal"));
const transaction_1 = require("../managed/transaction");
exports.protobufPackage = "wavesenterprise";
function createBaseBlockchainEvent() {
    return {
        microBlockAppended: undefined,
        blockAppended: undefined,
        rollbackCompleted: undefined,
        appendedBlockHistory: undefined,
    };
}
exports.BlockchainEvent = {
    encode(message, writer = _m0.Writer.create()) {
        if (message.microBlockAppended !== undefined) {
            exports.MicroBlockAppended.encode(message.microBlockAppended, writer.uint32(18).fork()).ldelim();
        }
        if (message.blockAppended !== undefined) {
            exports.BlockAppended.encode(message.blockAppended, writer.uint32(26).fork()).ldelim();
        }
        if (message.rollbackCompleted !== undefined) {
            exports.RollbackCompleted.encode(message.rollbackCompleted, writer.uint32(34).fork()).ldelim();
        }
        if (message.appendedBlockHistory !== undefined) {
            exports.AppendedBlockHistory.encode(message.appendedBlockHistory, writer.uint32(42).fork()).ldelim();
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseBlockchainEvent();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 2:
                    message.microBlockAppended = exports.MicroBlockAppended.decode(reader, reader.uint32());
                    break;
                case 3:
                    message.blockAppended = exports.BlockAppended.decode(reader, reader.uint32());
                    break;
                case 4:
                    message.rollbackCompleted = exports.RollbackCompleted.decode(reader, reader.uint32());
                    break;
                case 5:
                    message.appendedBlockHistory = exports.AppendedBlockHistory.decode(reader, reader.uint32());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        return {
            microBlockAppended: isSet(object.microBlockAppended)
                ? exports.MicroBlockAppended.fromJSON(object.microBlockAppended)
                : undefined,
            blockAppended: isSet(object.blockAppended)
                ? exports.BlockAppended.fromJSON(object.blockAppended)
                : undefined,
            rollbackCompleted: isSet(object.rollbackCompleted)
                ? exports.RollbackCompleted.fromJSON(object.rollbackCompleted)
                : undefined,
            appendedBlockHistory: isSet(object.appendedBlockHistory)
                ? exports.AppendedBlockHistory.fromJSON(object.appendedBlockHistory)
                : undefined,
        };
    },
    toJSON(message) {
        const obj = {};
        message.microBlockAppended !== undefined &&
            (obj.microBlockAppended = message.microBlockAppended
                ? exports.MicroBlockAppended.toJSON(message.microBlockAppended)
                : undefined);
        message.blockAppended !== undefined &&
            (obj.blockAppended = message.blockAppended
                ? exports.BlockAppended.toJSON(message.blockAppended)
                : undefined);
        message.rollbackCompleted !== undefined &&
            (obj.rollbackCompleted = message.rollbackCompleted
                ? exports.RollbackCompleted.toJSON(message.rollbackCompleted)
                : undefined);
        message.appendedBlockHistory !== undefined &&
            (obj.appendedBlockHistory = message.appendedBlockHistory
                ? exports.AppendedBlockHistory.toJSON(message.appendedBlockHistory)
                : undefined);
        return obj;
    },
    fromPartial(object) {
        const message = createBaseBlockchainEvent();
        message.microBlockAppended =
            object.microBlockAppended !== undefined &&
                object.microBlockAppended !== null
                ? exports.MicroBlockAppended.fromPartial(object.microBlockAppended)
                : undefined;
        message.blockAppended =
            object.blockAppended !== undefined && object.blockAppended !== null
                ? exports.BlockAppended.fromPartial(object.blockAppended)
                : undefined;
        message.rollbackCompleted =
            object.rollbackCompleted !== undefined &&
                object.rollbackCompleted !== null
                ? exports.RollbackCompleted.fromPartial(object.rollbackCompleted)
                : undefined;
        message.appendedBlockHistory =
            object.appendedBlockHistory !== undefined &&
                object.appendedBlockHistory !== null
                ? exports.AppendedBlockHistory.fromPartial(object.appendedBlockHistory)
                : undefined;
        return message;
    },
};
function createBaseGenericError() {
    return {};
}
exports.GenericError = {
    encode(_, writer = _m0.Writer.create()) {
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseGenericError();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(_) {
        return {};
    },
    toJSON(_) {
        const obj = {};
        return obj;
    },
    fromPartial(_) {
        const message = createBaseGenericError();
        return message;
    },
};
function createBaseBlockSignatureNotFoundError() {
    return { blockSignature: new Uint8Array() };
}
exports.BlockSignatureNotFoundError = {
    encode(message, writer = _m0.Writer.create()) {
        if (message.blockSignature !== undefined &&
            message.blockSignature.length !== 0) {
            writer.uint32(10).bytes(message.blockSignature);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseBlockSignatureNotFoundError();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.blockSignature = reader.bytes();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        return {
            blockSignature: isSet(object.blockSignature)
                ? bytesFromBase64(object.blockSignature)
                : new Uint8Array(),
        };
    },
    toJSON(message) {
        const obj = {};
        message.blockSignature !== undefined &&
            (obj.blockSignature = base64FromBytes(message.blockSignature !== undefined
                ? message.blockSignature
                : new Uint8Array()));
        return obj;
    },
    fromPartial(object) {
        var _a;
        const message = createBaseBlockSignatureNotFoundError();
        message.blockSignature = (_a = object.blockSignature) !== null && _a !== void 0 ? _a : new Uint8Array();
        return message;
    },
};
function createBaseMissingRequiredRequestField() {
    return {};
}
exports.MissingRequiredRequestField = {
    encode(_, writer = _m0.Writer.create()) {
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseMissingRequiredRequestField();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(_) {
        return {};
    },
    toJSON(_) {
        const obj = {};
        return obj;
    },
    fromPartial(_) {
        const message = createBaseMissingRequiredRequestField();
        return message;
    },
};
function createBaseMissingAuthorizationMetadata() {
    return {};
}
exports.MissingAuthorizationMetadata = {
    encode(_, writer = _m0.Writer.create()) {
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseMissingAuthorizationMetadata();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(_) {
        return {};
    },
    toJSON(_) {
        const obj = {};
        return obj;
    },
    fromPartial(_) {
        const message = createBaseMissingAuthorizationMetadata();
        return message;
    },
};
function createBaseInvalidApiKey() {
    return {};
}
exports.InvalidApiKey = {
    encode(_, writer = _m0.Writer.create()) {
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseInvalidApiKey();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(_) {
        return {};
    },
    toJSON(_) {
        const obj = {};
        return obj;
    },
    fromPartial(_) {
        const message = createBaseInvalidApiKey();
        return message;
    },
};
function createBaseInvalidToken() {
    return {};
}
exports.InvalidToken = {
    encode(_, writer = _m0.Writer.create()) {
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseInvalidToken();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(_) {
        return {};
    },
    toJSON(_) {
        const obj = {};
        return obj;
    },
    fromPartial(_) {
        const message = createBaseInvalidToken();
        return message;
    },
};
function createBaseMicroBlockAppended() {
    return { txs: [] };
}
exports.MicroBlockAppended = {
    encode(message, writer = _m0.Writer.create()) {
        if (message.txs !== undefined && message.txs.length !== 0) {
            for (const v of message.txs) {
                transaction_1.Transaction.encode(v, writer.uint32(10).fork()).ldelim();
            }
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseMicroBlockAppended();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.txs.push(transaction_1.Transaction.decode(reader, reader.uint32()));
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        return {
            txs: Array.isArray(object === null || object === void 0 ? void 0 : object.txs)
                ? object.txs.map((e) => transaction_1.Transaction.fromJSON(e))
                : [],
        };
    },
    toJSON(message) {
        const obj = {};
        if (message.txs) {
            obj.txs = message.txs.map((e) => (e ? transaction_1.Transaction.toJSON(e) : undefined));
        }
        else {
            obj.txs = [];
        }
        return obj;
    },
    fromPartial(object) {
        var _a;
        const message = createBaseMicroBlockAppended();
        message.txs = ((_a = object.txs) === null || _a === void 0 ? void 0 : _a.map((e) => transaction_1.Transaction.fromPartial(e))) || [];
        return message;
    },
};
function createBaseBlockAppended() {
    return {
        blockSignature: new Uint8Array(),
        reference: new Uint8Array(),
        txIds: [],
        minerAddress: new Uint8Array(),
        height: long_1.default.ZERO,
        version: 0,
        timestamp: long_1.default.ZERO,
        fee: long_1.default.ZERO,
        blockSize: 0,
        features: [],
    };
}
exports.BlockAppended = {
    encode(message, writer = _m0.Writer.create()) {
        if (message.blockSignature !== undefined &&
            message.blockSignature.length !== 0) {
            writer.uint32(10).bytes(message.blockSignature);
        }
        if (message.reference !== undefined && message.reference.length !== 0) {
            writer.uint32(18).bytes(message.reference);
        }
        if (message.txIds !== undefined && message.txIds.length !== 0) {
            for (const v of message.txIds) {
                writer.uint32(26).bytes(v);
            }
        }
        if (message.minerAddress !== undefined &&
            message.minerAddress.length !== 0) {
            writer.uint32(34).bytes(message.minerAddress);
        }
        if (message.height !== undefined && !message.height.isZero()) {
            writer.uint32(40).int64(message.height);
        }
        if (message.version !== undefined && message.version !== 0) {
            writer.uint32(48).int32(message.version);
        }
        if (message.timestamp !== undefined && !message.timestamp.isZero()) {
            writer.uint32(56).int64(message.timestamp);
        }
        if (message.fee !== undefined && !message.fee.isZero()) {
            writer.uint32(64).int64(message.fee);
        }
        if (message.blockSize !== undefined && message.blockSize !== 0) {
            writer.uint32(72).int32(message.blockSize);
        }
        if (message.features !== undefined && message.features.length !== 0) {
            writer.uint32(82).fork();
            for (const v of message.features) {
                writer.int32(v);
            }
            writer.ldelim();
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseBlockAppended();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.blockSignature = reader.bytes();
                    break;
                case 2:
                    message.reference = reader.bytes();
                    break;
                case 3:
                    message.txIds.push(reader.bytes());
                    break;
                case 4:
                    message.minerAddress = reader.bytes();
                    break;
                case 5:
                    message.height = reader.int64();
                    break;
                case 6:
                    message.version = reader.int32();
                    break;
                case 7:
                    message.timestamp = reader.int64();
                    break;
                case 8:
                    message.fee = reader.int64();
                    break;
                case 9:
                    message.blockSize = reader.int32();
                    break;
                case 10:
                    if ((tag & 7) === 2) {
                        const end2 = reader.uint32() + reader.pos;
                        while (reader.pos < end2) {
                            message.features.push(reader.int32());
                        }
                    }
                    else {
                        message.features.push(reader.int32());
                    }
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        return {
            blockSignature: isSet(object.blockSignature)
                ? bytesFromBase64(object.blockSignature)
                : new Uint8Array(),
            reference: isSet(object.reference)
                ? bytesFromBase64(object.reference)
                : new Uint8Array(),
            txIds: Array.isArray(object === null || object === void 0 ? void 0 : object.txIds)
                ? object.txIds.map((e) => bytesFromBase64(e))
                : [],
            minerAddress: isSet(object.minerAddress)
                ? bytesFromBase64(object.minerAddress)
                : new Uint8Array(),
            height: isSet(object.height) ? long_1.default.fromString(object.height) : long_1.default.ZERO,
            version: isSet(object.version) ? Number(object.version) : 0,
            timestamp: isSet(object.timestamp)
                ? long_1.default.fromString(object.timestamp)
                : long_1.default.ZERO,
            fee: isSet(object.fee) ? long_1.default.fromString(object.fee) : long_1.default.ZERO,
            blockSize: isSet(object.blockSize) ? Number(object.blockSize) : 0,
            features: Array.isArray(object === null || object === void 0 ? void 0 : object.features)
                ? object.features.map((e) => Number(e))
                : [],
        };
    },
    toJSON(message) {
        const obj = {};
        message.blockSignature !== undefined &&
            (obj.blockSignature = base64FromBytes(message.blockSignature !== undefined
                ? message.blockSignature
                : new Uint8Array()));
        message.reference !== undefined &&
            (obj.reference = base64FromBytes(message.reference !== undefined ? message.reference : new Uint8Array()));
        if (message.txIds) {
            obj.txIds = message.txIds.map((e) => base64FromBytes(e !== undefined ? e : new Uint8Array()));
        }
        else {
            obj.txIds = [];
        }
        message.minerAddress !== undefined &&
            (obj.minerAddress = base64FromBytes(message.minerAddress !== undefined
                ? message.minerAddress
                : new Uint8Array()));
        message.height !== undefined &&
            (obj.height = (message.height || long_1.default.ZERO).toString());
        message.version !== undefined &&
            (obj.version = Math.round(message.version));
        message.timestamp !== undefined &&
            (obj.timestamp = (message.timestamp || long_1.default.ZERO).toString());
        message.fee !== undefined &&
            (obj.fee = (message.fee || long_1.default.ZERO).toString());
        message.blockSize !== undefined &&
            (obj.blockSize = Math.round(message.blockSize));
        if (message.features) {
            obj.features = message.features.map((e) => Math.round(e));
        }
        else {
            obj.features = [];
        }
        return obj;
    },
    fromPartial(object) {
        var _a, _b, _c, _d, _e, _f, _g;
        const message = createBaseBlockAppended();
        message.blockSignature = (_a = object.blockSignature) !== null && _a !== void 0 ? _a : new Uint8Array();
        message.reference = (_b = object.reference) !== null && _b !== void 0 ? _b : new Uint8Array();
        message.txIds = ((_c = object.txIds) === null || _c === void 0 ? void 0 : _c.map((e) => e)) || [];
        message.minerAddress = (_d = object.minerAddress) !== null && _d !== void 0 ? _d : new Uint8Array();
        message.height =
            object.height !== undefined && object.height !== null
                ? long_1.default.fromValue(object.height)
                : long_1.default.ZERO;
        message.version = (_e = object.version) !== null && _e !== void 0 ? _e : 0;
        message.timestamp =
            object.timestamp !== undefined && object.timestamp !== null
                ? long_1.default.fromValue(object.timestamp)
                : long_1.default.ZERO;
        message.fee =
            object.fee !== undefined && object.fee !== null
                ? long_1.default.fromValue(object.fee)
                : long_1.default.ZERO;
        message.blockSize = (_f = object.blockSize) !== null && _f !== void 0 ? _f : 0;
        message.features = ((_g = object.features) === null || _g === void 0 ? void 0 : _g.map((e) => e)) || [];
        return message;
    },
};
function createBaseRollbackCompleted() {
    return { returnToBlockSignature: new Uint8Array(), rollbackTxIds: [] };
}
exports.RollbackCompleted = {
    encode(message, writer = _m0.Writer.create()) {
        if (message.returnToBlockSignature !== undefined &&
            message.returnToBlockSignature.length !== 0) {
            writer.uint32(10).bytes(message.returnToBlockSignature);
        }
        if (message.rollbackTxIds !== undefined &&
            message.rollbackTxIds.length !== 0) {
            for (const v of message.rollbackTxIds) {
                writer.uint32(18).bytes(v);
            }
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseRollbackCompleted();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.returnToBlockSignature = reader.bytes();
                    break;
                case 2:
                    message.rollbackTxIds.push(reader.bytes());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        return {
            returnToBlockSignature: isSet(object.returnToBlockSignature)
                ? bytesFromBase64(object.returnToBlockSignature)
                : new Uint8Array(),
            rollbackTxIds: Array.isArray(object === null || object === void 0 ? void 0 : object.rollbackTxIds)
                ? object.rollbackTxIds.map((e) => bytesFromBase64(e))
                : [],
        };
    },
    toJSON(message) {
        const obj = {};
        message.returnToBlockSignature !== undefined &&
            (obj.returnToBlockSignature = base64FromBytes(message.returnToBlockSignature !== undefined
                ? message.returnToBlockSignature
                : new Uint8Array()));
        if (message.rollbackTxIds) {
            obj.rollbackTxIds = message.rollbackTxIds.map((e) => base64FromBytes(e !== undefined ? e : new Uint8Array()));
        }
        else {
            obj.rollbackTxIds = [];
        }
        return obj;
    },
    fromPartial(object) {
        var _a, _b;
        const message = createBaseRollbackCompleted();
        message.returnToBlockSignature =
            (_a = object.returnToBlockSignature) !== null && _a !== void 0 ? _a : new Uint8Array();
        message.rollbackTxIds = ((_b = object.rollbackTxIds) === null || _b === void 0 ? void 0 : _b.map((e) => e)) || [];
        return message;
    },
};
function createBaseAppendedBlockHistory() {
    return {
        blockSignature: new Uint8Array(),
        reference: new Uint8Array(),
        txs: [],
        minerAddress: new Uint8Array(),
        height: long_1.default.ZERO,
        version: 0,
        timestamp: long_1.default.ZERO,
        fee: long_1.default.ZERO,
        blockSize: 0,
        features: [],
    };
}
exports.AppendedBlockHistory = {
    encode(message, writer = _m0.Writer.create()) {
        if (message.blockSignature !== undefined &&
            message.blockSignature.length !== 0) {
            writer.uint32(10).bytes(message.blockSignature);
        }
        if (message.reference !== undefined && message.reference.length !== 0) {
            writer.uint32(18).bytes(message.reference);
        }
        if (message.txs !== undefined && message.txs.length !== 0) {
            for (const v of message.txs) {
                transaction_1.Transaction.encode(v, writer.uint32(26).fork()).ldelim();
            }
        }
        if (message.minerAddress !== undefined &&
            message.minerAddress.length !== 0) {
            writer.uint32(34).bytes(message.minerAddress);
        }
        if (message.height !== undefined && !message.height.isZero()) {
            writer.uint32(40).int64(message.height);
        }
        if (message.version !== undefined && message.version !== 0) {
            writer.uint32(48).int32(message.version);
        }
        if (message.timestamp !== undefined && !message.timestamp.isZero()) {
            writer.uint32(56).int64(message.timestamp);
        }
        if (message.fee !== undefined && !message.fee.isZero()) {
            writer.uint32(64).int64(message.fee);
        }
        if (message.blockSize !== undefined && message.blockSize !== 0) {
            writer.uint32(72).int32(message.blockSize);
        }
        if (message.features !== undefined && message.features.length !== 0) {
            writer.uint32(82).fork();
            for (const v of message.features) {
                writer.int32(v);
            }
            writer.ldelim();
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseAppendedBlockHistory();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.blockSignature = reader.bytes();
                    break;
                case 2:
                    message.reference = reader.bytes();
                    break;
                case 3:
                    message.txs.push(transaction_1.Transaction.decode(reader, reader.uint32()));
                    break;
                case 4:
                    message.minerAddress = reader.bytes();
                    break;
                case 5:
                    message.height = reader.int64();
                    break;
                case 6:
                    message.version = reader.int32();
                    break;
                case 7:
                    message.timestamp = reader.int64();
                    break;
                case 8:
                    message.fee = reader.int64();
                    break;
                case 9:
                    message.blockSize = reader.int32();
                    break;
                case 10:
                    if ((tag & 7) === 2) {
                        const end2 = reader.uint32() + reader.pos;
                        while (reader.pos < end2) {
                            message.features.push(reader.int32());
                        }
                    }
                    else {
                        message.features.push(reader.int32());
                    }
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        return {
            blockSignature: isSet(object.blockSignature)
                ? bytesFromBase64(object.blockSignature)
                : new Uint8Array(),
            reference: isSet(object.reference)
                ? bytesFromBase64(object.reference)
                : new Uint8Array(),
            txs: Array.isArray(object === null || object === void 0 ? void 0 : object.txs)
                ? object.txs.map((e) => transaction_1.Transaction.fromJSON(e))
                : [],
            minerAddress: isSet(object.minerAddress)
                ? bytesFromBase64(object.minerAddress)
                : new Uint8Array(),
            height: isSet(object.height) ? long_1.default.fromString(object.height) : long_1.default.ZERO,
            version: isSet(object.version) ? Number(object.version) : 0,
            timestamp: isSet(object.timestamp)
                ? long_1.default.fromString(object.timestamp)
                : long_1.default.ZERO,
            fee: isSet(object.fee) ? long_1.default.fromString(object.fee) : long_1.default.ZERO,
            blockSize: isSet(object.blockSize) ? Number(object.blockSize) : 0,
            features: Array.isArray(object === null || object === void 0 ? void 0 : object.features)
                ? object.features.map((e) => Number(e))
                : [],
        };
    },
    toJSON(message) {
        const obj = {};
        message.blockSignature !== undefined &&
            (obj.blockSignature = base64FromBytes(message.blockSignature !== undefined
                ? message.blockSignature
                : new Uint8Array()));
        message.reference !== undefined &&
            (obj.reference = base64FromBytes(message.reference !== undefined ? message.reference : new Uint8Array()));
        if (message.txs) {
            obj.txs = message.txs.map((e) => (e ? transaction_1.Transaction.toJSON(e) : undefined));
        }
        else {
            obj.txs = [];
        }
        message.minerAddress !== undefined &&
            (obj.minerAddress = base64FromBytes(message.minerAddress !== undefined
                ? message.minerAddress
                : new Uint8Array()));
        message.height !== undefined &&
            (obj.height = (message.height || long_1.default.ZERO).toString());
        message.version !== undefined &&
            (obj.version = Math.round(message.version));
        message.timestamp !== undefined &&
            (obj.timestamp = (message.timestamp || long_1.default.ZERO).toString());
        message.fee !== undefined &&
            (obj.fee = (message.fee || long_1.default.ZERO).toString());
        message.blockSize !== undefined &&
            (obj.blockSize = Math.round(message.blockSize));
        if (message.features) {
            obj.features = message.features.map((e) => Math.round(e));
        }
        else {
            obj.features = [];
        }
        return obj;
    },
    fromPartial(object) {
        var _a, _b, _c, _d, _e, _f, _g;
        const message = createBaseAppendedBlockHistory();
        message.blockSignature = (_a = object.blockSignature) !== null && _a !== void 0 ? _a : new Uint8Array();
        message.reference = (_b = object.reference) !== null && _b !== void 0 ? _b : new Uint8Array();
        message.txs = ((_c = object.txs) === null || _c === void 0 ? void 0 : _c.map((e) => transaction_1.Transaction.fromPartial(e))) || [];
        message.minerAddress = (_d = object.minerAddress) !== null && _d !== void 0 ? _d : new Uint8Array();
        message.height =
            object.height !== undefined && object.height !== null
                ? long_1.default.fromValue(object.height)
                : long_1.default.ZERO;
        message.version = (_e = object.version) !== null && _e !== void 0 ? _e : 0;
        message.timestamp =
            object.timestamp !== undefined && object.timestamp !== null
                ? long_1.default.fromValue(object.timestamp)
                : long_1.default.ZERO;
        message.fee =
            object.fee !== undefined && object.fee !== null
                ? long_1.default.fromValue(object.fee)
                : long_1.default.ZERO;
        message.blockSize = (_f = object.blockSize) !== null && _f !== void 0 ? _f : 0;
        message.features = ((_g = object.features) === null || _g === void 0 ? void 0 : _g.map((e) => e)) || [];
        return message;
    },
};
var globalThis = (() => {
    if (typeof globalThis !== "undefined")
        return globalThis;
    if (typeof self !== "undefined")
        return self;
    if (typeof window !== "undefined")
        return window;
    if (typeof global !== "undefined")
        return global;
    throw "Unable to locate global object";
})();
const atob = globalThis.atob ||
    ((b64) => globalThis.Buffer.from(b64, "base64").toString("binary"));
function bytesFromBase64(b64) {
    const bin = atob(b64);
    const arr = new Uint8Array(bin.length);
    for (let i = 0; i < bin.length; ++i) {
        arr[i] = bin.charCodeAt(i);
    }
    return arr;
}
const btoa = globalThis.btoa ||
    ((bin) => globalThis.Buffer.from(bin, "binary").toString("base64"));
function base64FromBytes(arr) {
    const bin = [];
    for (const byte of arr) {
        bin.push(String.fromCharCode(byte));
    }
    return btoa(bin.join(""));
}
if (_m0.util.Long !== long_1.default) {
    _m0.util.Long = long_1.default;
    _m0.configure();
}
function isSet(value) {
    return value !== null && value !== undefined;
}
//# sourceMappingURL=messagebroker_blockchain_event.js.map