import Long from "long";
import * as _m0 from "protobufjs/minimal";
import { OpType } from "./op_type";
import { Role } from "./role";
export declare const protobufPackage = "wavesenterprise";
export interface PermissionOp {
    opType?: OpType;
    role?: Role;
    timestamp?: Long;
    dueTimestamp?: Long;
}
export declare const PermissionOp: {
    encode(message: PermissionOp, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): PermissionOp;
    fromJSON(object: any): PermissionOp;
    toJSON(message: PermissionOp): unknown;
    fromPartial(object: DeepPartial<PermissionOp>): PermissionOp;
};
declare type Builtin = Date | Function | Uint8Array | string | number | boolean | undefined;
export declare type DeepPartial<T> = T extends Builtin ? T : T extends Long ? string | number | Long : T extends Array<infer U> ? Array<DeepPartial<U>> : T extends ReadonlyArray<infer U> ? ReadonlyArray<DeepPartial<U>> : T extends {} ? {
    [K in keyof T]?: DeepPartial<T[K]>;
} : Partial<T>;
export {};
