"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.PkiPublicServiceClient = exports.PkiPublicServiceService = exports.CertificateResponse = exports.CertByFingerprintRequest = exports.CertByPublicKeyRequest = exports.CertByDNHashRequest = exports.CertByDNRequest = exports.protobufPackage = void 0;
const long_1 = __importDefault(require("long"));
const grpc_js_1 = require("@grpc/grpc-js");
const _m0 = __importStar(require("protobufjs/minimal"));
exports.protobufPackage = "wavesenterprise.grpc";
function createBaseCertByDNRequest() {
    return { dn: "" };
}
exports.CertByDNRequest = {
    encode(message, writer = _m0.Writer.create()) {
        if (message.dn !== undefined && message.dn !== "") {
            writer.uint32(10).string(message.dn);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseCertByDNRequest();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.dn = reader.string();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        return {
            dn: isSet(object.dn) ? String(object.dn) : "",
        };
    },
    toJSON(message) {
        const obj = {};
        message.dn !== undefined && (obj.dn = message.dn);
        return obj;
    },
    fromPartial(object) {
        var _a;
        const message = createBaseCertByDNRequest();
        message.dn = (_a = object.dn) !== null && _a !== void 0 ? _a : "";
        return message;
    },
};
function createBaseCertByDNHashRequest() {
    return { dnHash: "" };
}
exports.CertByDNHashRequest = {
    encode(message, writer = _m0.Writer.create()) {
        if (message.dnHash !== undefined && message.dnHash !== "") {
            writer.uint32(10).string(message.dnHash);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseCertByDNHashRequest();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.dnHash = reader.string();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        return {
            dnHash: isSet(object.dnHash) ? String(object.dnHash) : "",
        };
    },
    toJSON(message) {
        const obj = {};
        message.dnHash !== undefined && (obj.dnHash = message.dnHash);
        return obj;
    },
    fromPartial(object) {
        var _a;
        const message = createBaseCertByDNHashRequest();
        message.dnHash = (_a = object.dnHash) !== null && _a !== void 0 ? _a : "";
        return message;
    },
};
function createBaseCertByPublicKeyRequest() {
    return { publicKeyBase58: "" };
}
exports.CertByPublicKeyRequest = {
    encode(message, writer = _m0.Writer.create()) {
        if (message.publicKeyBase58 !== undefined &&
            message.publicKeyBase58 !== "") {
            writer.uint32(10).string(message.publicKeyBase58);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseCertByPublicKeyRequest();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.publicKeyBase58 = reader.string();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        return {
            publicKeyBase58: isSet(object.publicKeyBase58)
                ? String(object.publicKeyBase58)
                : "",
        };
    },
    toJSON(message) {
        const obj = {};
        message.publicKeyBase58 !== undefined &&
            (obj.publicKeyBase58 = message.publicKeyBase58);
        return obj;
    },
    fromPartial(object) {
        var _a;
        const message = createBaseCertByPublicKeyRequest();
        message.publicKeyBase58 = (_a = object.publicKeyBase58) !== null && _a !== void 0 ? _a : "";
        return message;
    },
};
function createBaseCertByFingerprintRequest() {
    return { fingerprintBase64: "" };
}
exports.CertByFingerprintRequest = {
    encode(message, writer = _m0.Writer.create()) {
        if (message.fingerprintBase64 !== undefined &&
            message.fingerprintBase64 !== "") {
            writer.uint32(10).string(message.fingerprintBase64);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseCertByFingerprintRequest();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.fingerprintBase64 = reader.string();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        return {
            fingerprintBase64: isSet(object.fingerprintBase64)
                ? String(object.fingerprintBase64)
                : "",
        };
    },
    toJSON(message) {
        const obj = {};
        message.fingerprintBase64 !== undefined &&
            (obj.fingerprintBase64 = message.fingerprintBase64);
        return obj;
    },
    fromPartial(object) {
        var _a;
        const message = createBaseCertByFingerprintRequest();
        message.fingerprintBase64 = (_a = object.fingerprintBase64) !== null && _a !== void 0 ? _a : "";
        return message;
    },
};
function createBaseCertificateResponse() {
    return { certificate: new Uint8Array() };
}
exports.CertificateResponse = {
    encode(message, writer = _m0.Writer.create()) {
        if (message.certificate !== undefined && message.certificate.length !== 0) {
            writer.uint32(10).bytes(message.certificate);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseCertificateResponse();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.certificate = reader.bytes();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        return {
            certificate: isSet(object.certificate)
                ? bytesFromBase64(object.certificate)
                : new Uint8Array(),
        };
    },
    toJSON(message) {
        const obj = {};
        message.certificate !== undefined &&
            (obj.certificate = base64FromBytes(message.certificate !== undefined
                ? message.certificate
                : new Uint8Array()));
        return obj;
    },
    fromPartial(object) {
        var _a;
        const message = createBaseCertificateResponse();
        message.certificate = (_a = object.certificate) !== null && _a !== void 0 ? _a : new Uint8Array();
        return message;
    },
};
exports.PkiPublicServiceService = {
    getCertificateByDn: {
        path: "/wavesenterprise.grpc.PkiPublicService/GetCertificateByDn",
        requestStream: false,
        responseStream: false,
        requestSerialize: (value) => Buffer.from(exports.CertByDNRequest.encode(value).finish()),
        requestDeserialize: (value) => exports.CertByDNRequest.decode(value),
        responseSerialize: (value) => Buffer.from(exports.CertificateResponse.encode(value).finish()),
        responseDeserialize: (value) => exports.CertificateResponse.decode(value),
    },
    getCertificateByDnHash: {
        path: "/wavesenterprise.grpc.PkiPublicService/GetCertificateByDnHash",
        requestStream: false,
        responseStream: false,
        requestSerialize: (value) => Buffer.from(exports.CertByDNHashRequest.encode(value).finish()),
        requestDeserialize: (value) => exports.CertByDNHashRequest.decode(value),
        responseSerialize: (value) => Buffer.from(exports.CertificateResponse.encode(value).finish()),
        responseDeserialize: (value) => exports.CertificateResponse.decode(value),
    },
    getCertificateByPublicKey: {
        path: "/wavesenterprise.grpc.PkiPublicService/GetCertificateByPublicKey",
        requestStream: false,
        responseStream: false,
        requestSerialize: (value) => Buffer.from(exports.CertByPublicKeyRequest.encode(value).finish()),
        requestDeserialize: (value) => exports.CertByPublicKeyRequest.decode(value),
        responseSerialize: (value) => Buffer.from(exports.CertificateResponse.encode(value).finish()),
        responseDeserialize: (value) => exports.CertificateResponse.decode(value),
    },
    getCertificateByFingerprint: {
        path: "/wavesenterprise.grpc.PkiPublicService/GetCertificateByFingerprint",
        requestStream: false,
        responseStream: false,
        requestSerialize: (value) => Buffer.from(exports.CertByFingerprintRequest.encode(value).finish()),
        requestDeserialize: (value) => exports.CertByFingerprintRequest.decode(value),
        responseSerialize: (value) => Buffer.from(exports.CertificateResponse.encode(value).finish()),
        responseDeserialize: (value) => exports.CertificateResponse.decode(value),
    },
};
exports.PkiPublicServiceClient = (0, grpc_js_1.makeGenericClientConstructor)(exports.PkiPublicServiceService, "wavesenterprise.grpc.PkiPublicService");
var globalThis = (() => {
    if (typeof globalThis !== "undefined")
        return globalThis;
    if (typeof self !== "undefined")
        return self;
    if (typeof window !== "undefined")
        return window;
    if (typeof global !== "undefined")
        return global;
    throw "Unable to locate global object";
})();
const atob = globalThis.atob ||
    ((b64) => globalThis.Buffer.from(b64, "base64").toString("binary"));
function bytesFromBase64(b64) {
    const bin = atob(b64);
    const arr = new Uint8Array(bin.length);
    for (let i = 0; i < bin.length; ++i) {
        arr[i] = bin.charCodeAt(i);
    }
    return arr;
}
const btoa = globalThis.btoa ||
    ((bin) => globalThis.Buffer.from(bin, "binary").toString("base64"));
function base64FromBytes(arr) {
    const bin = [];
    for (const byte of arr) {
        bin.push(String.fromCharCode(byte));
    }
    return btoa(bin.join(""));
}
if (_m0.util.Long !== long_1.default) {
    _m0.util.Long = long_1.default;
    _m0.configure();
}
function isSet(value) {
    return value !== null && value !== undefined;
}
//# sourceMappingURL=pki_public_service.js.map