"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.PrivacyPublicServiceClient = exports.PrivacyPublicServiceService = exports.ForceSyncResponse = exports.HashesResponse = exports.PolicyIdRequest = exports.SendDataMetadata = exports.File = exports.SendLargeDataRequest = exports.SendDataRequest = exports.SendDataResponse = exports.PolicyItemFileInfo = exports.PolicyItemDataExistsResponse = exports.PolicyItemInfoResponse = exports.PolicyItemDataResponse = exports.PolicyItemRequest = exports.protobufPackage = void 0;
const long_1 = __importDefault(require("long"));
const grpc_js_1 = require("@grpc/grpc-js");
const _m0 = __importStar(require("protobufjs/minimal"));
const policy_data_hash_transaction_1 = require("../managed/policy_data_hash_transaction");
const atomic_badge_1 = require("../atomic_badge");
const address_1 = require("../entity/address");
const wrappers_1 = require("../google/protobuf/wrappers");
exports.protobufPackage = "wavesenterprise.grpc";
function createBasePolicyItemRequest() {
    return { policyId: "", dataHash: "" };
}
exports.PolicyItemRequest = {
    encode(message, writer = _m0.Writer.create()) {
        if (message.policyId !== undefined && message.policyId !== "") {
            writer.uint32(10).string(message.policyId);
        }
        if (message.dataHash !== undefined && message.dataHash !== "") {
            writer.uint32(18).string(message.dataHash);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBasePolicyItemRequest();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.policyId = reader.string();
                    break;
                case 2:
                    message.dataHash = reader.string();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        return {
            policyId: isSet(object.policyId) ? String(object.policyId) : "",
            dataHash: isSet(object.dataHash) ? String(object.dataHash) : "",
        };
    },
    toJSON(message) {
        const obj = {};
        message.policyId !== undefined && (obj.policyId = message.policyId);
        message.dataHash !== undefined && (obj.dataHash = message.dataHash);
        return obj;
    },
    fromPartial(object) {
        var _a, _b;
        const message = createBasePolicyItemRequest();
        message.policyId = (_a = object.policyId) !== null && _a !== void 0 ? _a : "";
        message.dataHash = (_b = object.dataHash) !== null && _b !== void 0 ? _b : "";
        return message;
    },
};
function createBasePolicyItemDataResponse() {
    return { data: new Uint8Array() };
}
exports.PolicyItemDataResponse = {
    encode(message, writer = _m0.Writer.create()) {
        if (message.data !== undefined && message.data.length !== 0) {
            writer.uint32(10).bytes(message.data);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBasePolicyItemDataResponse();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.data = reader.bytes();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        return {
            data: isSet(object.data)
                ? bytesFromBase64(object.data)
                : new Uint8Array(),
        };
    },
    toJSON(message) {
        const obj = {};
        message.data !== undefined &&
            (obj.data = base64FromBytes(message.data !== undefined ? message.data : new Uint8Array()));
        return obj;
    },
    fromPartial(object) {
        var _a;
        const message = createBasePolicyItemDataResponse();
        message.data = (_a = object.data) !== null && _a !== void 0 ? _a : new Uint8Array();
        return message;
    },
};
function createBasePolicyItemInfoResponse() {
    return { senderAddress: "", policyId: "", info: undefined, dataHash: "" };
}
exports.PolicyItemInfoResponse = {
    encode(message, writer = _m0.Writer.create()) {
        if (message.senderAddress !== undefined && message.senderAddress !== "") {
            writer.uint32(10).string(message.senderAddress);
        }
        if (message.policyId !== undefined && message.policyId !== "") {
            writer.uint32(18).string(message.policyId);
        }
        if (message.info !== undefined) {
            exports.PolicyItemFileInfo.encode(message.info, writer.uint32(26).fork()).ldelim();
        }
        if (message.dataHash !== undefined && message.dataHash !== "") {
            writer.uint32(34).string(message.dataHash);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBasePolicyItemInfoResponse();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.senderAddress = reader.string();
                    break;
                case 2:
                    message.policyId = reader.string();
                    break;
                case 3:
                    message.info = exports.PolicyItemFileInfo.decode(reader, reader.uint32());
                    break;
                case 4:
                    message.dataHash = reader.string();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        return {
            senderAddress: isSet(object.senderAddress)
                ? String(object.senderAddress)
                : "",
            policyId: isSet(object.policyId) ? String(object.policyId) : "",
            info: isSet(object.info)
                ? exports.PolicyItemFileInfo.fromJSON(object.info)
                : undefined,
            dataHash: isSet(object.dataHash) ? String(object.dataHash) : "",
        };
    },
    toJSON(message) {
        const obj = {};
        message.senderAddress !== undefined &&
            (obj.senderAddress = message.senderAddress);
        message.policyId !== undefined && (obj.policyId = message.policyId);
        message.info !== undefined &&
            (obj.info = message.info
                ? exports.PolicyItemFileInfo.toJSON(message.info)
                : undefined);
        message.dataHash !== undefined && (obj.dataHash = message.dataHash);
        return obj;
    },
    fromPartial(object) {
        var _a, _b, _c;
        const message = createBasePolicyItemInfoResponse();
        message.senderAddress = (_a = object.senderAddress) !== null && _a !== void 0 ? _a : "";
        message.policyId = (_b = object.policyId) !== null && _b !== void 0 ? _b : "";
        message.info =
            object.info !== undefined && object.info !== null
                ? exports.PolicyItemFileInfo.fromPartial(object.info)
                : undefined;
        message.dataHash = (_c = object.dataHash) !== null && _c !== void 0 ? _c : "";
        return message;
    },
};
function createBasePolicyItemDataExistsResponse() {
    return { exists: false };
}
exports.PolicyItemDataExistsResponse = {
    encode(message, writer = _m0.Writer.create()) {
        if (message.exists === true) {
            writer.uint32(8).bool(message.exists);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBasePolicyItemDataExistsResponse();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.exists = reader.bool();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        return {
            exists: isSet(object.exists) ? Boolean(object.exists) : false,
        };
    },
    toJSON(message) {
        const obj = {};
        message.exists !== undefined && (obj.exists = message.exists);
        return obj;
    },
    fromPartial(object) {
        var _a;
        const message = createBasePolicyItemDataExistsResponse();
        message.exists = (_a = object.exists) !== null && _a !== void 0 ? _a : false;
        return message;
    },
};
function createBasePolicyItemFileInfo() {
    return {
        filename: "",
        size: 0,
        timestamp: long_1.default.ZERO,
        author: "",
        comment: "",
    };
}
exports.PolicyItemFileInfo = {
    encode(message, writer = _m0.Writer.create()) {
        if (message.filename !== undefined && message.filename !== "") {
            writer.uint32(10).string(message.filename);
        }
        if (message.size !== undefined && message.size !== 0) {
            writer.uint32(16).int32(message.size);
        }
        if (message.timestamp !== undefined && !message.timestamp.isZero()) {
            writer.uint32(24).int64(message.timestamp);
        }
        if (message.author !== undefined && message.author !== "") {
            writer.uint32(34).string(message.author);
        }
        if (message.comment !== undefined && message.comment !== "") {
            writer.uint32(42).string(message.comment);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBasePolicyItemFileInfo();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.filename = reader.string();
                    break;
                case 2:
                    message.size = reader.int32();
                    break;
                case 3:
                    message.timestamp = reader.int64();
                    break;
                case 4:
                    message.author = reader.string();
                    break;
                case 5:
                    message.comment = reader.string();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        return {
            filename: isSet(object.filename) ? String(object.filename) : "",
            size: isSet(object.size) ? Number(object.size) : 0,
            timestamp: isSet(object.timestamp)
                ? long_1.default.fromString(object.timestamp)
                : long_1.default.ZERO,
            author: isSet(object.author) ? String(object.author) : "",
            comment: isSet(object.comment) ? String(object.comment) : "",
        };
    },
    toJSON(message) {
        const obj = {};
        message.filename !== undefined && (obj.filename = message.filename);
        message.size !== undefined && (obj.size = Math.round(message.size));
        message.timestamp !== undefined &&
            (obj.timestamp = (message.timestamp || long_1.default.ZERO).toString());
        message.author !== undefined && (obj.author = message.author);
        message.comment !== undefined && (obj.comment = message.comment);
        return obj;
    },
    fromPartial(object) {
        var _a, _b, _c, _d;
        const message = createBasePolicyItemFileInfo();
        message.filename = (_a = object.filename) !== null && _a !== void 0 ? _a : "";
        message.size = (_b = object.size) !== null && _b !== void 0 ? _b : 0;
        message.timestamp =
            object.timestamp !== undefined && object.timestamp !== null
                ? long_1.default.fromValue(object.timestamp)
                : long_1.default.ZERO;
        message.author = (_c = object.author) !== null && _c !== void 0 ? _c : "";
        message.comment = (_d = object.comment) !== null && _d !== void 0 ? _d : "";
        return message;
    },
};
function createBaseSendDataResponse() {
    return { txVersion: 0, tx: undefined };
}
exports.SendDataResponse = {
    encode(message, writer = _m0.Writer.create()) {
        if (message.txVersion !== undefined && message.txVersion !== 0) {
            writer.uint32(8).int32(message.txVersion);
        }
        if (message.tx !== undefined) {
            policy_data_hash_transaction_1.PolicyDataHashTransaction.encode(message.tx, writer.uint32(18).fork()).ldelim();
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseSendDataResponse();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.txVersion = reader.int32();
                    break;
                case 2:
                    message.tx = policy_data_hash_transaction_1.PolicyDataHashTransaction.decode(reader, reader.uint32());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        return {
            txVersion: isSet(object.txVersion) ? Number(object.txVersion) : 0,
            tx: isSet(object.tx)
                ? policy_data_hash_transaction_1.PolicyDataHashTransaction.fromJSON(object.tx)
                : undefined,
        };
    },
    toJSON(message) {
        const obj = {};
        message.txVersion !== undefined &&
            (obj.txVersion = Math.round(message.txVersion));
        message.tx !== undefined &&
            (obj.tx = message.tx
                ? policy_data_hash_transaction_1.PolicyDataHashTransaction.toJSON(message.tx)
                : undefined);
        return obj;
    },
    fromPartial(object) {
        var _a;
        const message = createBaseSendDataResponse();
        message.txVersion = (_a = object.txVersion) !== null && _a !== void 0 ? _a : 0;
        message.tx =
            object.tx !== undefined && object.tx !== null
                ? policy_data_hash_transaction_1.PolicyDataHashTransaction.fromPartial(object.tx)
                : undefined;
        return message;
    },
};
function createBaseSendDataRequest() {
    return { metadata: undefined, data: new Uint8Array() };
}
exports.SendDataRequest = {
    encode(message, writer = _m0.Writer.create()) {
        if (message.metadata !== undefined) {
            exports.SendDataMetadata.encode(message.metadata, writer.uint32(10).fork()).ldelim();
        }
        if (message.data !== undefined && message.data.length !== 0) {
            writer.uint32(18).bytes(message.data);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseSendDataRequest();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.metadata = exports.SendDataMetadata.decode(reader, reader.uint32());
                    break;
                case 2:
                    message.data = reader.bytes();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        return {
            metadata: isSet(object.metadata)
                ? exports.SendDataMetadata.fromJSON(object.metadata)
                : undefined,
            data: isSet(object.data)
                ? bytesFromBase64(object.data)
                : new Uint8Array(),
        };
    },
    toJSON(message) {
        const obj = {};
        message.metadata !== undefined &&
            (obj.metadata = message.metadata
                ? exports.SendDataMetadata.toJSON(message.metadata)
                : undefined);
        message.data !== undefined &&
            (obj.data = base64FromBytes(message.data !== undefined ? message.data : new Uint8Array()));
        return obj;
    },
    fromPartial(object) {
        var _a;
        const message = createBaseSendDataRequest();
        message.metadata =
            object.metadata !== undefined && object.metadata !== null
                ? exports.SendDataMetadata.fromPartial(object.metadata)
                : undefined;
        message.data = (_a = object.data) !== null && _a !== void 0 ? _a : new Uint8Array();
        return message;
    },
};
function createBaseSendLargeDataRequest() {
    return { metadata: undefined, file: undefined };
}
exports.SendLargeDataRequest = {
    encode(message, writer = _m0.Writer.create()) {
        if (message.metadata !== undefined) {
            exports.SendDataMetadata.encode(message.metadata, writer.uint32(10).fork()).ldelim();
        }
        if (message.file !== undefined) {
            exports.File.encode(message.file, writer.uint32(18).fork()).ldelim();
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseSendLargeDataRequest();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.metadata = exports.SendDataMetadata.decode(reader, reader.uint32());
                    break;
                case 2:
                    message.file = exports.File.decode(reader, reader.uint32());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        return {
            metadata: isSet(object.metadata)
                ? exports.SendDataMetadata.fromJSON(object.metadata)
                : undefined,
            file: isSet(object.file) ? exports.File.fromJSON(object.file) : undefined,
        };
    },
    toJSON(message) {
        const obj = {};
        message.metadata !== undefined &&
            (obj.metadata = message.metadata
                ? exports.SendDataMetadata.toJSON(message.metadata)
                : undefined);
        message.file !== undefined &&
            (obj.file = message.file ? exports.File.toJSON(message.file) : undefined);
        return obj;
    },
    fromPartial(object) {
        const message = createBaseSendLargeDataRequest();
        message.metadata =
            object.metadata !== undefined && object.metadata !== null
                ? exports.SendDataMetadata.fromPartial(object.metadata)
                : undefined;
        message.file =
            object.file !== undefined && object.file !== null
                ? exports.File.fromPartial(object.file)
                : undefined;
        return message;
    },
};
function createBaseFile() {
    return { content: new Uint8Array() };
}
exports.File = {
    encode(message, writer = _m0.Writer.create()) {
        if (message.content !== undefined && message.content.length !== 0) {
            writer.uint32(10).bytes(message.content);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseFile();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.content = reader.bytes();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        return {
            content: isSet(object.content)
                ? bytesFromBase64(object.content)
                : new Uint8Array(),
        };
    },
    toJSON(message) {
        const obj = {};
        message.content !== undefined &&
            (obj.content = base64FromBytes(message.content !== undefined ? message.content : new Uint8Array()));
        return obj;
    },
    fromPartial(object) {
        var _a;
        const message = createBaseFile();
        message.content = (_a = object.content) !== null && _a !== void 0 ? _a : new Uint8Array();
        return message;
    },
};
function createBaseSendDataMetadata() {
    return {
        senderAddress: "",
        policyId: "",
        dataHash: "",
        info: undefined,
        fee: long_1.default.ZERO,
        feeAssetId: undefined,
        atomicBadge: undefined,
        password: undefined,
        broadcastTx: false,
        certificates: [],
    };
}
exports.SendDataMetadata = {
    encode(message, writer = _m0.Writer.create()) {
        if (message.senderAddress !== undefined && message.senderAddress !== "") {
            writer.uint32(10).string(message.senderAddress);
        }
        if (message.policyId !== undefined && message.policyId !== "") {
            writer.uint32(18).string(message.policyId);
        }
        if (message.dataHash !== undefined && message.dataHash !== "") {
            writer.uint32(26).string(message.dataHash);
        }
        if (message.info !== undefined) {
            exports.PolicyItemFileInfo.encode(message.info, writer.uint32(42).fork()).ldelim();
        }
        if (message.fee !== undefined && !message.fee.isZero()) {
            writer.uint32(48).int64(message.fee);
        }
        if (message.feeAssetId !== undefined) {
            wrappers_1.StringValue.encode({ value: message.feeAssetId }, writer.uint32(58).fork()).ldelim();
        }
        if (message.atomicBadge !== undefined) {
            atomic_badge_1.AtomicBadge.encode(message.atomicBadge, writer.uint32(66).fork()).ldelim();
        }
        if (message.password !== undefined) {
            wrappers_1.StringValue.encode({ value: message.password }, writer.uint32(74).fork()).ldelim();
        }
        if (message.broadcastTx === true) {
            writer.uint32(80).bool(message.broadcastTx);
        }
        if (message.certificates !== undefined &&
            message.certificates.length !== 0) {
            for (const v of message.certificates) {
                writer.uint32(90).bytes(v);
            }
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseSendDataMetadata();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.senderAddress = reader.string();
                    break;
                case 2:
                    message.policyId = reader.string();
                    break;
                case 3:
                    message.dataHash = reader.string();
                    break;
                case 5:
                    message.info = exports.PolicyItemFileInfo.decode(reader, reader.uint32());
                    break;
                case 6:
                    message.fee = reader.int64();
                    break;
                case 7:
                    message.feeAssetId = wrappers_1.StringValue.decode(reader, reader.uint32()).value;
                    break;
                case 8:
                    message.atomicBadge = atomic_badge_1.AtomicBadge.decode(reader, reader.uint32());
                    break;
                case 9:
                    message.password = wrappers_1.StringValue.decode(reader, reader.uint32()).value;
                    break;
                case 10:
                    message.broadcastTx = reader.bool();
                    break;
                case 11:
                    message.certificates.push(reader.bytes());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        return {
            senderAddress: isSet(object.senderAddress)
                ? String(object.senderAddress)
                : "",
            policyId: isSet(object.policyId) ? String(object.policyId) : "",
            dataHash: isSet(object.dataHash) ? String(object.dataHash) : "",
            info: isSet(object.info)
                ? exports.PolicyItemFileInfo.fromJSON(object.info)
                : undefined,
            fee: isSet(object.fee) ? long_1.default.fromString(object.fee) : long_1.default.ZERO,
            feeAssetId: isSet(object.feeAssetId)
                ? String(object.feeAssetId)
                : undefined,
            atomicBadge: isSet(object.atomicBadge)
                ? atomic_badge_1.AtomicBadge.fromJSON(object.atomicBadge)
                : undefined,
            password: isSet(object.password) ? String(object.password) : undefined,
            broadcastTx: isSet(object.broadcastTx)
                ? Boolean(object.broadcastTx)
                : false,
            certificates: Array.isArray(object === null || object === void 0 ? void 0 : object.certificates)
                ? object.certificates.map((e) => bytesFromBase64(e))
                : [],
        };
    },
    toJSON(message) {
        const obj = {};
        message.senderAddress !== undefined &&
            (obj.senderAddress = message.senderAddress);
        message.policyId !== undefined && (obj.policyId = message.policyId);
        message.dataHash !== undefined && (obj.dataHash = message.dataHash);
        message.info !== undefined &&
            (obj.info = message.info
                ? exports.PolicyItemFileInfo.toJSON(message.info)
                : undefined);
        message.fee !== undefined &&
            (obj.fee = (message.fee || long_1.default.ZERO).toString());
        message.feeAssetId !== undefined && (obj.feeAssetId = message.feeAssetId);
        message.atomicBadge !== undefined &&
            (obj.atomicBadge = message.atomicBadge
                ? atomic_badge_1.AtomicBadge.toJSON(message.atomicBadge)
                : undefined);
        message.password !== undefined && (obj.password = message.password);
        message.broadcastTx !== undefined &&
            (obj.broadcastTx = message.broadcastTx);
        if (message.certificates) {
            obj.certificates = message.certificates.map((e) => base64FromBytes(e !== undefined ? e : new Uint8Array()));
        }
        else {
            obj.certificates = [];
        }
        return obj;
    },
    fromPartial(object) {
        var _a, _b, _c, _d, _e, _f, _g;
        const message = createBaseSendDataMetadata();
        message.senderAddress = (_a = object.senderAddress) !== null && _a !== void 0 ? _a : "";
        message.policyId = (_b = object.policyId) !== null && _b !== void 0 ? _b : "";
        message.dataHash = (_c = object.dataHash) !== null && _c !== void 0 ? _c : "";
        message.info =
            object.info !== undefined && object.info !== null
                ? exports.PolicyItemFileInfo.fromPartial(object.info)
                : undefined;
        message.fee =
            object.fee !== undefined && object.fee !== null
                ? long_1.default.fromValue(object.fee)
                : long_1.default.ZERO;
        message.feeAssetId = (_d = object.feeAssetId) !== null && _d !== void 0 ? _d : undefined;
        message.atomicBadge =
            object.atomicBadge !== undefined && object.atomicBadge !== null
                ? atomic_badge_1.AtomicBadge.fromPartial(object.atomicBadge)
                : undefined;
        message.password = (_e = object.password) !== null && _e !== void 0 ? _e : undefined;
        message.broadcastTx = (_f = object.broadcastTx) !== null && _f !== void 0 ? _f : false;
        message.certificates = ((_g = object.certificates) === null || _g === void 0 ? void 0 : _g.map((e) => e)) || [];
        return message;
    },
};
function createBasePolicyIdRequest() {
    return { policyId: "" };
}
exports.PolicyIdRequest = {
    encode(message, writer = _m0.Writer.create()) {
        if (message.policyId !== undefined && message.policyId !== "") {
            writer.uint32(10).string(message.policyId);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBasePolicyIdRequest();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.policyId = reader.string();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        return {
            policyId: isSet(object.policyId) ? String(object.policyId) : "",
        };
    },
    toJSON(message) {
        const obj = {};
        message.policyId !== undefined && (obj.policyId = message.policyId);
        return obj;
    },
    fromPartial(object) {
        var _a;
        const message = createBasePolicyIdRequest();
        message.policyId = (_a = object.policyId) !== null && _a !== void 0 ? _a : "";
        return message;
    },
};
function createBaseHashesResponse() {
    return { hashes: [] };
}
exports.HashesResponse = {
    encode(message, writer = _m0.Writer.create()) {
        if (message.hashes !== undefined && message.hashes.length !== 0) {
            for (const v of message.hashes) {
                writer.uint32(10).string(v);
            }
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseHashesResponse();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.hashes.push(reader.string());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        return {
            hashes: Array.isArray(object === null || object === void 0 ? void 0 : object.hashes)
                ? object.hashes.map((e) => String(e))
                : [],
        };
    },
    toJSON(message) {
        const obj = {};
        if (message.hashes) {
            obj.hashes = message.hashes.map((e) => e);
        }
        else {
            obj.hashes = [];
        }
        return obj;
    },
    fromPartial(object) {
        var _a;
        const message = createBaseHashesResponse();
        message.hashes = ((_a = object.hashes) === null || _a === void 0 ? void 0 : _a.map((e) => e)) || [];
        return message;
    },
};
function createBaseForceSyncResponse() {
    return { forceRestarted: 0 };
}
exports.ForceSyncResponse = {
    encode(message, writer = _m0.Writer.create()) {
        if (message.forceRestarted !== undefined && message.forceRestarted !== 0) {
            writer.uint32(8).int32(message.forceRestarted);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseForceSyncResponse();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.forceRestarted = reader.int32();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        return {
            forceRestarted: isSet(object.forceRestarted)
                ? Number(object.forceRestarted)
                : 0,
        };
    },
    toJSON(message) {
        const obj = {};
        message.forceRestarted !== undefined &&
            (obj.forceRestarted = Math.round(message.forceRestarted));
        return obj;
    },
    fromPartial(object) {
        var _a;
        const message = createBaseForceSyncResponse();
        message.forceRestarted = (_a = object.forceRestarted) !== null && _a !== void 0 ? _a : 0;
        return message;
    },
};
exports.PrivacyPublicServiceService = {
    getPolicyItemData: {
        path: "/wavesenterprise.grpc.PrivacyPublicService/GetPolicyItemData",
        requestStream: false,
        responseStream: false,
        requestSerialize: (value) => Buffer.from(exports.PolicyItemRequest.encode(value).finish()),
        requestDeserialize: (value) => exports.PolicyItemRequest.decode(value),
        responseSerialize: (value) => Buffer.from(exports.PolicyItemDataResponse.encode(value).finish()),
        responseDeserialize: (value) => exports.PolicyItemDataResponse.decode(value),
    },
    getPolicyItemLargeData: {
        path: "/wavesenterprise.grpc.PrivacyPublicService/GetPolicyItemLargeData",
        requestStream: false,
        responseStream: true,
        requestSerialize: (value) => Buffer.from(exports.PolicyItemRequest.encode(value).finish()),
        requestDeserialize: (value) => exports.PolicyItemRequest.decode(value),
        responseSerialize: (value) => Buffer.from(exports.PolicyItemDataResponse.encode(value).finish()),
        responseDeserialize: (value) => exports.PolicyItemDataResponse.decode(value),
    },
    getPolicyItemInfo: {
        path: "/wavesenterprise.grpc.PrivacyPublicService/GetPolicyItemInfo",
        requestStream: false,
        responseStream: false,
        requestSerialize: (value) => Buffer.from(exports.PolicyItemRequest.encode(value).finish()),
        requestDeserialize: (value) => exports.PolicyItemRequest.decode(value),
        responseSerialize: (value) => Buffer.from(exports.PolicyItemInfoResponse.encode(value).finish()),
        responseDeserialize: (value) => exports.PolicyItemInfoResponse.decode(value),
    },
    policyItemDataExists: {
        path: "/wavesenterprise.grpc.PrivacyPublicService/PolicyItemDataExists",
        requestStream: false,
        responseStream: false,
        requestSerialize: (value) => Buffer.from(exports.PolicyItemRequest.encode(value).finish()),
        requestDeserialize: (value) => exports.PolicyItemRequest.decode(value),
        responseSerialize: (value) => Buffer.from(exports.PolicyItemDataExistsResponse.encode(value).finish()),
        responseDeserialize: (value) => exports.PolicyItemDataExistsResponse.decode(value),
    },
    sendData: {
        path: "/wavesenterprise.grpc.PrivacyPublicService/SendData",
        requestStream: false,
        responseStream: false,
        requestSerialize: (value) => Buffer.from(exports.SendDataRequest.encode(value).finish()),
        requestDeserialize: (value) => exports.SendDataRequest.decode(value),
        responseSerialize: (value) => Buffer.from(exports.SendDataResponse.encode(value).finish()),
        responseDeserialize: (value) => exports.SendDataResponse.decode(value),
    },
    sendLargeData: {
        path: "/wavesenterprise.grpc.PrivacyPublicService/SendLargeData",
        requestStream: true,
        responseStream: false,
        requestSerialize: (value) => Buffer.from(exports.SendLargeDataRequest.encode(value).finish()),
        requestDeserialize: (value) => exports.SendLargeDataRequest.decode(value),
        responseSerialize: (value) => Buffer.from(exports.SendDataResponse.encode(value).finish()),
        responseDeserialize: (value) => exports.SendDataResponse.decode(value),
    },
    recipients: {
        path: "/wavesenterprise.grpc.PrivacyPublicService/Recipients",
        requestStream: false,
        responseStream: false,
        requestSerialize: (value) => Buffer.from(exports.PolicyIdRequest.encode(value).finish()),
        requestDeserialize: (value) => exports.PolicyIdRequest.decode(value),
        responseSerialize: (value) => Buffer.from(address_1.AddressesResponse.encode(value).finish()),
        responseDeserialize: (value) => address_1.AddressesResponse.decode(value),
    },
    owners: {
        path: "/wavesenterprise.grpc.PrivacyPublicService/Owners",
        requestStream: false,
        responseStream: false,
        requestSerialize: (value) => Buffer.from(exports.PolicyIdRequest.encode(value).finish()),
        requestDeserialize: (value) => exports.PolicyIdRequest.decode(value),
        responseSerialize: (value) => Buffer.from(address_1.AddressesResponse.encode(value).finish()),
        responseDeserialize: (value) => address_1.AddressesResponse.decode(value),
    },
    hashes: {
        path: "/wavesenterprise.grpc.PrivacyPublicService/Hashes",
        requestStream: false,
        responseStream: false,
        requestSerialize: (value) => Buffer.from(exports.PolicyIdRequest.encode(value).finish()),
        requestDeserialize: (value) => exports.PolicyIdRequest.decode(value),
        responseSerialize: (value) => Buffer.from(exports.HashesResponse.encode(value).finish()),
        responseDeserialize: (value) => exports.HashesResponse.decode(value),
    },
    forceSync: {
        path: "/wavesenterprise.grpc.PrivacyPublicService/ForceSync",
        requestStream: false,
        responseStream: false,
        requestSerialize: (value) => Buffer.from(exports.PolicyIdRequest.encode(value).finish()),
        requestDeserialize: (value) => exports.PolicyIdRequest.decode(value),
        responseSerialize: (value) => Buffer.from(exports.ForceSyncResponse.encode(value).finish()),
        responseDeserialize: (value) => exports.ForceSyncResponse.decode(value),
    },
};
exports.PrivacyPublicServiceClient = (0, grpc_js_1.makeGenericClientConstructor)(exports.PrivacyPublicServiceService, "wavesenterprise.grpc.PrivacyPublicService");
var globalThis = (() => {
    if (typeof globalThis !== "undefined")
        return globalThis;
    if (typeof self !== "undefined")
        return self;
    if (typeof window !== "undefined")
        return window;
    if (typeof global !== "undefined")
        return global;
    throw "Unable to locate global object";
})();
const atob = globalThis.atob ||
    ((b64) => globalThis.Buffer.from(b64, "base64").toString("binary"));
function bytesFromBase64(b64) {
    const bin = atob(b64);
    const arr = new Uint8Array(bin.length);
    for (let i = 0; i < bin.length; ++i) {
        arr[i] = bin.charCodeAt(i);
    }
    return arr;
}
const btoa = globalThis.btoa ||
    ((bin) => globalThis.Buffer.from(bin, "binary").toString("base64"));
function base64FromBytes(arr) {
    const bin = [];
    for (const byte of arr) {
        bin.push(String.fromCharCode(byte));
    }
    return btoa(bin.join(""));
}
if (_m0.util.Long !== long_1.default) {
    _m0.util.Long = long_1.default;
    _m0.configure();
}
function isSet(value) {
    return value !== null && value !== undefined;
}
//# sourceMappingURL=privacy_public_service.js.map