"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.NodeInfoServiceClient = exports.NodeInfoServiceService = exports.AddressWithPubKeyResponse = exports.PosRoundInfo = exports.PoaRoundInfo = exports.NodeConfigResponse_AdditionalFeeEntry = exports.NodeConfigResponse_MinimumFeeEntry = exports.NodeConfigResponse = exports.protobufPackage = void 0;
const long_1 = __importDefault(require("long"));
const grpc_js_1 = require("@grpc/grpc-js");
const _m0 = __importStar(require("protobufjs/minimal"));
const constants_1 = require("../constants");
const duration_1 = require("../google/protobuf/duration");
const empty_1 = require("../google/protobuf/empty");
exports.protobufPackage = "wavesenterprise";
function createBaseNodeConfigResponse() {
    return {
        version: "",
        cryptoType: 0,
        chainId: 0,
        consensus: 0,
        minimumFee: {},
        additionalFee: {},
        maxTransactionsInMicroBlock: 0,
        minMicroBlockAge: undefined,
        microBlockInterval: undefined,
        pkiMode: 0,
        requiredOids: [],
        crlCheckEnabled: false,
        poaRoundInfo: undefined,
        posRoundInfo: undefined,
    };
}
exports.NodeConfigResponse = {
    encode(message, writer = _m0.Writer.create()) {
        if (message.version !== undefined && message.version !== "") {
            writer.uint32(10).string(message.version);
        }
        if (message.cryptoType !== undefined && message.cryptoType !== 0) {
            writer.uint32(16).int32(message.cryptoType);
        }
        if (message.chainId !== undefined && message.chainId !== 0) {
            writer.uint32(24).int32(message.chainId);
        }
        if (message.consensus !== undefined && message.consensus !== 0) {
            writer.uint32(32).int32(message.consensus);
        }
        Object.entries(message.minimumFee || {}).forEach(([key, value]) => {
            exports.NodeConfigResponse_MinimumFeeEntry.encode({ key: key, value }, writer.uint32(42).fork()).ldelim();
        });
        Object.entries(message.additionalFee || {}).forEach(([key, value]) => {
            exports.NodeConfigResponse_AdditionalFeeEntry.encode({ key: key, value }, writer.uint32(50).fork()).ldelim();
        });
        if (message.maxTransactionsInMicroBlock !== undefined &&
            message.maxTransactionsInMicroBlock !== 0) {
            writer.uint32(56).int32(message.maxTransactionsInMicroBlock);
        }
        if (message.minMicroBlockAge !== undefined) {
            duration_1.Duration.encode(message.minMicroBlockAge, writer.uint32(66).fork()).ldelim();
        }
        if (message.microBlockInterval !== undefined) {
            duration_1.Duration.encode(message.microBlockInterval, writer.uint32(74).fork()).ldelim();
        }
        if (message.pkiMode !== undefined && message.pkiMode !== 0) {
            writer.uint32(80).int32(message.pkiMode);
        }
        if (message.requiredOids !== undefined &&
            message.requiredOids.length !== 0) {
            for (const v of message.requiredOids) {
                writer.uint32(90).string(v);
            }
        }
        if (message.crlCheckEnabled === true) {
            writer.uint32(96).bool(message.crlCheckEnabled);
        }
        if (message.poaRoundInfo !== undefined) {
            exports.PoaRoundInfo.encode(message.poaRoundInfo, writer.uint32(810).fork()).ldelim();
        }
        if (message.posRoundInfo !== undefined) {
            exports.PosRoundInfo.encode(message.posRoundInfo, writer.uint32(818).fork()).ldelim();
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseNodeConfigResponse();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.version = reader.string();
                    break;
                case 2:
                    message.cryptoType = reader.int32();
                    break;
                case 3:
                    message.chainId = reader.int32();
                    break;
                case 4:
                    message.consensus = reader.int32();
                    break;
                case 5:
                    const entry5 = exports.NodeConfigResponse_MinimumFeeEntry.decode(reader, reader.uint32());
                    if (entry5.value !== undefined) {
                        message.minimumFee[entry5.key] = entry5.value;
                    }
                    break;
                case 6:
                    const entry6 = exports.NodeConfigResponse_AdditionalFeeEntry.decode(reader, reader.uint32());
                    if (entry6.value !== undefined) {
                        message.additionalFee[entry6.key] = entry6.value;
                    }
                    break;
                case 7:
                    message.maxTransactionsInMicroBlock = reader.int32();
                    break;
                case 8:
                    message.minMicroBlockAge = duration_1.Duration.decode(reader, reader.uint32());
                    break;
                case 9:
                    message.microBlockInterval = duration_1.Duration.decode(reader, reader.uint32());
                    break;
                case 10:
                    message.pkiMode = reader.int32();
                    break;
                case 11:
                    message.requiredOids.push(reader.string());
                    break;
                case 12:
                    message.crlCheckEnabled = reader.bool();
                    break;
                case 101:
                    message.poaRoundInfo = exports.PoaRoundInfo.decode(reader, reader.uint32());
                    break;
                case 102:
                    message.posRoundInfo = exports.PosRoundInfo.decode(reader, reader.uint32());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        return {
            version: isSet(object.version) ? String(object.version) : "",
            cryptoType: isSet(object.cryptoType)
                ? (0, constants_1.cryptoTypeFromJSON)(object.cryptoType)
                : 0,
            chainId: isSet(object.chainId) ? Number(object.chainId) : 0,
            consensus: isSet(object.consensus)
                ? (0, constants_1.consensusTypeFromJSON)(object.consensus)
                : 0,
            minimumFee: isObject(object.minimumFee)
                ? Object.entries(object.minimumFee).reduce((acc, [key, value]) => {
                    acc[key] = long_1.default.fromValue(value);
                    return acc;
                }, {})
                : {},
            additionalFee: isObject(object.additionalFee)
                ? Object.entries(object.additionalFee).reduce((acc, [key, value]) => {
                    acc[key] = long_1.default.fromValue(value);
                    return acc;
                }, {})
                : {},
            maxTransactionsInMicroBlock: isSet(object.maxTransactionsInMicroBlock)
                ? Number(object.maxTransactionsInMicroBlock)
                : 0,
            minMicroBlockAge: isSet(object.minMicroBlockAge)
                ? duration_1.Duration.fromJSON(object.minMicroBlockAge)
                : undefined,
            microBlockInterval: isSet(object.microBlockInterval)
                ? duration_1.Duration.fromJSON(object.microBlockInterval)
                : undefined,
            pkiMode: isSet(object.pkiMode) ? (0, constants_1.pkiModeFromJSON)(object.pkiMode) : 0,
            requiredOids: Array.isArray(object === null || object === void 0 ? void 0 : object.requiredOids)
                ? object.requiredOids.map((e) => String(e))
                : [],
            crlCheckEnabled: isSet(object.crlCheckEnabled)
                ? Boolean(object.crlCheckEnabled)
                : false,
            poaRoundInfo: isSet(object.poaRoundInfo)
                ? exports.PoaRoundInfo.fromJSON(object.poaRoundInfo)
                : undefined,
            posRoundInfo: isSet(object.posRoundInfo)
                ? exports.PosRoundInfo.fromJSON(object.posRoundInfo)
                : undefined,
        };
    },
    toJSON(message) {
        const obj = {};
        message.version !== undefined && (obj.version = message.version);
        message.cryptoType !== undefined &&
            (obj.cryptoType = (0, constants_1.cryptoTypeToJSON)(message.cryptoType));
        message.chainId !== undefined &&
            (obj.chainId = Math.round(message.chainId));
        message.consensus !== undefined &&
            (obj.consensus = (0, constants_1.consensusTypeToJSON)(message.consensus));
        obj.minimumFee = {};
        if (message.minimumFee) {
            Object.entries(message.minimumFee).forEach(([k, v]) => {
                obj.minimumFee[k] = v.toString();
            });
        }
        obj.additionalFee = {};
        if (message.additionalFee) {
            Object.entries(message.additionalFee).forEach(([k, v]) => {
                obj.additionalFee[k] = v.toString();
            });
        }
        message.maxTransactionsInMicroBlock !== undefined &&
            (obj.maxTransactionsInMicroBlock = Math.round(message.maxTransactionsInMicroBlock));
        message.minMicroBlockAge !== undefined &&
            (obj.minMicroBlockAge = message.minMicroBlockAge
                ? duration_1.Duration.toJSON(message.minMicroBlockAge)
                : undefined);
        message.microBlockInterval !== undefined &&
            (obj.microBlockInterval = message.microBlockInterval
                ? duration_1.Duration.toJSON(message.microBlockInterval)
                : undefined);
        message.pkiMode !== undefined &&
            (obj.pkiMode = (0, constants_1.pkiModeToJSON)(message.pkiMode));
        if (message.requiredOids) {
            obj.requiredOids = message.requiredOids.map((e) => e);
        }
        else {
            obj.requiredOids = [];
        }
        message.crlCheckEnabled !== undefined &&
            (obj.crlCheckEnabled = message.crlCheckEnabled);
        message.poaRoundInfo !== undefined &&
            (obj.poaRoundInfo = message.poaRoundInfo
                ? exports.PoaRoundInfo.toJSON(message.poaRoundInfo)
                : undefined);
        message.posRoundInfo !== undefined &&
            (obj.posRoundInfo = message.posRoundInfo
                ? exports.PosRoundInfo.toJSON(message.posRoundInfo)
                : undefined);
        return obj;
    },
    fromPartial(object) {
        var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k;
        const message = createBaseNodeConfigResponse();
        message.version = (_a = object.version) !== null && _a !== void 0 ? _a : "";
        message.cryptoType = (_b = object.cryptoType) !== null && _b !== void 0 ? _b : 0;
        message.chainId = (_c = object.chainId) !== null && _c !== void 0 ? _c : 0;
        message.consensus = (_d = object.consensus) !== null && _d !== void 0 ? _d : 0;
        message.minimumFee = Object.entries((_e = object.minimumFee) !== null && _e !== void 0 ? _e : {}).reduce((acc, [key, value]) => {
            if (value !== undefined) {
                acc[key] = long_1.default.fromValue(value);
            }
            return acc;
        }, {});
        message.additionalFee = Object.entries((_f = object.additionalFee) !== null && _f !== void 0 ? _f : {}).reduce((acc, [key, value]) => {
            if (value !== undefined) {
                acc[key] = long_1.default.fromValue(value);
            }
            return acc;
        }, {});
        message.maxTransactionsInMicroBlock =
            (_g = object.maxTransactionsInMicroBlock) !== null && _g !== void 0 ? _g : 0;
        message.minMicroBlockAge =
            object.minMicroBlockAge !== undefined && object.minMicroBlockAge !== null
                ? duration_1.Duration.fromPartial(object.minMicroBlockAge)
                : undefined;
        message.microBlockInterval =
            object.microBlockInterval !== undefined &&
                object.microBlockInterval !== null
                ? duration_1.Duration.fromPartial(object.microBlockInterval)
                : undefined;
        message.pkiMode = (_h = object.pkiMode) !== null && _h !== void 0 ? _h : 0;
        message.requiredOids = ((_j = object.requiredOids) === null || _j === void 0 ? void 0 : _j.map((e) => e)) || [];
        message.crlCheckEnabled = (_k = object.crlCheckEnabled) !== null && _k !== void 0 ? _k : false;
        message.poaRoundInfo =
            object.poaRoundInfo !== undefined && object.poaRoundInfo !== null
                ? exports.PoaRoundInfo.fromPartial(object.poaRoundInfo)
                : undefined;
        message.posRoundInfo =
            object.posRoundInfo !== undefined && object.posRoundInfo !== null
                ? exports.PosRoundInfo.fromPartial(object.posRoundInfo)
                : undefined;
        return message;
    },
};
function createBaseNodeConfigResponse_MinimumFeeEntry() {
    return { key: "", value: long_1.default.ZERO };
}
exports.NodeConfigResponse_MinimumFeeEntry = {
    encode(message, writer = _m0.Writer.create()) {
        if (message.key !== "") {
            writer.uint32(10).string(message.key);
        }
        if (!message.value.isZero()) {
            writer.uint32(16).int64(message.value);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseNodeConfigResponse_MinimumFeeEntry();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.key = reader.string();
                    break;
                case 2:
                    message.value = reader.int64();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        return {
            key: isSet(object.key) ? String(object.key) : "",
            value: isSet(object.value) ? long_1.default.fromString(object.value) : long_1.default.ZERO,
        };
    },
    toJSON(message) {
        const obj = {};
        message.key !== undefined && (obj.key = message.key);
        message.value !== undefined &&
            (obj.value = (message.value || long_1.default.ZERO).toString());
        return obj;
    },
    fromPartial(object) {
        var _a;
        const message = createBaseNodeConfigResponse_MinimumFeeEntry();
        message.key = (_a = object.key) !== null && _a !== void 0 ? _a : "";
        message.value =
            object.value !== undefined && object.value !== null
                ? long_1.default.fromValue(object.value)
                : long_1.default.ZERO;
        return message;
    },
};
function createBaseNodeConfigResponse_AdditionalFeeEntry() {
    return { key: "", value: long_1.default.ZERO };
}
exports.NodeConfigResponse_AdditionalFeeEntry = {
    encode(message, writer = _m0.Writer.create()) {
        if (message.key !== "") {
            writer.uint32(10).string(message.key);
        }
        if (!message.value.isZero()) {
            writer.uint32(16).int64(message.value);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseNodeConfigResponse_AdditionalFeeEntry();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.key = reader.string();
                    break;
                case 2:
                    message.value = reader.int64();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        return {
            key: isSet(object.key) ? String(object.key) : "",
            value: isSet(object.value) ? long_1.default.fromString(object.value) : long_1.default.ZERO,
        };
    },
    toJSON(message) {
        const obj = {};
        message.key !== undefined && (obj.key = message.key);
        message.value !== undefined &&
            (obj.value = (message.value || long_1.default.ZERO).toString());
        return obj;
    },
    fromPartial(object) {
        var _a;
        const message = createBaseNodeConfigResponse_AdditionalFeeEntry();
        message.key = (_a = object.key) !== null && _a !== void 0 ? _a : "";
        message.value =
            object.value !== undefined && object.value !== null
                ? long_1.default.fromValue(object.value)
                : long_1.default.ZERO;
        return message;
    },
};
function createBasePoaRoundInfo() {
    return { roundDuration: undefined, syncDuration: undefined };
}
exports.PoaRoundInfo = {
    encode(message, writer = _m0.Writer.create()) {
        if (message.roundDuration !== undefined) {
            duration_1.Duration.encode(message.roundDuration, writer.uint32(10).fork()).ldelim();
        }
        if (message.syncDuration !== undefined) {
            duration_1.Duration.encode(message.syncDuration, writer.uint32(18).fork()).ldelim();
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBasePoaRoundInfo();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.roundDuration = duration_1.Duration.decode(reader, reader.uint32());
                    break;
                case 2:
                    message.syncDuration = duration_1.Duration.decode(reader, reader.uint32());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        return {
            roundDuration: isSet(object.roundDuration)
                ? duration_1.Duration.fromJSON(object.roundDuration)
                : undefined,
            syncDuration: isSet(object.syncDuration)
                ? duration_1.Duration.fromJSON(object.syncDuration)
                : undefined,
        };
    },
    toJSON(message) {
        const obj = {};
        message.roundDuration !== undefined &&
            (obj.roundDuration = message.roundDuration
                ? duration_1.Duration.toJSON(message.roundDuration)
                : undefined);
        message.syncDuration !== undefined &&
            (obj.syncDuration = message.syncDuration
                ? duration_1.Duration.toJSON(message.syncDuration)
                : undefined);
        return obj;
    },
    fromPartial(object) {
        const message = createBasePoaRoundInfo();
        message.roundDuration =
            object.roundDuration !== undefined && object.roundDuration !== null
                ? duration_1.Duration.fromPartial(object.roundDuration)
                : undefined;
        message.syncDuration =
            object.syncDuration !== undefined && object.syncDuration !== null
                ? duration_1.Duration.fromPartial(object.syncDuration)
                : undefined;
        return message;
    },
};
function createBasePosRoundInfo() {
    return { averageBlockDelay: undefined };
}
exports.PosRoundInfo = {
    encode(message, writer = _m0.Writer.create()) {
        if (message.averageBlockDelay !== undefined) {
            duration_1.Duration.encode(message.averageBlockDelay, writer.uint32(10).fork()).ldelim();
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBasePosRoundInfo();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.averageBlockDelay = duration_1.Duration.decode(reader, reader.uint32());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        return {
            averageBlockDelay: isSet(object.averageBlockDelay)
                ? duration_1.Duration.fromJSON(object.averageBlockDelay)
                : undefined,
        };
    },
    toJSON(message) {
        const obj = {};
        message.averageBlockDelay !== undefined &&
            (obj.averageBlockDelay = message.averageBlockDelay
                ? duration_1.Duration.toJSON(message.averageBlockDelay)
                : undefined);
        return obj;
    },
    fromPartial(object) {
        const message = createBasePosRoundInfo();
        message.averageBlockDelay =
            object.averageBlockDelay !== undefined &&
                object.averageBlockDelay !== null
                ? duration_1.Duration.fromPartial(object.averageBlockDelay)
                : undefined;
        return message;
    },
};
function createBaseAddressWithPubKeyResponse() {
    return { address: "", publicKey: "" };
}
exports.AddressWithPubKeyResponse = {
    encode(message, writer = _m0.Writer.create()) {
        if (message.address !== undefined && message.address !== "") {
            writer.uint32(10).string(message.address);
        }
        if (message.publicKey !== undefined && message.publicKey !== "") {
            writer.uint32(18).string(message.publicKey);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseAddressWithPubKeyResponse();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.address = reader.string();
                    break;
                case 2:
                    message.publicKey = reader.string();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        return {
            address: isSet(object.address) ? String(object.address) : "",
            publicKey: isSet(object.publicKey) ? String(object.publicKey) : "",
        };
    },
    toJSON(message) {
        const obj = {};
        message.address !== undefined && (obj.address = message.address);
        message.publicKey !== undefined && (obj.publicKey = message.publicKey);
        return obj;
    },
    fromPartial(object) {
        var _a, _b;
        const message = createBaseAddressWithPubKeyResponse();
        message.address = (_a = object.address) !== null && _a !== void 0 ? _a : "";
        message.publicKey = (_b = object.publicKey) !== null && _b !== void 0 ? _b : "";
        return message;
    },
};
exports.NodeInfoServiceService = {
    nodeConfig: {
        path: "/wavesenterprise.NodeInfoService/NodeConfig",
        requestStream: false,
        responseStream: false,
        requestSerialize: (value) => Buffer.from(empty_1.Empty.encode(value).finish()),
        requestDeserialize: (value) => empty_1.Empty.decode(value),
        responseSerialize: (value) => Buffer.from(exports.NodeConfigResponse.encode(value).finish()),
        responseDeserialize: (value) => exports.NodeConfigResponse.decode(value),
    },
    nodeOwner: {
        path: "/wavesenterprise.NodeInfoService/NodeOwner",
        requestStream: false,
        responseStream: false,
        requestSerialize: (value) => Buffer.from(empty_1.Empty.encode(value).finish()),
        requestDeserialize: (value) => empty_1.Empty.decode(value),
        responseSerialize: (value) => Buffer.from(exports.AddressWithPubKeyResponse.encode(value).finish()),
        responseDeserialize: (value) => exports.AddressWithPubKeyResponse.decode(value),
    },
};
exports.NodeInfoServiceClient = (0, grpc_js_1.makeGenericClientConstructor)(exports.NodeInfoServiceService, "wavesenterprise.NodeInfoService");
if (_m0.util.Long !== long_1.default) {
    _m0.util.Long = long_1.default;
    _m0.configure();
}
function isObject(value) {
    return typeof value === "object" && value !== null;
}
function isSet(value) {
    return value !== null && value !== undefined;
}
//# sourceMappingURL=util_node_info_service.js.map