import Long from "long";
import * as _m0 from "protobufjs/minimal";
import { Transaction } from "../managed/transaction";
export declare const protobufPackage = "wavesenterprise";
export interface TransactionInfoRequest {
    txId?: string;
}
export interface TransactionInfoResponse {
    height?: number;
    transaction?: Transaction;
}
export interface TransactionWithCertChain {
    transaction?: Transaction;
    certificates?: Uint8Array[];
}
export declare const TransactionInfoRequest: {
    encode(message: TransactionInfoRequest, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): TransactionInfoRequest;
    fromJSON(object: any): TransactionInfoRequest;
    toJSON(message: TransactionInfoRequest): unknown;
    fromPartial(object: DeepPartial<TransactionInfoRequest>): TransactionInfoRequest;
};
export declare const TransactionInfoResponse: {
    encode(message: TransactionInfoResponse, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): TransactionInfoResponse;
    fromJSON(object: any): TransactionInfoResponse;
    toJSON(message: TransactionInfoResponse): unknown;
    fromPartial(object: DeepPartial<TransactionInfoResponse>): TransactionInfoResponse;
};
export declare const TransactionWithCertChain: {
    encode(message: TransactionWithCertChain, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): TransactionWithCertChain;
    fromJSON(object: any): TransactionWithCertChain;
    toJSON(message: TransactionWithCertChain): unknown;
    fromPartial(object: DeepPartial<TransactionWithCertChain>): TransactionWithCertChain;
};
declare type Builtin = Date | Function | Uint8Array | string | number | boolean | undefined;
export declare type DeepPartial<T> = T extends Builtin ? T : T extends Long ? string | number | Long : T extends Array<infer U> ? Array<DeepPartial<U>> : T extends ReadonlyArray<infer U> ? ReadonlyArray<DeepPartial<U>> : T extends {} ? {
    [K in keyof T]?: DeepPartial<T[K]>;
} : Partial<T>;
export {};
