import Long from "long";
import * as _m0 from "protobufjs/minimal";
export declare const protobufPackage = "wavesenterprise";
export interface ValidationPolicy {
    any?: ValidationPolicy_Any | undefined;
    majority?: ValidationPolicy_Majority | undefined;
    majorityWithOneOf?: ValidationPolicy_MajorityWithOneOf | undefined;
}
export interface ValidationPolicy_Any {
}
export interface ValidationPolicy_Majority {
}
export interface ValidationPolicy_MajorityWithOneOf {
    addresses?: Uint8Array[];
}
export declare const ValidationPolicy: {
    encode(message: ValidationPolicy, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): ValidationPolicy;
    fromJSON(object: any): ValidationPolicy;
    toJSON(message: ValidationPolicy): unknown;
    fromPartial(object: DeepPartial<ValidationPolicy>): ValidationPolicy;
};
export declare const ValidationPolicy_Any: {
    encode(_: ValidationPolicy_Any, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): ValidationPolicy_Any;
    fromJSON(_: any): ValidationPolicy_Any;
    toJSON(_: ValidationPolicy_Any): unknown;
    fromPartial(_: DeepPartial<ValidationPolicy_Any>): ValidationPolicy_Any;
};
export declare const ValidationPolicy_Majority: {
    encode(_: ValidationPolicy_Majority, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): ValidationPolicy_Majority;
    fromJSON(_: any): ValidationPolicy_Majority;
    toJSON(_: ValidationPolicy_Majority): unknown;
    fromPartial(_: DeepPartial<ValidationPolicy_Majority>): ValidationPolicy_Majority;
};
export declare const ValidationPolicy_MajorityWithOneOf: {
    encode(message: ValidationPolicy_MajorityWithOneOf, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): ValidationPolicy_MajorityWithOneOf;
    fromJSON(object: any): ValidationPolicy_MajorityWithOneOf;
    toJSON(message: ValidationPolicy_MajorityWithOneOf): unknown;
    fromPartial(object: DeepPartial<ValidationPolicy_MajorityWithOneOf>): ValidationPolicy_MajorityWithOneOf;
};
declare type Builtin = Date | Function | Uint8Array | string | number | boolean | undefined;
export declare type DeepPartial<T> = T extends Builtin ? T : T extends Long ? string | number | Long : T extends Array<infer U> ? Array<DeepPartial<U>> : T extends ReadonlyArray<infer U> ? ReadonlyArray<DeepPartial<U>> : T extends {} ? {
    [K in keyof T]?: DeepPartial<T[K]>;
} : Partial<T>;
export {};
